import { openBlock as C, createElementBlock as S, Fragment as de, renderList as pe, normalizeClass as $, createBlock as Et, resolveDynamicComponent as Wt, mergeProps as bt, createElementVNode as k, createCommentVNode as M, createTextVNode as Ut, resolveComponent as Xe, toDisplayString as me, createVNode as we, renderSlot as Qe, withDirectives as Ve, vShow as Ai, pushScopeId as Ii, popScopeId as Ri, vModelSelect as fn, vModelText as Vi, normalizeProps as He, vModelDynamic as os, guardReactiveProps as ze, vModelRadio as ls, vModelCheckbox as us, getCurrentInstance as zi, inject as cs, markRaw as yt, ref as Wi, watch as fs, reactive as ds, effectScope as hs, isRef as Gt, isReactive as In, toRef as jn, toRaw as ps, nextTick as Pi, computed as Ui, onUnmounted as gs, toRefs as qi, withCtx as $i } from "vue";
const ys = {
  props: {
    only: {
      type: Array,
      required: !1
    },
    except: {
      type: Array,
      required: !1
    },
    orderByOnly: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  methods: {
    subset(r) {
      if (this.only || this.except) {
        let f = Object.keys(r).filter(
          (c) => this.only ? this.only.includes(c) : !this.except.includes(c)
        ).reduce((c, _) => (c[_] = r[_], c), {});
        if (this.orderByOnly && !this.except) {
          let c = {};
          this.only.forEach((_) => {
            c[_] = f[_];
          }), f = c;
        }
        return f;
      }
      return r;
    }
  }
}, Gi = {
  mixins: [ys],
  props: {
    columns: {
      type: Number,
      required: !1,
      default: 1,
      validator: function(r) {
        return 12 % r === 0;
      }
    },
    spread: {
      type: Boolean,
      required: !1,
      default: !0
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    colClass: {
      type: String,
      required: !1,
      default: null
    },
    componentClass: {
      type: String,
      required: !1,
      default: null
    }
  },
  methods: {
    rows(r) {
      const f = this.subset(r), c = Object.keys(f), _ = c.length, A = Math.ceil(_ / this.columns);
      let N = [...Array(A).keys()];
      for (const w in N) {
        let T = [];
        for (let B = w * this.columns; B <= w * this.columns + (this.columns - 1); B++)
          if (c[B]) {
            const H = { ...f[c[B]] };
            H.key = c[B], T.push(H);
          }
        N[w] = T;
      }
      return N;
    },
    colSize(r) {
      let f = 12 / this.columns;
      return r.length < this.columns && this.spread && (f = Math.floor(12 / r.length)), f;
    }
  }
}, Ye = {
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(r) {
        return ["horizontal", "vertical", "none"].includes(r);
      }
    },
    labelColumnSize: {
      type: Number,
      required: !1,
      default: 6,
      validator: function(r) {
        return r < 12;
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    helperText: {
      type: String,
      required: !1,
      default: ""
    },
    helperTextClass: {
      type: String,
      required: !1,
      default: ""
    }
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(r) {
        this.setFilterLoadData(this.filter.key, r);
      }
    }
  },
  methods: {
    setFilterLoadData(r, f) {
      this.setFilter(r, f), !this.synchronous && this.pageDefinition.retrieveData && this.loadData();
    }
  }
};
const ke = (r, f) => {
  const c = r.__vccOpts || r;
  for (const [_, A] of f)
    c[_] = A;
  return c;
}, bs = {
  name: "FilterGrid",
  mixins: [Gi, Ye],
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(r) {
        return ["horizontal", "vertical", "none"].includes(r);
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    clearButton: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(r) {
        return ["left", "center", "right", "none"].includes(r);
      }
    }
  },
  methods: {
    initializeDefaultsLoadData() {
      this.INITIALIZE_DEFAULTS(
        this.subset(this.filters) ? Object.keys(this.subset(this.filters)) : null
      ), !this.synchronous && this.pageDefinition.retrieveData && this.LOAD_DATA();
    }
  }
}, vs = ["id"], ms = {
  key: 0,
  class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow"
}, ks = /* @__PURE__ */ Ut(" \xA0 ");
function ws(r, f, c, _, A, N) {
  return C(), S("div", null, [
    (C(!0), S(de, null, pe(r.rows(this.filters), (w, T) => (C(), S("div", {
      class: $("row harness-ui-filtergrid-row " + r.rowClass),
      key: T
    }, [
      (C(!0), S(de, null, pe(w, (B, H) => (C(), S("div", {
        class: $(
          "harness-ui-filtergrid-col col-sm-" + 12 / r.columns + " " + r.colClass
        ),
        key: r.pageDefinition.key + "-" + H,
        id: B.key + "-col"
      }, [
        (C(), Et(Wt(B.component), bt({ filter: B, ...B.props, ...r.$props, ...r.$attrs }, {
          key: r.pageDefinition.key + "-filtergrid-" + B.key,
          class: r.componentClass
        }), null, 16, ["class"]))
      ], 10, vs))), 128))
    ], 2))), 128)),
    (c.synchronous || c.clearButton) && c.buttonPosition !== "none" ? (C(), S("div", ms, [
      k("div", {
        class: $("col-md-12 text-" + c.buttonPosition)
      }, [
        c.synchronous ? (C(), S("button", {
          key: 0,
          class: "btn btn-primary btn-sm harness-ui-filtergrid-applybutton",
          onClick: f[0] || (f[0] = (...w) => r.LOAD_DATA && r.LOAD_DATA(...w)),
          role: "button"
        }, " Apply Filters ")) : M("", !0),
        ks,
        c.clearButton ? (C(), S("button", {
          key: 1,
          role: "button",
          class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
          onClick: f[1] || (f[1] = (...w) => N.initializeDefaultsLoadData && N.initializeDefaultsLoadData(...w))
        }, " Clear Filters ")) : M("", !0)
      ], 2)
    ])) : M("", !0)
  ]);
}
const Ts = /* @__PURE__ */ ke(bs, [["render", ws], ["__scopeId", "data-v-ba380453"]]), Cs = {
  name: "ChartGrid",
  mixins: [Gi],
  computed: {
    chartRows() {
      return this.rows(this.charts);
    }
  }
};
function Ss(r, f, c, _, A, N) {
  return C(), S("div", null, [
    (C(!0), S(de, null, pe(N.chartRows, (w, T) => (C(), S("div", {
      class: $("row harness-ui-chartgrid-row " + r.rowClass),
      key: T
    }, [
      (C(!0), S(de, null, pe(w, (B, H) => (C(), S("div", {
        class: $("col-md-" + r.colSize(w) + " " + r.colClass),
        key: H
      }, [
        (C(), Et(Wt(B.component), bt({ chart: B, ...B.props, ...r.$props, ...r.$attrs }, {
          key: r.pageDefinition.key + "-chartgrid-" + B.key,
          class: r.componentClass
        }), null, 16, ["class"]))
      ], 2))), 128))
    ], 2))), 128))
  ]);
}
const _s = /* @__PURE__ */ ke(Cs, [["render", Ss]]), Ds = {
  name: "GridWithFilters",
  props: ["columns"]
}, Es = { class: "display-4" }, Ns = { class: "row" }, xs = { class: "col-md-12" }, Ls = { class: "card" }, Os = /* @__PURE__ */ k("div", { class: "card-header" }, "Filters", -1), As = { class: "card-body" };
function Ps(r, f, c, _, A, N) {
  const w = Xe("FilterGrid"), T = Xe("ChartGrid");
  return C(), S("div", null, [
    k("h1", Es, me(r.page.title), 1),
    k("div", Ns, [
      k("div", xs, [
        k("div", Ls, [
          Os,
          k("div", As, [
            we(w)
          ])
        ])
      ])
    ]),
    we(T, { columns: c.columns }, null, 8, ["columns"])
  ]);
}
const qs = /* @__PURE__ */ ke(Ds, [["render", Ps]]), Qi = {
  props: {
    chart: {
      type: Object,
      required: !0
    },
    tableClass: {
      type: String,
      required: !1,
      default: null
    },
    headerClass: {
      type: String,
      required: !1,
      default: null
    },
    labelClass: {
      type: String,
      required: !1,
      default: null
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    cellClass: {
      type: String,
      required: !1,
      default: null
    },
    rowHeaderCol: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    validatedChartData() {
      return this.validateChartData(this.chartData, this.chart.key);
    }
  }
};
const $s = {
  name: "DataTable508",
  mixins: [Qi],
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    chartData() {
      let r = this.getChartData(this.chart.key) || null, f = this.getChartProps(this.chart.key).tableAdapter || null;
      if (r && f)
        try {
          return f(this.chart, this.filters, r);
        } catch (c) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(c)
          );
        }
      return r;
    }
  }
}, Hs = ["id"], js = ["innerHTML"], Fs = ["innerHTML"], Ms = ["innerHTML"];
function Bs(r, f, c, _, A, N) {
  return r.validatedChartData && r.validatedChartData.length ? (C(), S("div", {
    key: 0,
    id: r.chart.key + "_data_table",
    class: "harness-ui-datatable"
  }, [
    k("table", {
      class: $("harness-ui-table table " + r.tableClass)
    }, [
      k("thead", {
        class: $(r.headerClass)
      }, [
        k("tr", null, [
          (C(!0), S(de, null, pe(N.columnHeaders, (w, T) => (C(), S("th", {
            scope: "col",
            key: T,
            class: $(r.labelClass),
            innerHTML: w
          }, null, 10, js))), 128))
        ])
      ], 2),
      k("tbody", null, [
        (C(!0), S(de, null, pe(r.validatedChartData, (w, T) => (C(), S("tr", {
          key: T,
          class: $(r.rowClass)
        }, [
          (C(!0), S(de, null, pe(N.columnHeaders, (B, H) => (C(), S(de, null, [
            H === 0 && r.rowHeaderCol ? (C(), S("th", {
              key: H,
              class: $(r.cellClass),
              innerHTML: w[B],
              scope: "row"
            }, null, 10, Fs)) : (C(), S("td", {
              key: `${H}-else`,
              class: $(r.cellClass),
              innerHTML: w[B]
            }, null, 10, Ms))
          ], 64))), 256))
        ], 2))), 128))
      ])
    ], 2)
  ], 8, Hs)) : M("", !0);
}
const Is = /* @__PURE__ */ ke($s, [["render", Bs], ["__scopeId", "data-v-d0c810b3"]]);
const Rs = {
  name: "ChartWithTable",
  props: {
    chart: {
      type: Object,
      required: !0
    },
    chartComponent: {
      type: [Object, Function],
      required: !0
    },
    tableDisplay: {
      type: String,
      required: !1,
      default: "toggle"
    },
    scrollable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    downloadable: {
      type: Boolean,
      required: !1,
      default: !0
    },
    card: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "top"
    },
    saveImageButton: {
      type: Function,
      required: !1
    },
    collapsible: {
      type: Boolean,
      required: !1,
      default: !1
    },
    collapsibleFunc: {
      type: Function,
      required: !1,
      default: () => !0
    },
    startCollapsed: {
      type: Boolean,
      required: !1,
      default: !1
    },
    showTableButtonText: {
      type: String,
      required: !1,
      default: "Show Table"
    },
    showChartButtonText: {
      type: String,
      required: !1,
      default: "Show Chart"
    }
  },
  data: function() {
    return {
      view: "chart",
      chartReady: !1,
      collapsed: this.startCollapsed
    };
  },
  methods: {
    toggleView() {
      switch (this.view) {
        case "chart":
          this.view = "table";
          break;
        case "table":
          this.view = "chart";
          break;
      }
      this.$emit("view", this.view);
    },
    toggleCollapse() {
      this.collapsed = !this.collapsed, this.$emit("collapsed", this.collapsed), this.collapsibleFunc();
    }
  },
  computed: {
    labels() {
      let r = {};
      return this.$attrs.tableColumns && this.$attrs.tableColumnLabels ? (r.tableColumns = this.$attrs.tableColumns, r.tableColumnLabels = this.$attrs.tableColumnLabels) : this.getChartProps(this.chart.key).tableColumns && this.getChartProps(this.chart.key).tableColumnLabels && (r.tableColumns = this.getChartProps(this.chart.key).tableColumns, r.tableColumnLabels = this.getChartProps(
        this.chart.key
      ).tableColumnLabels), r;
    },
    scroll() {
      return this.scrollable ? "height:" + this.getChartProps(this.chart.key).height + "px;overflow-y:auto;" : "";
    }
  }
}, Vs = (r) => (Ii("data-v-5ccab39d"), r = r(), Ri(), r), zs = ["id"], Ws = { class: "row" }, Us = { class: "harness-ui-chartwithtable-title" }, Gs = ["aria-controls"], Qs = { class: "harness-ui-chartwithtable-subtitle" }, Xs = {
  key: 0,
  class: "col-md-6"
}, Ys = {
  id: "button-container",
  class: "float-right"
}, Js = ["aria-label"], Ks = ["innerHTML"], Zs = ["aria-label"], ea = ["innerHTML"], ta = ["aria-label"], na = ["aria-label"], ia = ["id"], ra = { class: "harness-ui-chartwithtable-abovechart" }, sa = /* @__PURE__ */ Vs(() => /* @__PURE__ */ k("br", null, null, -1)), aa = { class: "harness-ui-chartwithtable-belowchart" }, oa = ["id"], la = {
  id: "button-container",
  class: "float-right"
}, ua = ["aria-label"], ca = ["innerHTML"], fa = ["aria-label"], da = ["innerHTML"], ha = { key: 2 }, pa = ["aria-label"], ga = { key: 3 }, ya = ["aria-label"];
function ba(r, f, c, _, A, N) {
  const w = Xe("DataTable508");
  return C(), S("div", {
    id: c.chart.key + "_container",
    class: $((c.card ? "card" : "") + " harness-ui-chartwithtable")
  }, [
    k("div", {
      class: $(c.card ? "card-header" : "")
    }, [
      k("div", Ws, [
        k("div", {
          class: $(c.buttonPosition === "top" ? "col-md-6" : "col-md-12")
        }, [
          k("h3", {
            class: $(c.card ? "card-title" : "")
          }, [
            k("div", Us, [
              k("div", null, [
                Qe(r.$slots, "title", {
                  innerHTML: c.chart.title
                }, void 0, !0),
                c.collapsible ? (C(), S("button", {
                  key: 0,
                  id: "collapseButton",
                  "data-toggle": "collapse",
                  "aria-expanded": "false",
                  "aria-controls": c.chart.key + "ChartTableBody " + c.chart.key + "Buttons",
                  onClick: f[0] || (f[0] = (...T) => N.toggleCollapse && N.toggleCollapse(...T)),
                  "aria-label": "Toggle Chart"
                }, me(r.collapsed ? "+" : "-"), 9, Gs)) : M("", !0)
              ]),
              k("div", Qs, [
                Qe(r.$slots, "subtitle", {}, void 0, !0)
              ])
            ])
          ], 2)
        ], 2),
        c.buttonPosition === "top" ? (C(), S("div", Xs, [
          k("h3", {
            class: $(
              "harness-ui-chartwithtable-buttonrow" + (c.card ? " card-title" : "")
            )
          }, [
            k("span", Ys, [
              c.tableDisplay == "toggle" && r.view == "chart" ? (C(), S("button", {
                key: 0,
                role: "button",
                "aria-label": "Show Table: " + (c.chart.title || c.chart.key),
                onClick: f[1] || (f[1] = (...T) => N.toggleView && N.toggleView(...T)),
                class: "btn btn-sm btn-primary harness-ui-togglebutton"
              }, [
                k("span", { innerHTML: c.showTableButtonText }, null, 8, Ks)
              ], 8, Js)) : M("", !0),
              c.tableDisplay == "toggle" && r.view == "table" ? (C(), S("button", {
                key: 1,
                role: "button",
                "aria-label": "Show Chart: " + (c.chart.title || c.chart.key),
                onClick: f[2] || (f[2] = (...T) => N.toggleView && N.toggleView(...T)),
                class: "btn btn-sm btn-primary harness-ui-togglebutton"
              }, [
                k("span", { innerHTML: c.showChartButtonText }, null, 8, ea)
              ], 8, Zs)) : M("", !0),
              c.downloadable && r.getChartData(c.chart.key) ? (C(), S("button", {
                key: 2,
                role: "button",
                "aria-label": "Download Table: " + (c.chart.title || c.chart.key),
                onClick: f[3] || (f[3] = (T) => r.downloadCSV(c.chart.key)),
                class: "btn btn-sm btn-primary harness-ui-downloadbutton"
              }, " Download CSV ", 8, ta)) : M("", !0),
              c.saveImageButton && r.getChartData(c.chart.key) ? (C(), S("button", {
                key: 3,
                role: "button",
                "aria-label": "Download Table: " + (c.chart.title || c.chart.key),
                onClick: f[4] || (f[4] = (T) => c.saveImageButton()),
                class: "btn btn-sm btn-primary harness-ui-downloadbutton"
              }, " Save Image ", 8, na)) : M("", !0),
              Qe(r.$slots, "additional-buttons", {}, void 0, !0)
            ])
          ], 2)
        ])) : M("", !0)
      ])
    ], 2),
    k("div", {
      id: c.chart.key + "ChartTableBody",
      class: $(
        "card-body harness-ui-chartwithtable-body" + (c.collapsible ? " " + c.chart.key + "-multi-collapse" : "") + (r.collapsed ? " collapse" : " show")
      )
    }, [
      k("div", ra, [
        Qe(r.$slots, "above-chart", {}, void 0, !0)
      ]),
      Ve((C(), Et(Wt(c.chartComponent), bt({ chart: c.chart, ...c.chart.props, ...r.$attrs }, {
        key: "chartwithtable" + c.chart.key + "chart"
      }), null, 16)), [
        [Ai, c.tableDisplay != "toggle" || r.view == "chart"]
      ]),
      sa,
      k("div", aa, [
        Qe(r.$slots, "below-chart", {}, void 0, !0)
      ]),
      Ve((C(), Et(w, bt({ chart: c.chart, ...c.chart.props, ...r.$attrs }, {
        key: "chartwithtable" + c.chart.key + "table",
        style: N.scroll
      }), null, 16, ["style"])), [
        [Ai, c.tableDisplay != "toggle" || r.view == "table"]
      ])
    ], 10, ia),
    c.buttonPosition === "bottom" ? (C(), S("h3", {
      key: 0,
      id: c.chart.key + "Buttons",
      class: $(
        "harness-ui-chartwithtable-buttonrow" + (c.collapsible ? " " + c.chart.key + "-multi-collapse" : "") + (r.collapsed ? " collapse" : " show") + (c.card ? " card-title" : "")
      )
    }, [
      k("span", la, [
        c.tableDisplay == "toggle" && r.view == "chart" ? (C(), S("button", {
          key: 0,
          role: "button",
          "aria-label": "Show Table: " + (c.chart.title || c.chart.key),
          onClick: f[5] || (f[5] = (...T) => N.toggleView && N.toggleView(...T)),
          class: "btn btn-sm btn-primary harness-ui-togglebutton"
        }, [
          k("span", { innerHTML: c.showTableButtonText }, null, 8, ca)
        ], 8, ua)) : M("", !0),
        c.tableDisplay == "toggle" && r.view == "table" ? (C(), S("button", {
          key: 1,
          role: "button",
          "aria-label": "Show Chart: " + (c.chart.title || c.chart.key),
          onClick: f[6] || (f[6] = (...T) => N.toggleView && N.toggleView(...T)),
          class: "btn btn-sm btn-primary harness-ui-togglebutton"
        }, [
          k("span", { innerHTML: c.showChartButtonText }, null, 8, da)
        ], 8, fa)) : M("", !0),
        c.downloadable && r.getChartData(c.chart.key) ? (C(), S("span", ha, [
          k("button", {
            role: "button",
            "aria-label": "Download Table: " + (c.chart.title || c.chart.key),
            onClick: f[7] || (f[7] = (T) => r.downloadCSV(c.chart.key, N.labels || null)),
            class: "btn btn-sm btn-primary harness-ui-downloadbutton"
          }, " Download CSV ", 8, pa)
        ])) : M("", !0),
        c.saveImageButton && r.getChartData(c.chart.key) ? (C(), S("span", ga, [
          c.saveImageButton ? (C(), S("button", {
            key: 0,
            role: "button",
            "aria-label": "Download Image: " + (c.chart.title || c.chart.key),
            onClick: f[8] || (f[8] = (T) => c.saveImageButton()),
            class: "btn btn-sm btn-primary harness-ui-downloadbutton"
          }, " Save Image ", 8, ya)) : M("", !0)
        ])) : M("", !0),
        Qe(r.$slots, "additional-buttons", {}, void 0, !0)
      ])
    ], 10, oa)) : M("", !0)
  ], 10, zs);
}
const va = /* @__PURE__ */ ke(Rs, [["render", ba], ["__scopeId", "data-v-5ccab39d"]]);
const ma = {
  name: "InteractiveTable",
  mixins: [Qi],
  props: {
    local: {
      type: Object,
      required: !1,
      default: () => {
      }
    },
    numRowOptions: {
      type: Array,
      required: !0
    },
    defaultSortColumn: {
      type: String,
      required: !0
    },
    defaultSortOrder: {
      type: String,
      required: !1,
      default: "asc",
      validator: function(r) {
        return ["asc", "desc"].includes(r);
      }
    },
    numPaginationOptions: {
      type: Number,
      required: !1,
      default: 5
    }
  },
  data() {
    return {
      sortedDescending: this.defaultSortOrder === "desc",
      pageNumber: 1,
      searchQuery: "",
      columnSelector: this.defaultSortColumn,
      columnSort: this.defaultSortOrder,
      paginationAmount: 5
    };
  },
  methods: {
    setColumnFilter(r) {
      r === this.columnSelector && (this.sortedDescending = !this.sortedDescending), this.columnSelector = r, this.columnSort = this.sortedDescending ? "desc" : "asc", this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", [
        {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.sortedDescending ? "desc" : "asc",
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }
      ]), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
    },
    setPageNum(r) {
      this.pageNumber = r, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
        pageNumber: this.pageNumber,
        searchQuery: this.searchQuery,
        columnSelector: this.columnSelector,
        columnSort: this.columnSort,
        paginationAmount: this.paginationAmount,
        numberOfPages: this.numberOfPages
      }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
    },
    isActiveAndDescending(r) {
      return this.columnSort === "desc" && this.columnSelector === r;
    },
    isActiveAndAscending(r) {
      return this.columnSort === "asc" && this.columnSelector === r;
    }
  },
  computed: {
    tableOptions() {
      let r = [];
      return Object.keys(this.filters).includes(this.chart.key + "TableOptions") && (r = this.getOptionsForFilter(this.chart.key + "TableOptions")), r;
    },
    tableAdaptedData() {
      let r = this.getChartData(this.chart.key) || null, f = this.getChartProps(this.chart.key).tableAdapter || null;
      if (r && f)
        try {
          r = f(this.chart, this.filters, r);
        } catch (c) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(c)
          );
        }
      return r;
    },
    chartData() {
      let r = this.tableAdaptedData;
      if (r) {
        if (this.isSearchable && (r = r.filter((f) => Object.values(f).reduce((c, _) => c || (_ ? _.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1))), this.isSortable && (this.columnSort === "asc" ? r = r.sort((f, c) => f[this.columnSelector].toString().localeCompare(c[this.columnSelector], "en", {
          sensitivity: "base"
        })) : this.columnSort === "desc" && (r = r.sort((f, c) => c[this.columnSelector].toString().localeCompare(f[this.columnSelector], "en", {
          sensitivity: "base"
        })))), this.isPaginated) {
          let f = this.pageNumber, c = r.length, _ = parseInt(this.paginationAmount), A = f * _ > c ? c : f * _, N = (f - 1) * _;
          r = r.slice(N, A);
        }
        return r;
      }
      return r;
    },
    isSearchable() {
      return this.local ? !this.local.hasOwnProperty("search") || this.local.hasOwnProperty("search") && this.local.search !== !1 : !0;
    },
    isSortable() {
      return this.local ? !this.local.hasOwnProperty("sort") || this.local.hasOwnProperty("sort") && this.local.sort !== !1 : !0;
    },
    isPaginated() {
      return this.local ? !this.local.hasOwnProperty("paginate") || this.local.hasOwnProperty("paginate") && this.local.paginate !== !1 : !0;
    },
    numberOfPages() {
      let r = this.tableAdaptedData;
      r && (r = r.filter((N) => Object.values(N).reduce((w, T) => w || (T ? T.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1)));
      let f = [1], c = parseInt(this.paginationAmount), _ = this.validateChartData(r, this.chart.key) ? this.validateChartData(r, this.chart.key).length : 0, A = Math.ceil(_ / c);
      for (let N = 2; N <= A; N++)
        f.push(N);
      return f;
    },
    searchText: {
      get() {
        return this.searchQuery;
      },
      set(r) {
        this.searchQuery = r, this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.columnSort,
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
      }
    },
    paginationOptions() {
      return this.pageNumber <= this.numPaginationOptions ? this.numberOfPages.slice(0, this.numPaginationOptions) : this.numberOfPages.slice(
        this.pageNumber - this.numPaginationOptions,
        this.pageNumber
      );
    }
  },
  beforeUpdate() {
    this.pageNumber > this.numberOfPages.length && (this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
      pageNumber: this.pageNumber,
      searchQuery: this.searchQuery,
      columnSelector: this.columnSelector,
      columnSort: this.columnSort,
      paginationAmount: this.paginationAmount,
      numberOfPages: this.numberOfPages
    }), this.LOAD_DATA());
  }
}, hn = (r) => (Ii("data-v-0ad4c383"), r = r(), Ri(), r), ka = { class: "row py-2" }, wa = { class: "col-sm-3" }, Ta = { class: "row form-row" }, Ca = { class: "offset-1 col-4" }, Sa = ["id"], _a = ["value"], Da = { class: "col-sm-4 offset-sm-5 text-right" }, Ea = { class: "row form-row" }, Na = { class: "offset-4 col-8 pr-4" }, xa = ["id"], La = ["id"], Oa = ["onClick"], Aa = { class: "harness-ui-interactivetable-column-header" }, Pa = {
  key: 0,
  class: /* @__PURE__ */ $(["activeCol"])
}, qa = {
  key: 1,
  class: /* @__PURE__ */ $(["activeCol"])
}, $a = ["innerHTML"], Ha = ["innerHTML"], ja = { class: "row justify-content-center" }, Fa = { class: "col-md-2 text-center" }, Ma = {
  "aria-label": "Table pagination navigation",
  class: "navigation text-center harness-ui-interactivetable-pagination-navigation"
}, Ba = { class: "pagination harness-ui-interactivetable-pagination" }, Ia = /* @__PURE__ */ hn(() => /* @__PURE__ */ k("i", { class: "bi-chevron-double-left" }, null, -1)), Ra = [
  Ia
], Va = /* @__PURE__ */ hn(() => /* @__PURE__ */ k("i", { class: "bi-chevron-left" }, null, -1)), za = [
  Va
], Wa = ["onClick"], Ua = /* @__PURE__ */ hn(() => /* @__PURE__ */ k("i", { class: "bi-chevron-right" }, null, -1)), Ga = [
  Ua
], Qa = /* @__PURE__ */ hn(() => /* @__PURE__ */ k("i", { class: "bi-chevron-double-right" }, null, -1)), Xa = [
  Qa
];
function Ya(r, f, c, _, A, N) {
  return C(), S("div", null, [
    k("div", null, [
      k("div", ka, [
        k("div", wa, [
          k("div", Ta, [
            k("div", Ca, [
              Ve(k("select", {
                class: "form-control harness-ui-interactivetable-select",
                id: r.chart.key + "NumRowsSelect",
                "aria-label": "Amount of rows to paginate by",
                "onUpdate:modelValue": f[0] || (f[0] = (w) => A.paginationAmount = w)
              }, [
                (C(!0), S(de, null, pe(c.numRowOptions, (w) => (C(), S("option", {
                  key: w,
                  value: w
                }, me(w), 9, _a))), 128))
              ], 8, Sa), [
                [fn, A.paginationAmount]
              ])
            ])
          ])
        ]),
        k("div", Da, [
          k("div", Ea, [
            k("div", Na, [
              Ve(k("input", {
                type: "text",
                class: "form-control harness-ui-interactivetable-text-input",
                id: r.chart.key + "SearchQueryInput",
                "aria-label": "Table search",
                "onUpdate:modelValue": f[1] || (f[1] = (w) => N.searchText = w),
                placeholder: "Search..."
              }, null, 8, xa), [
                [Vi, N.searchText]
              ])
            ])
          ])
        ])
      ]),
      r.validatedChartData && r.validatedChartData.length ? (C(), S("div", {
        key: 0,
        id: r.chart.key + "_data_table",
        class: "harness-ui-interactivetable-datatable"
      }, [
        k("table", {
          class: $("harness-ui-interactivetable-table table " + r.tableClass)
        }, [
          k("thead", {
            class: $(r.headerClass)
          }, [
            k("tr", null, [
              (C(!0), S(de, null, pe(r.columnHeaders, (w, T) => (C(), S("th", {
                scope: "col",
                key: T,
                class: $("table-header " + r.labelClass),
                onClick: (B) => N.setColumnFilter(w)
              }, [
                k("button", Aa, me(w), 1),
                N.isActiveAndDescending(w) ? (C(), S("span", Pa, "\u25BC")) : M("", !0),
                N.isActiveAndAscending(w) ? (C(), S("span", qa, "\u25B2")) : M("", !0)
              ], 10, Oa))), 128))
            ])
          ], 2),
          k("tbody", null, [
            (C(!0), S(de, null, pe(r.validatedChartData, (w, T) => (C(), S("tr", {
              key: T,
              class: $(r.rowClass)
            }, [
              (C(!0), S(de, null, pe(r.columnHeaders, (B, H) => (C(), S(de, null, [
                H === 0 && r.rowHeaderCol ? (C(), S("th", {
                  key: H,
                  class: $(r.cellClass),
                  innerHTML: w[B],
                  scope: "row"
                }, null, 10, $a)) : (C(), S("td", {
                  key: `${H}-else`,
                  class: $(r.cellClass),
                  innerHTML: w[B]
                }, null, 10, Ha))
              ], 64))), 256))
            ], 2))), 128))
          ])
        ], 2)
      ], 8, La)) : M("", !0)
    ]),
    k("div", ja, [
      k("div", Fa, [
        k("nav", Ma, [
          k("ul", Ba, [
            k("li", {
              class: $(`page-link ${A.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: f[2] || (f[2] = (w) => N.setPageNum(1))
            }, Ra, 2),
            k("li", {
              class: $(`page-link ${A.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: f[3] || (f[3] = (w) => A.pageNumber != 1 ? N.setPageNum(A.pageNumber - 1) : "")
            }, za, 2),
            (C(!0), S(de, null, pe(N.paginationOptions, (w) => (C(), S("li", {
              key: w,
              class: $([
                "page-item",
                "harness-ui-interactivetable-pagination-pageitem",
                w === A.pageNumber ? " active" : ""
              ])
            }, [
              k("button", {
                class: $("page-link"),
                onClick: (T) => N.setPageNum(w)
              }, me(w), 9, Wa)
            ], 2))), 128)),
            k("li", {
              class: $(`page-link ${A.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: f[4] || (f[4] = (w) => A.pageNumber < N.numberOfPages.length ? N.setPageNum(A.pageNumber + 1) : "")
            }, Ga, 2),
            k("li", {
              class: $(`page-link ${A.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: f[5] || (f[5] = (w) => N.setPageNum(N.numberOfPages.length))
            }, Xa, 2)
          ])
        ])
      ])
    ])
  ]);
}
const Ja = /* @__PURE__ */ ke(ma, [["render", Ya], ["__scopeId", "data-v-0ad4c383"]]), Ka = {
  name: "filter-picker",
  props: {
    validFilters: {
      required: !0,
      type: Array
    },
    removeButtonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(r) {
        return ["left", "center", "right"].includes(r);
      }
    },
    columnSize: {
      type: Number,
      required: !1,
      default: 12,
      validator: function(r) {
        return 12 % r === 0;
      }
    }
  },
  data() {
    return {
      active: []
    };
  },
  computed: {
    inactive() {
      return this.validFilters.filter(
        function(r) {
          return !this.active.includes(r);
        }.bind(this)
      );
    }
  },
  methods: {
    addFilter(r) {
      r.target.value && this.active.push(r.target.value);
    },
    removeFilter(r) {
      r.target.value && (this.active = this.active.filter((f) => f !== r.target.value), this.setFilter(
        r.target.value,
        this.getFilterDefault(r.target.value)
      ), this.loadData());
    }
  }
}, Za = { class: "harness-ui-filterpicker" }, eo = { class: "row" }, to = { class: "row harness-ui-filtergrid-row" }, no = { class: "col" }, io = /* @__PURE__ */ Ut("Add Filter"), ro = /* @__PURE__ */ k("option", null, null, -1), so = ["value"], ao = { class: "col" }, oo = /* @__PURE__ */ Ut("Remove Filter"), lo = /* @__PURE__ */ k("option", null, null, -1), uo = ["value"], co = { class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow pt-3" }, fo = /* @__PURE__ */ k("hr", null, null, -1);
function ho(r, f, c, _, A, N) {
  const w = Xe("FilterGrid");
  return C(), S("div", Za, [
    k("div", eo, [
      k("div", {
        class: $("col-" + c.columnSize)
      }, [
        k("div", to, [
          k("div", no, [
            Qe(r.$slots, "default", { class: "harness-ui-filterpicker-label" }, () => [
              io
            ]),
            k("select", {
              class: "form-control harness-ui-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: f[0] || (f[0] = (...T) => N.addFilter && N.addFilter(...T))
            }, [
              ro,
              (C(!0), S(de, null, pe(N.inactive, (T) => (C(), S("option", {
                key: T,
                value: T
              }, me(r.getLabel(T)), 9, so))), 128))
            ], 32)
          ]),
          k("div", ao, [
            Qe(r.$slots, "default", { class: "harness-ui-filterpicker-label" }, () => [
              oo
            ]),
            k("select", {
              class: "form-control harness-ui-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: f[1] || (f[1] = (...T) => N.removeFilter && N.removeFilter(...T))
            }, [
              lo,
              (C(!0), S(de, null, pe(A.active, (T) => (C(), S("option", {
                key: T,
                value: T
              }, me(r.getLabel(T)), 9, uo))), 128))
            ], 32)
          ])
        ]),
        k("div", co, [
          k("div", {
            class: $("col-md-12 text-" + c.removeButtonPosition)
          }, [
            k("button", {
              role: "button",
              class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
              onClick: f[2] || (f[2] = (T) => {
                A.active = [], r.initializeDefaults(), r.loadData();
              })
            }, " Remove All Filters ")
          ], 2)
        ]),
        fo,
        we(w, bt({ only: A.active }, { ...r.$attrs }), null, 16, ["only"])
      ], 2)
    ])
  ]);
}
const po = /* @__PURE__ */ ke(Ka, [["render", ho]]), go = {
  name: "FiltersAccordion",
  props: {
    validFilters: {
      type: Array,
      required: !0
    },
    mappingFunction: {
      type: Function,
      required: !1
    },
    filterLayout: {
      type: Object,
      required: !1
    }
  },
  computed: {
    filterTypes() {
      return Object.keys(this.filters).reduce((r, f) => (f = this.filters[f], f.props && !r.includes(f.props.filterType) && f.props.filterType !== "internal" && f.props.filterType && r.push(f.props.filterType), r), []);
    }
  },
  methods: {
    subsetFiltersByType(r) {
      return Object.keys(this.filters).filter(
        function(f) {
          if (this.filters[f].props)
            return this.filters[f].props.filterType === r && this.validFilters.includes(f);
        }.bind(this)
      );
    },
    filterMapping(r) {
      return this.mappingFunction ? this.mappingFunction(r) : `${r.replace("_", " ")}s`;
    },
    toggle(r) {
      r.preventDefault();
      let f = r.target.id.split("-")[0], c = document.getElementById(f + "-icon");
      if (c.classList.contains("bi-caret-down-square"))
        c.classList.remove("bi-caret-down-square"), c.classList.add("bi-caret-up-square"), this.filterTypes.filter((_) => _ !== f).forEach((_) => {
          let A = document.getElementById(_ + "-icon");
          A.classList.contains("bi-caret-up-square") && (A.classList.remove("bi-caret-up-square"), A.classList.add("bi-caret-down-square"));
        });
      else if (c.classList.contains("bi-caret-up-square")) {
        let _ = document.getElementById(f + "-icon");
        _.classList.remove("bi-caret-up-square"), _.classList.add("bi-caret-down-square");
      }
    },
    dirtyFilterString(r) {
      return this.subsetFiltersByType(r).filter((f) => this.isFilterDirty(f)).map((f) => this.getLabel(f)).join(", ");
    },
    clearFilterTypeFilters(r) {
      let f = this.subsetFiltersByType(r);
      this.initializeDefaults(f), this.loadData();
    },
    filterGridLayout(r) {
      return this.filterLayout ? this.filterLayout[r] : {
        columns: 4,
        labelPosition: "vertical",
        spread: !0
      };
    }
  }
}, yo = { class: "row" }, bo = {
  class: "accordion col-12",
  id: "filters-accordion"
}, vo = ["id"], mo = ["id", "data-target"], ko = { class: "mb-0" }, wo = { class: "row" }, To = ["id"], Co = ["id"], So = ["id", "aria-controls"], _o = ["id"], Do = ["id"], Eo = ["id"], No = ["id"], xo = ["id", "aria-labelledby"], Lo = { class: "card-body" }, Oo = { class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow" }, Ao = { class: "col-md-12 text-center" }, Po = ["onClick"];
function qo(r, f, c, _, A, N) {
  const w = Xe("FilterGrid");
  return C(), S("div", yo, [
    k("div", bo, [
      (C(!0), S(de, null, pe(N.filterTypes, (T, B) => (C(), S("div", {
        class: "card",
        id: T + "-card",
        key: B
      }, [
        k("div", {
          class: "card-header",
          id: T + "-heading",
          onClick: f[2] || (f[2] = (...H) => N.toggle && N.toggle(...H)),
          "data-toggle": "collapse",
          "data-target": "#collapse-" + T
        }, [
          k("h2", ko, [
            k("div", wo, [
              k("div", {
                class: "col-6",
                id: T + "-col1"
              }, [
                k("i", {
                  class: $(
                    "bi bi-ui-checks " + (N.dirtyFilterString(T).length ? "active" : "")
                  ),
                  id: T + "-checks"
                }, null, 10, Co),
                k("button", {
                  class: "btn btn-link",
                  id: T + "-button",
                  type: "button",
                  "aria-expanded": "false",
                  "aria-controls": "collapse-" + T
                }, me(N.filterMapping(T)), 9, So),
                N.dirtyFilterString(T).length ? (C(), S("small", {
                  key: 0,
                  id: T + "-small"
                }, me(N.dirtyFilterString(T)), 9, _o)) : M("", !0)
              ], 8, To),
              k("div", {
                class: "col-6 text-right",
                id: T + "-col2"
              }, [
                k("button", {
                  class: "btn btn-link text-right",
                  id: T + "-collapsebutton",
                  onClick: f[1] || (f[1] = (...H) => N.toggle && N.toggle(...H))
                }, [
                  k("i", {
                    class: "bi bi-caret-down-square",
                    id: T + "-icon",
                    onClick: f[0] || (f[0] = (...H) => N.toggle && N.toggle(...H))
                  }, null, 8, No)
                ], 8, Eo)
              ], 8, Do)
            ])
          ])
        ], 8, mo),
        k("div", {
          id: "collapse-" + T,
          class: "collapse",
          "aria-labelledby": T + "-heading",
          "data-parent": "#filters-accordion"
        }, [
          k("div", Lo, [
            we(w, {
              columns: N.filterGridLayout(T).columns,
              "label-position": N.filterGridLayout(T).labelPosition,
              spread: N.filterGridLayout(T).spread,
              only: N.subsetFiltersByType(T),
              "clear-button": !1
            }, null, 8, ["columns", "label-position", "spread", "only"]),
            k("div", Oo, [
              k("div", Ao, [
                k("button", {
                  class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
                  role: "button",
                  onClick: (H) => N.clearFilterTypeFilters(T)
                }, " Clear Filters ", 8, Po)
              ])
            ])
          ])
        ], 8, xo)
      ], 8, vo))), 128))
    ])
  ]);
}
const $o = /* @__PURE__ */ ke(go, [["render", qo]]), nt = {
  props: {
    filter: {
      type: Object,
      required: !0,
      validator: function(r) {
        return Object.keys(r).includes("key");
      }
    }
  }
}, Ho = {
  name: "InputPartial",
  mixins: [Ye, nt],
  props: {
    type: {
      required: !0,
      type: String
    },
    strictError: {
      type: Boolean,
      required: !0
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    inputClearButton: {
      required: !1,
      type: Boolean,
      default: !1
    }
  },
  methods: {
    initDefault() {
      this.INITIALIZE_DEFAULTS([this.filter.key]), this.synchronous || this.loadData();
    }
  }
}, jo = { class: "input-group" }, Fo = {
  key: 1,
  class: "input-group-prepend"
}, Mo = ["innerHTML"], Bo = ["type", "placeholder", "id", "aria-labelledby"], Io = {
  key: 3,
  class: "input-group-append"
}, Ro = ["innerHTML"], Vo = /* @__PURE__ */ k("i", { class: "bi bi-x" }, null, -1), zo = [
  Vo
];
function Wo(r, f, c, _, A, N) {
  return C(), S("div", jo, [
    c.prependComponent ? (C(), Et(Wt(c.prependComponent), He(bt({ key: 0 }, { ...r.$props, ...r.$attrs, strictError: c.strictError })), null, 16)) : c.prependHTML ? (C(), S("div", Fo, [
      k("span", {
        class: "input-group-text",
        innerHTML: c.prependHTML
      }, null, 8, Mo)
    ])) : M("", !0),
    Ve(k("input", {
      type: c.type,
      class: $(`form-control harness-ui-${c.type}-input ${r.isFilterDirty(r.filter.key) ? "dirty-filter-input" : ""} ${c.strictError ? "typeahead-strict-error" : ""}`),
      placeholder: c.placeholder,
      "onUpdate:modelValue": f[0] || (f[0] = (w) => r.boundValue = w),
      id: `${r.filter.key}-${c.type}-input`,
      "aria-labelledby": `${r.filter.key}-label`
    }, null, 10, Bo), [
      [os, r.boundValue]
    ]),
    c.appendComponent ? (C(), Et(Wt(c.appendComponent), He(bt({ key: 2 }, { ...r.$props, ...r.$attrs, strictError: c.strictError })), null, 16)) : c.appendHTML || c.inputClearButton ? (C(), S("div", Io, [
      c.appendHTML ? (C(), S("span", {
        key: 0,
        class: "input-group-text",
        innerHTML: c.appendHTML
      }, null, 8, Ro)) : M("", !0),
      c.inputClearButton ? (C(), S("button", {
        key: 1,
        class: "btn btn-outline-secondary harness-ui-input-group-clear-button",
        onClick: f[1] || (f[1] = (w) => N.initDefault())
      }, zo)) : M("", !0)
    ])) : M("", !0)
  ]);
}
const Uo = /* @__PURE__ */ ke(Ho, [["render", Wo]]);
var Go = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Xi = { exports: {} };
/*!
 * jQuery JavaScript Library v3.6.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright OpenJS Foundation and other contributors
 * Released under the MIT license
 * https://jquery.org/license
 *
 * Date: 2022-08-26T17:52Z
 */
(function(r) {
  (function(f, c) {
    r.exports = f.document ? c(f, !0) : function(_) {
      if (!_.document)
        throw new Error("jQuery requires a window with a document");
      return c(_);
    };
  })(typeof window < "u" ? window : Go, function(f, c) {
    var _ = [], A = Object.getPrototypeOf, N = _.slice, w = _.flat ? function(e) {
      return _.flat.call(e);
    } : function(e) {
      return _.concat.apply([], e);
    }, T = _.push, B = _.indexOf, H = {}, Q = H.toString, se = H.hasOwnProperty, Z = se.toString, fe = Z.call(Object), te = {}, G = function(t) {
      return typeof t == "function" && typeof t.nodeType != "number" && typeof t.item != "function";
    }, Oe = function(t) {
      return t != null && t === t.window;
    }, K = f.document, st = {
      type: !0,
      src: !0,
      nonce: !0,
      noModule: !0
    };
    function We(e, t, n) {
      n = n || K;
      var i, a, o = n.createElement("script");
      if (o.text = e, t)
        for (i in st)
          a = t[i] || t.getAttribute && t.getAttribute(i), a && o.setAttribute(i, a);
      n.head.appendChild(o).parentNode.removeChild(o);
    }
    function Je(e) {
      return e == null ? e + "" : typeof e == "object" || typeof e == "function" ? H[Q.call(e)] || "object" : typeof e;
    }
    var at = "3.6.1", s = function(e, t) {
      return new s.fn.init(e, t);
    };
    s.fn = s.prototype = {
      jquery: at,
      constructor: s,
      length: 0,
      toArray: function() {
        return N.call(this);
      },
      get: function(e) {
        return e == null ? N.call(this) : e < 0 ? this[e + this.length] : this[e];
      },
      pushStack: function(e) {
        var t = s.merge(this.constructor(), e);
        return t.prevObject = this, t;
      },
      each: function(e) {
        return s.each(this, e);
      },
      map: function(e) {
        return this.pushStack(s.map(this, function(t, n) {
          return e.call(t, n, t);
        }));
      },
      slice: function() {
        return this.pushStack(N.apply(this, arguments));
      },
      first: function() {
        return this.eq(0);
      },
      last: function() {
        return this.eq(-1);
      },
      even: function() {
        return this.pushStack(s.grep(this, function(e, t) {
          return (t + 1) % 2;
        }));
      },
      odd: function() {
        return this.pushStack(s.grep(this, function(e, t) {
          return t % 2;
        }));
      },
      eq: function(e) {
        var t = this.length, n = +e + (e < 0 ? t : 0);
        return this.pushStack(n >= 0 && n < t ? [this[n]] : []);
      },
      end: function() {
        return this.prevObject || this.constructor();
      },
      push: T,
      sort: _.sort,
      splice: _.splice
    }, s.extend = s.fn.extend = function() {
      var e, t, n, i, a, o, l = arguments[0] || {}, p = 1, d = arguments.length, b = !1;
      for (typeof l == "boolean" && (b = l, l = arguments[p] || {}, p++), typeof l != "object" && !G(l) && (l = {}), p === d && (l = this, p--); p < d; p++)
        if ((e = arguments[p]) != null)
          for (t in e)
            i = e[t], !(t === "__proto__" || l === i) && (b && i && (s.isPlainObject(i) || (a = Array.isArray(i))) ? (n = l[t], a && !Array.isArray(n) ? o = [] : !a && !s.isPlainObject(n) ? o = {} : o = n, a = !1, l[t] = s.extend(b, o, i)) : i !== void 0 && (l[t] = i));
      return l;
    }, s.extend({
      expando: "jQuery" + (at + Math.random()).replace(/\D/g, ""),
      isReady: !0,
      error: function(e) {
        throw new Error(e);
      },
      noop: function() {
      },
      isPlainObject: function(e) {
        var t, n;
        return !e || Q.call(e) !== "[object Object]" ? !1 : (t = A(e), t ? (n = se.call(t, "constructor") && t.constructor, typeof n == "function" && Z.call(n) === fe) : !0);
      },
      isEmptyObject: function(e) {
        var t;
        for (t in e)
          return !1;
        return !0;
      },
      globalEval: function(e, t, n) {
        We(e, { nonce: t && t.nonce }, n);
      },
      each: function(e, t) {
        var n, i = 0;
        if (J(e))
          for (n = e.length; i < n && t.call(e[i], i, e[i]) !== !1; i++)
            ;
        else
          for (i in e)
            if (t.call(e[i], i, e[i]) === !1)
              break;
        return e;
      },
      makeArray: function(e, t) {
        var n = t || [];
        return e != null && (J(Object(e)) ? s.merge(
          n,
          typeof e == "string" ? [e] : e
        ) : T.call(n, e)), n;
      },
      inArray: function(e, t, n) {
        return t == null ? -1 : B.call(t, e, n);
      },
      merge: function(e, t) {
        for (var n = +t.length, i = 0, a = e.length; i < n; i++)
          e[a++] = t[i];
        return e.length = a, e;
      },
      grep: function(e, t, n) {
        for (var i, a = [], o = 0, l = e.length, p = !n; o < l; o++)
          i = !t(e[o], o), i !== p && a.push(e[o]);
        return a;
      },
      map: function(e, t, n) {
        var i, a, o = 0, l = [];
        if (J(e))
          for (i = e.length; o < i; o++)
            a = t(e[o], o, n), a != null && l.push(a);
        else
          for (o in e)
            a = t(e[o], o, n), a != null && l.push(a);
        return w(l);
      },
      guid: 1,
      support: te
    }), typeof Symbol == "function" && (s.fn[Symbol.iterator] = _[Symbol.iterator]), s.each(
      "Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),
      function(e, t) {
        H["[object " + t + "]"] = t.toLowerCase();
      }
    );
    function J(e) {
      var t = !!e && "length" in e && e.length, n = Je(e);
      return G(e) || Oe(e) ? !1 : n === "array" || t === 0 || typeof t == "number" && t > 0 && t - 1 in e;
    }
    var Te = function(e) {
      var t, n, i, a, o, l, p, d, b, m, L, v, D, j, Y, F, be, ye, Ae, oe = "sizzle" + 1 * new Date(), X = e.document, xe = 0, re = 0, ge = an(), jt = an(), nn = an(), Pe = an(), ft = function(u, h) {
        return u === h && (L = !0), 0;
      }, dt = {}.hasOwnProperty, Le = [], it = Le.pop, Fe = Le.push, rt = Le.push, Ci = Le.slice, ht = function(u, h) {
        for (var g = 0, E = u.length; g < E; g++)
          if (u[g] === h)
            return g;
        return -1;
      }, xn = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped", ae = "[\\x20\\t\\r\\n\\f]", pt = "(?:\\\\[\\da-fA-F]{1,6}" + ae + "?|\\\\[^\\r\\n\\f]|[\\w-]|[^\0-\\x7f])+", Si = "\\[" + ae + "*(" + pt + ")(?:" + ae + "*([*^$|!~]?=)" + ae + `*(?:'((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)"|(` + pt + "))|)" + ae + "*\\]", Ln = ":(" + pt + `)(?:\\((('((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)")|((?:\\\\.|[^\\\\()[\\]]|` + Si + ")*)|.*)\\)|)", Gr = new RegExp(ae + "+", "g"), rn = new RegExp("^" + ae + "+|((?:^|[^\\\\])(?:\\\\.)*)" + ae + "+$", "g"), Qr = new RegExp("^" + ae + "*," + ae + "*"), _i = new RegExp("^" + ae + "*([>+~]|" + ae + ")" + ae + "*"), Xr = new RegExp(ae + "|>"), Yr = new RegExp(Ln), Jr = new RegExp("^" + pt + "$"), sn = {
        ID: new RegExp("^#(" + pt + ")"),
        CLASS: new RegExp("^\\.(" + pt + ")"),
        TAG: new RegExp("^(" + pt + "|[*])"),
        ATTR: new RegExp("^" + Si),
        PSEUDO: new RegExp("^" + Ln),
        CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + ae + "*(even|odd|(([+-]|)(\\d*)n|)" + ae + "*(?:([+-]|)" + ae + "*(\\d+)|))" + ae + "*\\)|)", "i"),
        bool: new RegExp("^(?:" + xn + ")$", "i"),
        needsContext: new RegExp("^" + ae + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + ae + "*((?:-\\d)?\\d*)" + ae + "*\\)|)(?=[^-]|$)", "i")
      }, Kr = /HTML$/i, Zr = /^(?:input|select|textarea|button)$/i, es = /^h\d$/i, Ft = /^[^{]+\{\s*\[native \w/, ts = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, On = /[+~]/, et = new RegExp("\\\\[\\da-fA-F]{1,6}" + ae + "?|\\\\([^\\r\\n\\f])", "g"), tt = function(u, h) {
        var g = "0x" + u.slice(1) - 65536;
        return h || (g < 0 ? String.fromCharCode(g + 65536) : String.fromCharCode(g >> 10 | 55296, g & 1023 | 56320));
      }, Di = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g, Ei = function(u, h) {
        return h ? u === "\0" ? "\uFFFD" : u.slice(0, -1) + "\\" + u.charCodeAt(u.length - 1).toString(16) + " " : "\\" + u;
      }, Ni = function() {
        v();
      }, ns = ln(
        function(u) {
          return u.disabled === !0 && u.nodeName.toLowerCase() === "fieldset";
        },
        { dir: "parentNode", next: "legend" }
      );
      try {
        rt.apply(
          Le = Ci.call(X.childNodes),
          X.childNodes
        ), Le[X.childNodes.length].nodeType;
      } catch {
        rt = {
          apply: Le.length ? function(h, g) {
            Fe.apply(h, Ci.call(g));
          } : function(h, g) {
            for (var E = h.length, y = 0; h[E++] = g[y++]; )
              ;
            h.length = E - 1;
          }
        };
      }
      function ue(u, h, g, E) {
        var y, x, O, P, q, z, I, U = h && h.ownerDocument, ne = h ? h.nodeType : 9;
        if (g = g || [], typeof u != "string" || !u || ne !== 1 && ne !== 9 && ne !== 11)
          return g;
        if (!E && (v(h), h = h || D, Y)) {
          if (ne !== 11 && (q = ts.exec(u)))
            if (y = q[1]) {
              if (ne === 9)
                if (O = h.getElementById(y)) {
                  if (O.id === y)
                    return g.push(O), g;
                } else
                  return g;
              else if (U && (O = U.getElementById(y)) && Ae(h, O) && O.id === y)
                return g.push(O), g;
            } else {
              if (q[2])
                return rt.apply(g, h.getElementsByTagName(u)), g;
              if ((y = q[3]) && n.getElementsByClassName && h.getElementsByClassName)
                return rt.apply(g, h.getElementsByClassName(y)), g;
            }
          if (n.qsa && !Pe[u + " "] && (!F || !F.test(u)) && (ne !== 1 || h.nodeName.toLowerCase() !== "object")) {
            if (I = u, U = h, ne === 1 && (Xr.test(u) || _i.test(u))) {
              for (U = On.test(u) && Pn(h.parentNode) || h, (U !== h || !n.scope) && ((P = h.getAttribute("id")) ? P = P.replace(Di, Ei) : h.setAttribute("id", P = oe)), z = l(u), x = z.length; x--; )
                z[x] = (P ? "#" + P : ":scope") + " " + on(z[x]);
              I = z.join(",");
            }
            try {
              return rt.apply(
                g,
                U.querySelectorAll(I)
              ), g;
            } catch {
              Pe(u, !0);
            } finally {
              P === oe && h.removeAttribute("id");
            }
          }
        }
        return d(u.replace(rn, "$1"), h, g, E);
      }
      function an() {
        var u = [];
        function h(g, E) {
          return u.push(g + " ") > i.cacheLength && delete h[u.shift()], h[g + " "] = E;
        }
        return h;
      }
      function Be(u) {
        return u[oe] = !0, u;
      }
      function Ie(u) {
        var h = D.createElement("fieldset");
        try {
          return !!u(h);
        } catch {
          return !1;
        } finally {
          h.parentNode && h.parentNode.removeChild(h), h = null;
        }
      }
      function An(u, h) {
        for (var g = u.split("|"), E = g.length; E--; )
          i.attrHandle[g[E]] = h;
      }
      function xi(u, h) {
        var g = h && u, E = g && u.nodeType === 1 && h.nodeType === 1 && u.sourceIndex - h.sourceIndex;
        if (E)
          return E;
        if (g) {
          for (; g = g.nextSibling; )
            if (g === h)
              return -1;
        }
        return u ? 1 : -1;
      }
      function is(u) {
        return function(h) {
          var g = h.nodeName.toLowerCase();
          return g === "input" && h.type === u;
        };
      }
      function rs(u) {
        return function(h) {
          var g = h.nodeName.toLowerCase();
          return (g === "input" || g === "button") && h.type === u;
        };
      }
      function Li(u) {
        return function(h) {
          return "form" in h ? h.parentNode && h.disabled === !1 ? "label" in h ? "label" in h.parentNode ? h.parentNode.disabled === u : h.disabled === u : h.isDisabled === u || h.isDisabled !== !u && ns(h) === u : h.disabled === u : "label" in h ? h.disabled === u : !1;
        };
      }
      function gt(u) {
        return Be(function(h) {
          return h = +h, Be(function(g, E) {
            for (var y, x = u([], g.length, h), O = x.length; O--; )
              g[y = x[O]] && (g[y] = !(E[y] = g[y]));
          });
        });
      }
      function Pn(u) {
        return u && typeof u.getElementsByTagName < "u" && u;
      }
      n = ue.support = {}, o = ue.isXML = function(u) {
        var h = u && u.namespaceURI, g = u && (u.ownerDocument || u).documentElement;
        return !Kr.test(h || g && g.nodeName || "HTML");
      }, v = ue.setDocument = function(u) {
        var h, g, E = u ? u.ownerDocument || u : X;
        return E == D || E.nodeType !== 9 || !E.documentElement || (D = E, j = D.documentElement, Y = !o(D), X != D && (g = D.defaultView) && g.top !== g && (g.addEventListener ? g.addEventListener("unload", Ni, !1) : g.attachEvent && g.attachEvent("onunload", Ni)), n.scope = Ie(function(y) {
          return j.appendChild(y).appendChild(D.createElement("div")), typeof y.querySelectorAll < "u" && !y.querySelectorAll(":scope fieldset div").length;
        }), n.attributes = Ie(function(y) {
          return y.className = "i", !y.getAttribute("className");
        }), n.getElementsByTagName = Ie(function(y) {
          return y.appendChild(D.createComment("")), !y.getElementsByTagName("*").length;
        }), n.getElementsByClassName = Ft.test(D.getElementsByClassName), n.getById = Ie(function(y) {
          return j.appendChild(y).id = oe, !D.getElementsByName || !D.getElementsByName(oe).length;
        }), n.getById ? (i.filter.ID = function(y) {
          var x = y.replace(et, tt);
          return function(O) {
            return O.getAttribute("id") === x;
          };
        }, i.find.ID = function(y, x) {
          if (typeof x.getElementById < "u" && Y) {
            var O = x.getElementById(y);
            return O ? [O] : [];
          }
        }) : (i.filter.ID = function(y) {
          var x = y.replace(et, tt);
          return function(O) {
            var P = typeof O.getAttributeNode < "u" && O.getAttributeNode("id");
            return P && P.value === x;
          };
        }, i.find.ID = function(y, x) {
          if (typeof x.getElementById < "u" && Y) {
            var O, P, q, z = x.getElementById(y);
            if (z) {
              if (O = z.getAttributeNode("id"), O && O.value === y)
                return [z];
              for (q = x.getElementsByName(y), P = 0; z = q[P++]; )
                if (O = z.getAttributeNode("id"), O && O.value === y)
                  return [z];
            }
            return [];
          }
        }), i.find.TAG = n.getElementsByTagName ? function(y, x) {
          if (typeof x.getElementsByTagName < "u")
            return x.getElementsByTagName(y);
          if (n.qsa)
            return x.querySelectorAll(y);
        } : function(y, x) {
          var O, P = [], q = 0, z = x.getElementsByTagName(y);
          if (y === "*") {
            for (; O = z[q++]; )
              O.nodeType === 1 && P.push(O);
            return P;
          }
          return z;
        }, i.find.CLASS = n.getElementsByClassName && function(y, x) {
          if (typeof x.getElementsByClassName < "u" && Y)
            return x.getElementsByClassName(y);
        }, be = [], F = [], (n.qsa = Ft.test(D.querySelectorAll)) && (Ie(function(y) {
          var x;
          j.appendChild(y).innerHTML = "<a id='" + oe + "'></a><select id='" + oe + "-\r\\' msallowcapture=''><option selected=''></option></select>", y.querySelectorAll("[msallowcapture^='']").length && F.push("[*^$]=" + ae + `*(?:''|"")`), y.querySelectorAll("[selected]").length || F.push("\\[" + ae + "*(?:value|" + xn + ")"), y.querySelectorAll("[id~=" + oe + "-]").length || F.push("~="), x = D.createElement("input"), x.setAttribute("name", ""), y.appendChild(x), y.querySelectorAll("[name='']").length || F.push("\\[" + ae + "*name" + ae + "*=" + ae + `*(?:''|"")`), y.querySelectorAll(":checked").length || F.push(":checked"), y.querySelectorAll("a#" + oe + "+*").length || F.push(".#.+[+~]"), y.querySelectorAll("\\\f"), F.push("[\\r\\n\\f]");
        }), Ie(function(y) {
          y.innerHTML = "<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";
          var x = D.createElement("input");
          x.setAttribute("type", "hidden"), y.appendChild(x).setAttribute("name", "D"), y.querySelectorAll("[name=d]").length && F.push("name" + ae + "*[*^$|!~]?="), y.querySelectorAll(":enabled").length !== 2 && F.push(":enabled", ":disabled"), j.appendChild(y).disabled = !0, y.querySelectorAll(":disabled").length !== 2 && F.push(":enabled", ":disabled"), y.querySelectorAll("*,:x"), F.push(",.*:");
        })), (n.matchesSelector = Ft.test(ye = j.matches || j.webkitMatchesSelector || j.mozMatchesSelector || j.oMatchesSelector || j.msMatchesSelector)) && Ie(function(y) {
          n.disconnectedMatch = ye.call(y, "*"), ye.call(y, "[s!='']:x"), be.push("!=", Ln);
        }), F = F.length && new RegExp(F.join("|")), be = be.length && new RegExp(be.join("|")), h = Ft.test(j.compareDocumentPosition), Ae = h || Ft.test(j.contains) ? function(y, x) {
          var O = y.nodeType === 9 ? y.documentElement : y, P = x && x.parentNode;
          return y === P || !!(P && P.nodeType === 1 && (O.contains ? O.contains(P) : y.compareDocumentPosition && y.compareDocumentPosition(P) & 16));
        } : function(y, x) {
          if (x) {
            for (; x = x.parentNode; )
              if (x === y)
                return !0;
          }
          return !1;
        }, ft = h ? function(y, x) {
          if (y === x)
            return L = !0, 0;
          var O = !y.compareDocumentPosition - !x.compareDocumentPosition;
          return O || (O = (y.ownerDocument || y) == (x.ownerDocument || x) ? y.compareDocumentPosition(x) : 1, O & 1 || !n.sortDetached && x.compareDocumentPosition(y) === O ? y == D || y.ownerDocument == X && Ae(X, y) ? -1 : x == D || x.ownerDocument == X && Ae(X, x) ? 1 : m ? ht(m, y) - ht(m, x) : 0 : O & 4 ? -1 : 1);
        } : function(y, x) {
          if (y === x)
            return L = !0, 0;
          var O, P = 0, q = y.parentNode, z = x.parentNode, I = [y], U = [x];
          if (!q || !z)
            return y == D ? -1 : x == D ? 1 : q ? -1 : z ? 1 : m ? ht(m, y) - ht(m, x) : 0;
          if (q === z)
            return xi(y, x);
          for (O = y; O = O.parentNode; )
            I.unshift(O);
          for (O = x; O = O.parentNode; )
            U.unshift(O);
          for (; I[P] === U[P]; )
            P++;
          return P ? xi(I[P], U[P]) : I[P] == X ? -1 : U[P] == X ? 1 : 0;
        }), D;
      }, ue.matches = function(u, h) {
        return ue(u, null, null, h);
      }, ue.matchesSelector = function(u, h) {
        if (v(u), n.matchesSelector && Y && !Pe[h + " "] && (!be || !be.test(h)) && (!F || !F.test(h)))
          try {
            var g = ye.call(u, h);
            if (g || n.disconnectedMatch || u.document && u.document.nodeType !== 11)
              return g;
          } catch {
            Pe(h, !0);
          }
        return ue(h, D, null, [u]).length > 0;
      }, ue.contains = function(u, h) {
        return (u.ownerDocument || u) != D && v(u), Ae(u, h);
      }, ue.attr = function(u, h) {
        (u.ownerDocument || u) != D && v(u);
        var g = i.attrHandle[h.toLowerCase()], E = g && dt.call(i.attrHandle, h.toLowerCase()) ? g(u, h, !Y) : void 0;
        return E !== void 0 ? E : n.attributes || !Y ? u.getAttribute(h) : (E = u.getAttributeNode(h)) && E.specified ? E.value : null;
      }, ue.escape = function(u) {
        return (u + "").replace(Di, Ei);
      }, ue.error = function(u) {
        throw new Error("Syntax error, unrecognized expression: " + u);
      }, ue.uniqueSort = function(u) {
        var h, g = [], E = 0, y = 0;
        if (L = !n.detectDuplicates, m = !n.sortStable && u.slice(0), u.sort(ft), L) {
          for (; h = u[y++]; )
            h === u[y] && (E = g.push(y));
          for (; E--; )
            u.splice(g[E], 1);
        }
        return m = null, u;
      }, a = ue.getText = function(u) {
        var h, g = "", E = 0, y = u.nodeType;
        if (y) {
          if (y === 1 || y === 9 || y === 11) {
            if (typeof u.textContent == "string")
              return u.textContent;
            for (u = u.firstChild; u; u = u.nextSibling)
              g += a(u);
          } else if (y === 3 || y === 4)
            return u.nodeValue;
        } else
          for (; h = u[E++]; )
            g += a(h);
        return g;
      }, i = ue.selectors = {
        cacheLength: 50,
        createPseudo: Be,
        match: sn,
        attrHandle: {},
        find: {},
        relative: {
          ">": { dir: "parentNode", first: !0 },
          " ": { dir: "parentNode" },
          "+": { dir: "previousSibling", first: !0 },
          "~": { dir: "previousSibling" }
        },
        preFilter: {
          ATTR: function(u) {
            return u[1] = u[1].replace(et, tt), u[3] = (u[3] || u[4] || u[5] || "").replace(et, tt), u[2] === "~=" && (u[3] = " " + u[3] + " "), u.slice(0, 4);
          },
          CHILD: function(u) {
            return u[1] = u[1].toLowerCase(), u[1].slice(0, 3) === "nth" ? (u[3] || ue.error(u[0]), u[4] = +(u[4] ? u[5] + (u[6] || 1) : 2 * (u[3] === "even" || u[3] === "odd")), u[5] = +(u[7] + u[8] || u[3] === "odd")) : u[3] && ue.error(u[0]), u;
          },
          PSEUDO: function(u) {
            var h, g = !u[6] && u[2];
            return sn.CHILD.test(u[0]) ? null : (u[3] ? u[2] = u[4] || u[5] || "" : g && Yr.test(g) && (h = l(g, !0)) && (h = g.indexOf(")", g.length - h) - g.length) && (u[0] = u[0].slice(0, h), u[2] = g.slice(0, h)), u.slice(0, 3));
          }
        },
        filter: {
          TAG: function(u) {
            var h = u.replace(et, tt).toLowerCase();
            return u === "*" ? function() {
              return !0;
            } : function(g) {
              return g.nodeName && g.nodeName.toLowerCase() === h;
            };
          },
          CLASS: function(u) {
            var h = ge[u + " "];
            return h || (h = new RegExp("(^|" + ae + ")" + u + "(" + ae + "|$)")) && ge(
              u,
              function(g) {
                return h.test(
                  typeof g.className == "string" && g.className || typeof g.getAttribute < "u" && g.getAttribute("class") || ""
                );
              }
            );
          },
          ATTR: function(u, h, g) {
            return function(E) {
              var y = ue.attr(E, u);
              return y == null ? h === "!=" : h ? (y += "", h === "=" ? y === g : h === "!=" ? y !== g : h === "^=" ? g && y.indexOf(g) === 0 : h === "*=" ? g && y.indexOf(g) > -1 : h === "$=" ? g && y.slice(-g.length) === g : h === "~=" ? (" " + y.replace(Gr, " ") + " ").indexOf(g) > -1 : h === "|=" ? y === g || y.slice(0, g.length + 1) === g + "-" : !1) : !0;
            };
          },
          CHILD: function(u, h, g, E, y) {
            var x = u.slice(0, 3) !== "nth", O = u.slice(-4) !== "last", P = h === "of-type";
            return E === 1 && y === 0 ? function(q) {
              return !!q.parentNode;
            } : function(q, z, I) {
              var U, ne, ce, W, ve, Ce, qe = x !== O ? "nextSibling" : "previousSibling", he = q.parentNode, Mt = P && q.nodeName.toLowerCase(), Bt = !I && !P, $e = !1;
              if (he) {
                if (x) {
                  for (; qe; ) {
                    for (W = q; W = W[qe]; )
                      if (P ? W.nodeName.toLowerCase() === Mt : W.nodeType === 1)
                        return !1;
                    Ce = qe = u === "only" && !Ce && "nextSibling";
                  }
                  return !0;
                }
                if (Ce = [O ? he.firstChild : he.lastChild], O && Bt) {
                  for (W = he, ce = W[oe] || (W[oe] = {}), ne = ce[W.uniqueID] || (ce[W.uniqueID] = {}), U = ne[u] || [], ve = U[0] === xe && U[1], $e = ve && U[2], W = ve && he.childNodes[ve]; W = ++ve && W && W[qe] || ($e = ve = 0) || Ce.pop(); )
                    if (W.nodeType === 1 && ++$e && W === q) {
                      ne[u] = [xe, ve, $e];
                      break;
                    }
                } else if (Bt && (W = q, ce = W[oe] || (W[oe] = {}), ne = ce[W.uniqueID] || (ce[W.uniqueID] = {}), U = ne[u] || [], ve = U[0] === xe && U[1], $e = ve), $e === !1)
                  for (; (W = ++ve && W && W[qe] || ($e = ve = 0) || Ce.pop()) && !((P ? W.nodeName.toLowerCase() === Mt : W.nodeType === 1) && ++$e && (Bt && (ce = W[oe] || (W[oe] = {}), ne = ce[W.uniqueID] || (ce[W.uniqueID] = {}), ne[u] = [xe, $e]), W === q)); )
                    ;
                return $e -= y, $e === E || $e % E === 0 && $e / E >= 0;
              }
            };
          },
          PSEUDO: function(u, h) {
            var g, E = i.pseudos[u] || i.setFilters[u.toLowerCase()] || ue.error("unsupported pseudo: " + u);
            return E[oe] ? E(h) : E.length > 1 ? (g = [u, u, "", h], i.setFilters.hasOwnProperty(u.toLowerCase()) ? Be(function(y, x) {
              for (var O, P = E(y, h), q = P.length; q--; )
                O = ht(y, P[q]), y[O] = !(x[O] = P[q]);
            }) : function(y) {
              return E(y, 0, g);
            }) : E;
          }
        },
        pseudos: {
          not: Be(function(u) {
            var h = [], g = [], E = p(u.replace(rn, "$1"));
            return E[oe] ? Be(function(y, x, O, P) {
              for (var q, z = E(y, null, P, []), I = y.length; I--; )
                (q = z[I]) && (y[I] = !(x[I] = q));
            }) : function(y, x, O) {
              return h[0] = y, E(h, null, O, g), h[0] = null, !g.pop();
            };
          }),
          has: Be(function(u) {
            return function(h) {
              return ue(u, h).length > 0;
            };
          }),
          contains: Be(function(u) {
            return u = u.replace(et, tt), function(h) {
              return (h.textContent || a(h)).indexOf(u) > -1;
            };
          }),
          lang: Be(function(u) {
            return Jr.test(u || "") || ue.error("unsupported lang: " + u), u = u.replace(et, tt).toLowerCase(), function(h) {
              var g;
              do
                if (g = Y ? h.lang : h.getAttribute("xml:lang") || h.getAttribute("lang"))
                  return g = g.toLowerCase(), g === u || g.indexOf(u + "-") === 0;
              while ((h = h.parentNode) && h.nodeType === 1);
              return !1;
            };
          }),
          target: function(u) {
            var h = e.location && e.location.hash;
            return h && h.slice(1) === u.id;
          },
          root: function(u) {
            return u === j;
          },
          focus: function(u) {
            return u === D.activeElement && (!D.hasFocus || D.hasFocus()) && !!(u.type || u.href || ~u.tabIndex);
          },
          enabled: Li(!1),
          disabled: Li(!0),
          checked: function(u) {
            var h = u.nodeName.toLowerCase();
            return h === "input" && !!u.checked || h === "option" && !!u.selected;
          },
          selected: function(u) {
            return u.parentNode && u.parentNode.selectedIndex, u.selected === !0;
          },
          empty: function(u) {
            for (u = u.firstChild; u; u = u.nextSibling)
              if (u.nodeType < 6)
                return !1;
            return !0;
          },
          parent: function(u) {
            return !i.pseudos.empty(u);
          },
          header: function(u) {
            return es.test(u.nodeName);
          },
          input: function(u) {
            return Zr.test(u.nodeName);
          },
          button: function(u) {
            var h = u.nodeName.toLowerCase();
            return h === "input" && u.type === "button" || h === "button";
          },
          text: function(u) {
            var h;
            return u.nodeName.toLowerCase() === "input" && u.type === "text" && ((h = u.getAttribute("type")) == null || h.toLowerCase() === "text");
          },
          first: gt(function() {
            return [0];
          }),
          last: gt(function(u, h) {
            return [h - 1];
          }),
          eq: gt(function(u, h, g) {
            return [g < 0 ? g + h : g];
          }),
          even: gt(function(u, h) {
            for (var g = 0; g < h; g += 2)
              u.push(g);
            return u;
          }),
          odd: gt(function(u, h) {
            for (var g = 1; g < h; g += 2)
              u.push(g);
            return u;
          }),
          lt: gt(function(u, h, g) {
            for (var E = g < 0 ? g + h : g > h ? h : g; --E >= 0; )
              u.push(E);
            return u;
          }),
          gt: gt(function(u, h, g) {
            for (var E = g < 0 ? g + h : g; ++E < h; )
              u.push(E);
            return u;
          })
        }
      }, i.pseudos.nth = i.pseudos.eq;
      for (t in { radio: !0, checkbox: !0, file: !0, password: !0, image: !0 })
        i.pseudos[t] = is(t);
      for (t in { submit: !0, reset: !0 })
        i.pseudos[t] = rs(t);
      function Oi() {
      }
      Oi.prototype = i.filters = i.pseudos, i.setFilters = new Oi(), l = ue.tokenize = function(u, h) {
        var g, E, y, x, O, P, q, z = jt[u + " "];
        if (z)
          return h ? 0 : z.slice(0);
        for (O = u, P = [], q = i.preFilter; O; ) {
          (!g || (E = Qr.exec(O))) && (E && (O = O.slice(E[0].length) || O), P.push(y = [])), g = !1, (E = _i.exec(O)) && (g = E.shift(), y.push({
            value: g,
            type: E[0].replace(rn, " ")
          }), O = O.slice(g.length));
          for (x in i.filter)
            (E = sn[x].exec(O)) && (!q[x] || (E = q[x](E))) && (g = E.shift(), y.push({
              value: g,
              type: x,
              matches: E
            }), O = O.slice(g.length));
          if (!g)
            break;
        }
        return h ? O.length : O ? ue.error(u) : jt(u, P).slice(0);
      };
      function on(u) {
        for (var h = 0, g = u.length, E = ""; h < g; h++)
          E += u[h].value;
        return E;
      }
      function ln(u, h, g) {
        var E = h.dir, y = h.next, x = y || E, O = g && x === "parentNode", P = re++;
        return h.first ? function(q, z, I) {
          for (; q = q[E]; )
            if (q.nodeType === 1 || O)
              return u(q, z, I);
          return !1;
        } : function(q, z, I) {
          var U, ne, ce, W = [xe, P];
          if (I) {
            for (; q = q[E]; )
              if ((q.nodeType === 1 || O) && u(q, z, I))
                return !0;
          } else
            for (; q = q[E]; )
              if (q.nodeType === 1 || O)
                if (ce = q[oe] || (q[oe] = {}), ne = ce[q.uniqueID] || (ce[q.uniqueID] = {}), y && y === q.nodeName.toLowerCase())
                  q = q[E] || q;
                else {
                  if ((U = ne[x]) && U[0] === xe && U[1] === P)
                    return W[2] = U[2];
                  if (ne[x] = W, W[2] = u(q, z, I))
                    return !0;
                }
          return !1;
        };
      }
      function qn(u) {
        return u.length > 1 ? function(h, g, E) {
          for (var y = u.length; y--; )
            if (!u[y](h, g, E))
              return !1;
          return !0;
        } : u[0];
      }
      function ss(u, h, g) {
        for (var E = 0, y = h.length; E < y; E++)
          ue(u, h[E], g);
        return g;
      }
      function un(u, h, g, E, y) {
        for (var x, O = [], P = 0, q = u.length, z = h != null; P < q; P++)
          (x = u[P]) && (!g || g(x, E, y)) && (O.push(x), z && h.push(P));
        return O;
      }
      function $n(u, h, g, E, y, x) {
        return E && !E[oe] && (E = $n(E)), y && !y[oe] && (y = $n(y, x)), Be(function(O, P, q, z) {
          var I, U, ne, ce = [], W = [], ve = P.length, Ce = O || ss(
            h || "*",
            q.nodeType ? [q] : q,
            []
          ), qe = u && (O || !h) ? un(Ce, ce, u, q, z) : Ce, he = g ? y || (O ? u : ve || E) ? [] : P : qe;
          if (g && g(qe, he, q, z), E)
            for (I = un(he, W), E(I, [], q, z), U = I.length; U--; )
              (ne = I[U]) && (he[W[U]] = !(qe[W[U]] = ne));
          if (O) {
            if (y || u) {
              if (y) {
                for (I = [], U = he.length; U--; )
                  (ne = he[U]) && I.push(qe[U] = ne);
                y(null, he = [], I, z);
              }
              for (U = he.length; U--; )
                (ne = he[U]) && (I = y ? ht(O, ne) : ce[U]) > -1 && (O[I] = !(P[I] = ne));
            }
          } else
            he = un(
              he === P ? he.splice(ve, he.length) : he
            ), y ? y(null, P, he, z) : rt.apply(P, he);
        });
      }
      function Hn(u) {
        for (var h, g, E, y = u.length, x = i.relative[u[0].type], O = x || i.relative[" "], P = x ? 1 : 0, q = ln(function(U) {
          return U === h;
        }, O, !0), z = ln(function(U) {
          return ht(h, U) > -1;
        }, O, !0), I = [function(U, ne, ce) {
          var W = !x && (ce || ne !== b) || ((h = ne).nodeType ? q(U, ne, ce) : z(U, ne, ce));
          return h = null, W;
        }]; P < y; P++)
          if (g = i.relative[u[P].type])
            I = [ln(qn(I), g)];
          else {
            if (g = i.filter[u[P].type].apply(null, u[P].matches), g[oe]) {
              for (E = ++P; E < y && !i.relative[u[E].type]; E++)
                ;
              return $n(
                P > 1 && qn(I),
                P > 1 && on(
                  u.slice(0, P - 1).concat({ value: u[P - 2].type === " " ? "*" : "" })
                ).replace(rn, "$1"),
                g,
                P < E && Hn(u.slice(P, E)),
                E < y && Hn(u = u.slice(E)),
                E < y && on(u)
              );
            }
            I.push(g);
          }
        return qn(I);
      }
      function as(u, h) {
        var g = h.length > 0, E = u.length > 0, y = function(x, O, P, q, z) {
          var I, U, ne, ce = 0, W = "0", ve = x && [], Ce = [], qe = b, he = x || E && i.find.TAG("*", z), Mt = xe += qe == null ? 1 : Math.random() || 0.1, Bt = he.length;
          for (z && (b = O == D || O || z); W !== Bt && (I = he[W]) != null; W++) {
            if (E && I) {
              for (U = 0, !O && I.ownerDocument != D && (v(I), P = !Y); ne = u[U++]; )
                if (ne(I, O || D, P)) {
                  q.push(I);
                  break;
                }
              z && (xe = Mt);
            }
            g && ((I = !ne && I) && ce--, x && ve.push(I));
          }
          if (ce += W, g && W !== ce) {
            for (U = 0; ne = h[U++]; )
              ne(ve, Ce, O, P);
            if (x) {
              if (ce > 0)
                for (; W--; )
                  ve[W] || Ce[W] || (Ce[W] = it.call(q));
              Ce = un(Ce);
            }
            rt.apply(q, Ce), z && !x && Ce.length > 0 && ce + h.length > 1 && ue.uniqueSort(q);
          }
          return z && (xe = Mt, b = qe), ve;
        };
        return g ? Be(y) : y;
      }
      return p = ue.compile = function(u, h) {
        var g, E = [], y = [], x = nn[u + " "];
        if (!x) {
          for (h || (h = l(u)), g = h.length; g--; )
            x = Hn(h[g]), x[oe] ? E.push(x) : y.push(x);
          x = nn(
            u,
            as(y, E)
          ), x.selector = u;
        }
        return x;
      }, d = ue.select = function(u, h, g, E) {
        var y, x, O, P, q, z = typeof u == "function" && u, I = !E && l(u = z.selector || u);
        if (g = g || [], I.length === 1) {
          if (x = I[0] = I[0].slice(0), x.length > 2 && (O = x[0]).type === "ID" && h.nodeType === 9 && Y && i.relative[x[1].type]) {
            if (h = (i.find.ID(O.matches[0].replace(et, tt), h) || [])[0], h)
              z && (h = h.parentNode);
            else
              return g;
            u = u.slice(x.shift().value.length);
          }
          for (y = sn.needsContext.test(u) ? 0 : x.length; y-- && (O = x[y], !i.relative[P = O.type]); )
            if ((q = i.find[P]) && (E = q(
              O.matches[0].replace(et, tt),
              On.test(x[0].type) && Pn(h.parentNode) || h
            ))) {
              if (x.splice(y, 1), u = E.length && on(x), !u)
                return rt.apply(g, E), g;
              break;
            }
        }
        return (z || p(u, I))(
          E,
          h,
          !Y,
          g,
          !h || On.test(u) && Pn(h.parentNode) || h
        ), g;
      }, n.sortStable = oe.split("").sort(ft).join("") === oe, n.detectDuplicates = !!L, v(), n.sortDetached = Ie(function(u) {
        return u.compareDocumentPosition(D.createElement("fieldset")) & 1;
      }), Ie(function(u) {
        return u.innerHTML = "<a href='#'></a>", u.firstChild.getAttribute("href") === "#";
      }) || An("type|href|height|width", function(u, h, g) {
        if (!g)
          return u.getAttribute(h, h.toLowerCase() === "type" ? 1 : 2);
      }), (!n.attributes || !Ie(function(u) {
        return u.innerHTML = "<input/>", u.firstChild.setAttribute("value", ""), u.firstChild.getAttribute("value") === "";
      })) && An("value", function(u, h, g) {
        if (!g && u.nodeName.toLowerCase() === "input")
          return u.defaultValue;
      }), Ie(function(u) {
        return u.getAttribute("disabled") == null;
      }) || An(xn, function(u, h, g) {
        var E;
        if (!g)
          return u[h] === !0 ? h.toLowerCase() : (E = u.getAttributeNode(h)) && E.specified ? E.value : null;
      }), ue;
    }(f);
    s.find = Te, s.expr = Te.selectors, s.expr[":"] = s.expr.pseudos, s.uniqueSort = s.unique = Te.uniqueSort, s.text = Te.getText, s.isXMLDoc = Te.isXML, s.contains = Te.contains, s.escapeSelector = Te.escape;
    var ee = function(e, t, n) {
      for (var i = [], a = n !== void 0; (e = e[t]) && e.nodeType !== 9; )
        if (e.nodeType === 1) {
          if (a && s(e).is(n))
            break;
          i.push(e);
        }
      return i;
    }, R = function(e, t) {
      for (var n = []; e; e = e.nextSibling)
        e.nodeType === 1 && e !== t && n.push(e);
      return n;
    }, ie = s.expr.match.needsContext;
    function le(e, t) {
      return e.nodeName && e.nodeName.toLowerCase() === t.toLowerCase();
    }
    var Se = /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;
    function Nt(e, t, n) {
      return G(t) ? s.grep(e, function(i, a) {
        return !!t.call(i, a, i) !== n;
      }) : t.nodeType ? s.grep(e, function(i) {
        return i === t !== n;
      }) : typeof t != "string" ? s.grep(e, function(i) {
        return B.call(t, i) > -1 !== n;
      }) : s.filter(t, e, n);
    }
    s.filter = function(e, t, n) {
      var i = t[0];
      return n && (e = ":not(" + e + ")"), t.length === 1 && i.nodeType === 1 ? s.find.matchesSelector(i, e) ? [i] : [] : s.find.matches(e, s.grep(t, function(a) {
        return a.nodeType === 1;
      }));
    }, s.fn.extend({
      find: function(e) {
        var t, n, i = this.length, a = this;
        if (typeof e != "string")
          return this.pushStack(s(e).filter(function() {
            for (t = 0; t < i; t++)
              if (s.contains(a[t], this))
                return !0;
          }));
        for (n = this.pushStack([]), t = 0; t < i; t++)
          s.find(e, a[t], n);
        return i > 1 ? s.uniqueSort(n) : n;
      },
      filter: function(e) {
        return this.pushStack(Nt(this, e || [], !1));
      },
      not: function(e) {
        return this.pushStack(Nt(this, e || [], !0));
      },
      is: function(e) {
        return !!Nt(
          this,
          typeof e == "string" && ie.test(e) ? s(e) : e || [],
          !1
        ).length;
      }
    });
    var Qt, ot = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/, _e = s.fn.init = function(e, t, n) {
      var i, a;
      if (!e)
        return this;
      if (n = n || Qt, typeof e == "string")
        if (e[0] === "<" && e[e.length - 1] === ">" && e.length >= 3 ? i = [null, e, null] : i = ot.exec(e), i && (i[1] || !t))
          if (i[1]) {
            if (t = t instanceof s ? t[0] : t, s.merge(this, s.parseHTML(
              i[1],
              t && t.nodeType ? t.ownerDocument || t : K,
              !0
            )), Se.test(i[1]) && s.isPlainObject(t))
              for (i in t)
                G(this[i]) ? this[i](t[i]) : this.attr(i, t[i]);
            return this;
          } else
            return a = K.getElementById(i[2]), a && (this[0] = a, this.length = 1), this;
        else
          return !t || t.jquery ? (t || n).find(e) : this.constructor(t).find(e);
      else {
        if (e.nodeType)
          return this[0] = e, this.length = 1, this;
        if (G(e))
          return n.ready !== void 0 ? n.ready(e) : e(s);
      }
      return s.makeArray(e, this);
    };
    _e.prototype = s.fn, Qt = s(K);
    var Ki = /^(?:parents|prev(?:Until|All))/, Zi = {
      children: !0,
      contents: !0,
      next: !0,
      prev: !0
    };
    s.fn.extend({
      has: function(e) {
        var t = s(e, this), n = t.length;
        return this.filter(function() {
          for (var i = 0; i < n; i++)
            if (s.contains(this, t[i]))
              return !0;
        });
      },
      closest: function(e, t) {
        var n, i = 0, a = this.length, o = [], l = typeof e != "string" && s(e);
        if (!ie.test(e)) {
          for (; i < a; i++)
            for (n = this[i]; n && n !== t; n = n.parentNode)
              if (n.nodeType < 11 && (l ? l.index(n) > -1 : n.nodeType === 1 && s.find.matchesSelector(n, e))) {
                o.push(n);
                break;
              }
        }
        return this.pushStack(o.length > 1 ? s.uniqueSort(o) : o);
      },
      index: function(e) {
        return e ? typeof e == "string" ? B.call(s(e), this[0]) : B.call(
          this,
          e.jquery ? e[0] : e
        ) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
      },
      add: function(e, t) {
        return this.pushStack(
          s.uniqueSort(
            s.merge(this.get(), s(e, t))
          )
        );
      },
      addBack: function(e) {
        return this.add(
          e == null ? this.prevObject : this.prevObject.filter(e)
        );
      }
    });
    function Vn(e, t) {
      for (; (e = e[t]) && e.nodeType !== 1; )
        ;
      return e;
    }
    s.each({
      parent: function(e) {
        var t = e.parentNode;
        return t && t.nodeType !== 11 ? t : null;
      },
      parents: function(e) {
        return ee(e, "parentNode");
      },
      parentsUntil: function(e, t, n) {
        return ee(e, "parentNode", n);
      },
      next: function(e) {
        return Vn(e, "nextSibling");
      },
      prev: function(e) {
        return Vn(e, "previousSibling");
      },
      nextAll: function(e) {
        return ee(e, "nextSibling");
      },
      prevAll: function(e) {
        return ee(e, "previousSibling");
      },
      nextUntil: function(e, t, n) {
        return ee(e, "nextSibling", n);
      },
      prevUntil: function(e, t, n) {
        return ee(e, "previousSibling", n);
      },
      siblings: function(e) {
        return R((e.parentNode || {}).firstChild, e);
      },
      children: function(e) {
        return R(e.firstChild);
      },
      contents: function(e) {
        return e.contentDocument != null && A(e.contentDocument) ? e.contentDocument : (le(e, "template") && (e = e.content || e), s.merge([], e.childNodes));
      }
    }, function(e, t) {
      s.fn[e] = function(n, i) {
        var a = s.map(this, t, n);
        return e.slice(-5) !== "Until" && (i = n), i && typeof i == "string" && (a = s.filter(i, a)), this.length > 1 && (Zi[e] || s.uniqueSort(a), Ki.test(e) && a.reverse()), this.pushStack(a);
      };
    });
    var Ue = /[^\x20\t\r\n\f]+/g;
    function er(e) {
      var t = {};
      return s.each(e.match(Ue) || [], function(n, i) {
        t[i] = !0;
      }), t;
    }
    s.Callbacks = function(e) {
      e = typeof e == "string" ? er(e) : s.extend({}, e);
      var t, n, i, a, o = [], l = [], p = -1, d = function() {
        for (a = a || e.once, i = t = !0; l.length; p = -1)
          for (n = l.shift(); ++p < o.length; )
            o[p].apply(n[0], n[1]) === !1 && e.stopOnFalse && (p = o.length, n = !1);
        e.memory || (n = !1), t = !1, a && (n ? o = [] : o = "");
      }, b = {
        add: function() {
          return o && (n && !t && (p = o.length - 1, l.push(n)), function m(L) {
            s.each(L, function(v, D) {
              G(D) ? (!e.unique || !b.has(D)) && o.push(D) : D && D.length && Je(D) !== "string" && m(D);
            });
          }(arguments), n && !t && d()), this;
        },
        remove: function() {
          return s.each(arguments, function(m, L) {
            for (var v; (v = s.inArray(L, o, v)) > -1; )
              o.splice(v, 1), v <= p && p--;
          }), this;
        },
        has: function(m) {
          return m ? s.inArray(m, o) > -1 : o.length > 0;
        },
        empty: function() {
          return o && (o = []), this;
        },
        disable: function() {
          return a = l = [], o = n = "", this;
        },
        disabled: function() {
          return !o;
        },
        lock: function() {
          return a = l = [], !n && !t && (o = n = ""), this;
        },
        locked: function() {
          return !!a;
        },
        fireWith: function(m, L) {
          return a || (L = L || [], L = [m, L.slice ? L.slice() : L], l.push(L), t || d()), this;
        },
        fire: function() {
          return b.fireWith(this, arguments), this;
        },
        fired: function() {
          return !!i;
        }
      };
      return b;
    };
    function mt(e) {
      return e;
    }
    function Xt(e) {
      throw e;
    }
    function zn(e, t, n, i) {
      var a;
      try {
        e && G(a = e.promise) ? a.call(e).done(t).fail(n) : e && G(a = e.then) ? a.call(e, t, n) : t.apply(void 0, [e].slice(i));
      } catch (o) {
        n.apply(void 0, [o]);
      }
    }
    s.extend({
      Deferred: function(e) {
        var t = [
          [
            "notify",
            "progress",
            s.Callbacks("memory"),
            s.Callbacks("memory"),
            2
          ],
          [
            "resolve",
            "done",
            s.Callbacks("once memory"),
            s.Callbacks("once memory"),
            0,
            "resolved"
          ],
          [
            "reject",
            "fail",
            s.Callbacks("once memory"),
            s.Callbacks("once memory"),
            1,
            "rejected"
          ]
        ], n = "pending", i = {
          state: function() {
            return n;
          },
          always: function() {
            return a.done(arguments).fail(arguments), this;
          },
          catch: function(o) {
            return i.then(null, o);
          },
          pipe: function() {
            var o = arguments;
            return s.Deferred(function(l) {
              s.each(t, function(p, d) {
                var b = G(o[d[4]]) && o[d[4]];
                a[d[1]](function() {
                  var m = b && b.apply(this, arguments);
                  m && G(m.promise) ? m.promise().progress(l.notify).done(l.resolve).fail(l.reject) : l[d[0] + "With"](
                    this,
                    b ? [m] : arguments
                  );
                });
              }), o = null;
            }).promise();
          },
          then: function(o, l, p) {
            var d = 0;
            function b(m, L, v, D) {
              return function() {
                var j = this, Y = arguments, F = function() {
                  var ye, Ae;
                  if (!(m < d)) {
                    if (ye = v.apply(j, Y), ye === L.promise())
                      throw new TypeError("Thenable self-resolution");
                    Ae = ye && (typeof ye == "object" || typeof ye == "function") && ye.then, G(Ae) ? D ? Ae.call(
                      ye,
                      b(d, L, mt, D),
                      b(d, L, Xt, D)
                    ) : (d++, Ae.call(
                      ye,
                      b(d, L, mt, D),
                      b(d, L, Xt, D),
                      b(
                        d,
                        L,
                        mt,
                        L.notifyWith
                      )
                    )) : (v !== mt && (j = void 0, Y = [ye]), (D || L.resolveWith)(j, Y));
                  }
                }, be = D ? F : function() {
                  try {
                    F();
                  } catch (ye) {
                    s.Deferred.exceptionHook && s.Deferred.exceptionHook(
                      ye,
                      be.stackTrace
                    ), m + 1 >= d && (v !== Xt && (j = void 0, Y = [ye]), L.rejectWith(j, Y));
                  }
                };
                m ? be() : (s.Deferred.getStackHook && (be.stackTrace = s.Deferred.getStackHook()), f.setTimeout(be));
              };
            }
            return s.Deferred(function(m) {
              t[0][3].add(
                b(
                  0,
                  m,
                  G(p) ? p : mt,
                  m.notifyWith
                )
              ), t[1][3].add(
                b(
                  0,
                  m,
                  G(o) ? o : mt
                )
              ), t[2][3].add(
                b(
                  0,
                  m,
                  G(l) ? l : Xt
                )
              );
            }).promise();
          },
          promise: function(o) {
            return o != null ? s.extend(o, i) : i;
          }
        }, a = {};
        return s.each(t, function(o, l) {
          var p = l[2], d = l[5];
          i[l[1]] = p.add, d && p.add(
            function() {
              n = d;
            },
            t[3 - o][2].disable,
            t[3 - o][3].disable,
            t[0][2].lock,
            t[0][3].lock
          ), p.add(l[3].fire), a[l[0]] = function() {
            return a[l[0] + "With"](this === a ? void 0 : this, arguments), this;
          }, a[l[0] + "With"] = p.fireWith;
        }), i.promise(a), e && e.call(a, a), a;
      },
      when: function(e) {
        var t = arguments.length, n = t, i = Array(n), a = N.call(arguments), o = s.Deferred(), l = function(p) {
          return function(d) {
            i[p] = this, a[p] = arguments.length > 1 ? N.call(arguments) : d, --t || o.resolveWith(i, a);
          };
        };
        if (t <= 1 && (zn(
          e,
          o.done(l(n)).resolve,
          o.reject,
          !t
        ), o.state() === "pending" || G(a[n] && a[n].then)))
          return o.then();
        for (; n--; )
          zn(a[n], l(n), o.reject);
        return o.promise();
      }
    });
    var tr = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;
    s.Deferred.exceptionHook = function(e, t) {
      f.console && f.console.warn && e && tr.test(e.name) && f.console.warn("jQuery.Deferred exception: " + e.message, e.stack, t);
    }, s.readyException = function(e) {
      f.setTimeout(function() {
        throw e;
      });
    };
    var pn = s.Deferred();
    s.fn.ready = function(e) {
      return pn.then(e).catch(function(t) {
        s.readyException(t);
      }), this;
    }, s.extend({
      isReady: !1,
      readyWait: 1,
      ready: function(e) {
        (e === !0 ? --s.readyWait : s.isReady) || (s.isReady = !0, !(e !== !0 && --s.readyWait > 0) && pn.resolveWith(K, [s]));
      }
    }), s.ready.then = pn.then;
    function Yt() {
      K.removeEventListener("DOMContentLoaded", Yt), f.removeEventListener("load", Yt), s.ready();
    }
    K.readyState === "complete" || K.readyState !== "loading" && !K.documentElement.doScroll ? f.setTimeout(s.ready) : (K.addEventListener("DOMContentLoaded", Yt), f.addEventListener("load", Yt));
    var Ke = function(e, t, n, i, a, o, l) {
      var p = 0, d = e.length, b = n == null;
      if (Je(n) === "object") {
        a = !0;
        for (p in n)
          Ke(e, t, p, n[p], !0, o, l);
      } else if (i !== void 0 && (a = !0, G(i) || (l = !0), b && (l ? (t.call(e, i), t = null) : (b = t, t = function(m, L, v) {
        return b.call(s(m), v);
      })), t))
        for (; p < d; p++)
          t(
            e[p],
            n,
            l ? i : i.call(e[p], p, t(e[p], n))
          );
      return a ? e : b ? t.call(e) : d ? t(e[0], n) : o;
    }, nr = /^-ms-/, ir = /-([a-z])/g;
    function rr(e, t) {
      return t.toUpperCase();
    }
    function Ge(e) {
      return e.replace(nr, "ms-").replace(ir, rr);
    }
    var xt = function(e) {
      return e.nodeType === 1 || e.nodeType === 9 || !+e.nodeType;
    };
    function Lt() {
      this.expando = s.expando + Lt.uid++;
    }
    Lt.uid = 1, Lt.prototype = {
      cache: function(e) {
        var t = e[this.expando];
        return t || (t = {}, xt(e) && (e.nodeType ? e[this.expando] = t : Object.defineProperty(e, this.expando, {
          value: t,
          configurable: !0
        }))), t;
      },
      set: function(e, t, n) {
        var i, a = this.cache(e);
        if (typeof t == "string")
          a[Ge(t)] = n;
        else
          for (i in t)
            a[Ge(i)] = t[i];
        return a;
      },
      get: function(e, t) {
        return t === void 0 ? this.cache(e) : e[this.expando] && e[this.expando][Ge(t)];
      },
      access: function(e, t, n) {
        return t === void 0 || t && typeof t == "string" && n === void 0 ? this.get(e, t) : (this.set(e, t, n), n !== void 0 ? n : t);
      },
      remove: function(e, t) {
        var n, i = e[this.expando];
        if (i !== void 0) {
          if (t !== void 0)
            for (Array.isArray(t) ? t = t.map(Ge) : (t = Ge(t), t = t in i ? [t] : t.match(Ue) || []), n = t.length; n--; )
              delete i[t[n]];
          (t === void 0 || s.isEmptyObject(i)) && (e.nodeType ? e[this.expando] = void 0 : delete e[this.expando]);
        }
      },
      hasData: function(e) {
        var t = e[this.expando];
        return t !== void 0 && !s.isEmptyObject(t);
      }
    };
    var V = new Lt(), De = new Lt(), sr = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/, ar = /[A-Z]/g;
    function or(e) {
      return e === "true" ? !0 : e === "false" ? !1 : e === "null" ? null : e === +e + "" ? +e : sr.test(e) ? JSON.parse(e) : e;
    }
    function Wn(e, t, n) {
      var i;
      if (n === void 0 && e.nodeType === 1)
        if (i = "data-" + t.replace(ar, "-$&").toLowerCase(), n = e.getAttribute(i), typeof n == "string") {
          try {
            n = or(n);
          } catch {
          }
          De.set(e, t, n);
        } else
          n = void 0;
      return n;
    }
    s.extend({
      hasData: function(e) {
        return De.hasData(e) || V.hasData(e);
      },
      data: function(e, t, n) {
        return De.access(e, t, n);
      },
      removeData: function(e, t) {
        De.remove(e, t);
      },
      _data: function(e, t, n) {
        return V.access(e, t, n);
      },
      _removeData: function(e, t) {
        V.remove(e, t);
      }
    }), s.fn.extend({
      data: function(e, t) {
        var n, i, a, o = this[0], l = o && o.attributes;
        if (e === void 0) {
          if (this.length && (a = De.get(o), o.nodeType === 1 && !V.get(o, "hasDataAttrs"))) {
            for (n = l.length; n--; )
              l[n] && (i = l[n].name, i.indexOf("data-") === 0 && (i = Ge(i.slice(5)), Wn(o, i, a[i])));
            V.set(o, "hasDataAttrs", !0);
          }
          return a;
        }
        return typeof e == "object" ? this.each(function() {
          De.set(this, e);
        }) : Ke(this, function(p) {
          var d;
          if (o && p === void 0)
            return d = De.get(o, e), d !== void 0 || (d = Wn(o, e), d !== void 0) ? d : void 0;
          this.each(function() {
            De.set(this, e, p);
          });
        }, null, t, arguments.length > 1, null, !0);
      },
      removeData: function(e) {
        return this.each(function() {
          De.remove(this, e);
        });
      }
    }), s.extend({
      queue: function(e, t, n) {
        var i;
        if (e)
          return t = (t || "fx") + "queue", i = V.get(e, t), n && (!i || Array.isArray(n) ? i = V.access(e, t, s.makeArray(n)) : i.push(n)), i || [];
      },
      dequeue: function(e, t) {
        t = t || "fx";
        var n = s.queue(e, t), i = n.length, a = n.shift(), o = s._queueHooks(e, t), l = function() {
          s.dequeue(e, t);
        };
        a === "inprogress" && (a = n.shift(), i--), a && (t === "fx" && n.unshift("inprogress"), delete o.stop, a.call(e, l, o)), !i && o && o.empty.fire();
      },
      _queueHooks: function(e, t) {
        var n = t + "queueHooks";
        return V.get(e, n) || V.access(e, n, {
          empty: s.Callbacks("once memory").add(function() {
            V.remove(e, [t + "queue", n]);
          })
        });
      }
    }), s.fn.extend({
      queue: function(e, t) {
        var n = 2;
        return typeof e != "string" && (t = e, e = "fx", n--), arguments.length < n ? s.queue(this[0], e) : t === void 0 ? this : this.each(function() {
          var i = s.queue(this, e, t);
          s._queueHooks(this, e), e === "fx" && i[0] !== "inprogress" && s.dequeue(this, e);
        });
      },
      dequeue: function(e) {
        return this.each(function() {
          s.dequeue(this, e);
        });
      },
      clearQueue: function(e) {
        return this.queue(e || "fx", []);
      },
      promise: function(e, t) {
        var n, i = 1, a = s.Deferred(), o = this, l = this.length, p = function() {
          --i || a.resolveWith(o, [o]);
        };
        for (typeof e != "string" && (t = e, e = void 0), e = e || "fx"; l--; )
          n = V.get(o[l], e + "queueHooks"), n && n.empty && (i++, n.empty.add(p));
        return p(), a.promise(t);
      }
    });
    var Un = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source, Ot = new RegExp("^(?:([+-])=|)(" + Un + ")([a-z%]*)$", "i"), Ze = ["Top", "Right", "Bottom", "Left"], lt = K.documentElement, kt = function(e) {
      return s.contains(e.ownerDocument, e);
    }, lr = { composed: !0 };
    lt.getRootNode && (kt = function(e) {
      return s.contains(e.ownerDocument, e) || e.getRootNode(lr) === e.ownerDocument;
    });
    var Jt = function(e, t) {
      return e = t || e, e.style.display === "none" || e.style.display === "" && kt(e) && s.css(e, "display") === "none";
    };
    function Gn(e, t, n, i) {
      var a, o, l = 20, p = i ? function() {
        return i.cur();
      } : function() {
        return s.css(e, t, "");
      }, d = p(), b = n && n[3] || (s.cssNumber[t] ? "" : "px"), m = e.nodeType && (s.cssNumber[t] || b !== "px" && +d) && Ot.exec(s.css(e, t));
      if (m && m[3] !== b) {
        for (d = d / 2, b = b || m[3], m = +d || 1; l--; )
          s.style(e, t, m + b), (1 - o) * (1 - (o = p() / d || 0.5)) <= 0 && (l = 0), m = m / o;
        m = m * 2, s.style(e, t, m + b), n = n || [];
      }
      return n && (m = +m || +d || 0, a = n[1] ? m + (n[1] + 1) * n[2] : +n[2], i && (i.unit = b, i.start = m, i.end = a)), a;
    }
    var Qn = {};
    function ur(e) {
      var t, n = e.ownerDocument, i = e.nodeName, a = Qn[i];
      return a || (t = n.body.appendChild(n.createElement(i)), a = s.css(t, "display"), t.parentNode.removeChild(t), a === "none" && (a = "block"), Qn[i] = a, a);
    }
    function wt(e, t) {
      for (var n, i, a = [], o = 0, l = e.length; o < l; o++)
        i = e[o], i.style && (n = i.style.display, t ? (n === "none" && (a[o] = V.get(i, "display") || null, a[o] || (i.style.display = "")), i.style.display === "" && Jt(i) && (a[o] = ur(i))) : n !== "none" && (a[o] = "none", V.set(i, "display", n)));
      for (o = 0; o < l; o++)
        a[o] != null && (e[o].style.display = a[o]);
      return e;
    }
    s.fn.extend({
      show: function() {
        return wt(this, !0);
      },
      hide: function() {
        return wt(this);
      },
      toggle: function(e) {
        return typeof e == "boolean" ? e ? this.show() : this.hide() : this.each(function() {
          Jt(this) ? s(this).show() : s(this).hide();
        });
      }
    });
    var At = /^(?:checkbox|radio)$/i, Xn = /<([a-z][^\/\0>\x20\t\r\n\f]*)/i, Yn = /^$|^module$|\/(?:java|ecma)script/i;
    (function() {
      var e = K.createDocumentFragment(), t = e.appendChild(K.createElement("div")), n = K.createElement("input");
      n.setAttribute("type", "radio"), n.setAttribute("checked", "checked"), n.setAttribute("name", "t"), t.appendChild(n), te.checkClone = t.cloneNode(!0).cloneNode(!0).lastChild.checked, t.innerHTML = "<textarea>x</textarea>", te.noCloneChecked = !!t.cloneNode(!0).lastChild.defaultValue, t.innerHTML = "<option></option>", te.option = !!t.lastChild;
    })();
    var je = {
      thead: [1, "<table>", "</table>"],
      col: [2, "<table><colgroup>", "</colgroup></table>"],
      tr: [2, "<table><tbody>", "</tbody></table>"],
      td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
      _default: [0, "", ""]
    };
    je.tbody = je.tfoot = je.colgroup = je.caption = je.thead, je.th = je.td, te.option || (je.optgroup = je.option = [1, "<select multiple='multiple'>", "</select>"]);
    function Ee(e, t) {
      var n;
      return typeof e.getElementsByTagName < "u" ? n = e.getElementsByTagName(t || "*") : typeof e.querySelectorAll < "u" ? n = e.querySelectorAll(t || "*") : n = [], t === void 0 || t && le(e, t) ? s.merge([e], n) : n;
    }
    function gn(e, t) {
      for (var n = 0, i = e.length; n < i; n++)
        V.set(
          e[n],
          "globalEval",
          !t || V.get(t[n], "globalEval")
        );
    }
    var cr = /<|&#?\w+;/;
    function Jn(e, t, n, i, a) {
      for (var o, l, p, d, b, m, L = t.createDocumentFragment(), v = [], D = 0, j = e.length; D < j; D++)
        if (o = e[D], o || o === 0)
          if (Je(o) === "object")
            s.merge(v, o.nodeType ? [o] : o);
          else if (!cr.test(o))
            v.push(t.createTextNode(o));
          else {
            for (l = l || L.appendChild(t.createElement("div")), p = (Xn.exec(o) || ["", ""])[1].toLowerCase(), d = je[p] || je._default, l.innerHTML = d[1] + s.htmlPrefilter(o) + d[2], m = d[0]; m--; )
              l = l.lastChild;
            s.merge(v, l.childNodes), l = L.firstChild, l.textContent = "";
          }
      for (L.textContent = "", D = 0; o = v[D++]; ) {
        if (i && s.inArray(o, i) > -1) {
          a && a.push(o);
          continue;
        }
        if (b = kt(o), l = Ee(L.appendChild(o), "script"), b && gn(l), n)
          for (m = 0; o = l[m++]; )
            Yn.test(o.type || "") && n.push(o);
      }
      return L;
    }
    var Kn = /^([^.]*)(?:\.(.+)|)/;
    function Tt() {
      return !0;
    }
    function Ct() {
      return !1;
    }
    function fr(e, t) {
      return e === dr() == (t === "focus");
    }
    function dr() {
      try {
        return K.activeElement;
      } catch {
      }
    }
    function yn(e, t, n, i, a, o) {
      var l, p;
      if (typeof t == "object") {
        typeof n != "string" && (i = i || n, n = void 0);
        for (p in t)
          yn(e, p, n, i, t[p], o);
        return e;
      }
      if (i == null && a == null ? (a = n, i = n = void 0) : a == null && (typeof n == "string" ? (a = i, i = void 0) : (a = i, i = n, n = void 0)), a === !1)
        a = Ct;
      else if (!a)
        return e;
      return o === 1 && (l = a, a = function(d) {
        return s().off(d), l.apply(this, arguments);
      }, a.guid = l.guid || (l.guid = s.guid++)), e.each(function() {
        s.event.add(this, t, a, i, n);
      });
    }
    s.event = {
      global: {},
      add: function(e, t, n, i, a) {
        var o, l, p, d, b, m, L, v, D, j, Y, F = V.get(e);
        if (!!xt(e))
          for (n.handler && (o = n, n = o.handler, a = o.selector), a && s.find.matchesSelector(lt, a), n.guid || (n.guid = s.guid++), (d = F.events) || (d = F.events = /* @__PURE__ */ Object.create(null)), (l = F.handle) || (l = F.handle = function(be) {
            return typeof s < "u" && s.event.triggered !== be.type ? s.event.dispatch.apply(e, arguments) : void 0;
          }), t = (t || "").match(Ue) || [""], b = t.length; b--; )
            p = Kn.exec(t[b]) || [], D = Y = p[1], j = (p[2] || "").split(".").sort(), D && (L = s.event.special[D] || {}, D = (a ? L.delegateType : L.bindType) || D, L = s.event.special[D] || {}, m = s.extend({
              type: D,
              origType: Y,
              data: i,
              handler: n,
              guid: n.guid,
              selector: a,
              needsContext: a && s.expr.match.needsContext.test(a),
              namespace: j.join(".")
            }, o), (v = d[D]) || (v = d[D] = [], v.delegateCount = 0, (!L.setup || L.setup.call(e, i, j, l) === !1) && e.addEventListener && e.addEventListener(D, l)), L.add && (L.add.call(e, m), m.handler.guid || (m.handler.guid = n.guid)), a ? v.splice(v.delegateCount++, 0, m) : v.push(m), s.event.global[D] = !0);
      },
      remove: function(e, t, n, i, a) {
        var o, l, p, d, b, m, L, v, D, j, Y, F = V.hasData(e) && V.get(e);
        if (!(!F || !(d = F.events))) {
          for (t = (t || "").match(Ue) || [""], b = t.length; b--; ) {
            if (p = Kn.exec(t[b]) || [], D = Y = p[1], j = (p[2] || "").split(".").sort(), !D) {
              for (D in d)
                s.event.remove(e, D + t[b], n, i, !0);
              continue;
            }
            for (L = s.event.special[D] || {}, D = (i ? L.delegateType : L.bindType) || D, v = d[D] || [], p = p[2] && new RegExp("(^|\\.)" + j.join("\\.(?:.*\\.|)") + "(\\.|$)"), l = o = v.length; o--; )
              m = v[o], (a || Y === m.origType) && (!n || n.guid === m.guid) && (!p || p.test(m.namespace)) && (!i || i === m.selector || i === "**" && m.selector) && (v.splice(o, 1), m.selector && v.delegateCount--, L.remove && L.remove.call(e, m));
            l && !v.length && ((!L.teardown || L.teardown.call(e, j, F.handle) === !1) && s.removeEvent(e, D, F.handle), delete d[D]);
          }
          s.isEmptyObject(d) && V.remove(e, "handle events");
        }
      },
      dispatch: function(e) {
        var t, n, i, a, o, l, p = new Array(arguments.length), d = s.event.fix(e), b = (V.get(this, "events") || /* @__PURE__ */ Object.create(null))[d.type] || [], m = s.event.special[d.type] || {};
        for (p[0] = d, t = 1; t < arguments.length; t++)
          p[t] = arguments[t];
        if (d.delegateTarget = this, !(m.preDispatch && m.preDispatch.call(this, d) === !1)) {
          for (l = s.event.handlers.call(this, d, b), t = 0; (a = l[t++]) && !d.isPropagationStopped(); )
            for (d.currentTarget = a.elem, n = 0; (o = a.handlers[n++]) && !d.isImmediatePropagationStopped(); )
              (!d.rnamespace || o.namespace === !1 || d.rnamespace.test(o.namespace)) && (d.handleObj = o, d.data = o.data, i = ((s.event.special[o.origType] || {}).handle || o.handler).apply(a.elem, p), i !== void 0 && (d.result = i) === !1 && (d.preventDefault(), d.stopPropagation()));
          return m.postDispatch && m.postDispatch.call(this, d), d.result;
        }
      },
      handlers: function(e, t) {
        var n, i, a, o, l, p = [], d = t.delegateCount, b = e.target;
        if (d && b.nodeType && !(e.type === "click" && e.button >= 1)) {
          for (; b !== this; b = b.parentNode || this)
            if (b.nodeType === 1 && !(e.type === "click" && b.disabled === !0)) {
              for (o = [], l = {}, n = 0; n < d; n++)
                i = t[n], a = i.selector + " ", l[a] === void 0 && (l[a] = i.needsContext ? s(a, this).index(b) > -1 : s.find(a, this, null, [b]).length), l[a] && o.push(i);
              o.length && p.push({ elem: b, handlers: o });
            }
        }
        return b = this, d < t.length && p.push({ elem: b, handlers: t.slice(d) }), p;
      },
      addProp: function(e, t) {
        Object.defineProperty(s.Event.prototype, e, {
          enumerable: !0,
          configurable: !0,
          get: G(t) ? function() {
            if (this.originalEvent)
              return t(this.originalEvent);
          } : function() {
            if (this.originalEvent)
              return this.originalEvent[e];
          },
          set: function(n) {
            Object.defineProperty(this, e, {
              enumerable: !0,
              configurable: !0,
              writable: !0,
              value: n
            });
          }
        });
      },
      fix: function(e) {
        return e[s.expando] ? e : new s.Event(e);
      },
      special: {
        load: {
          noBubble: !0
        },
        click: {
          setup: function(e) {
            var t = this || e;
            return At.test(t.type) && t.click && le(t, "input") && Kt(t, "click", Tt), !1;
          },
          trigger: function(e) {
            var t = this || e;
            return At.test(t.type) && t.click && le(t, "input") && Kt(t, "click"), !0;
          },
          _default: function(e) {
            var t = e.target;
            return At.test(t.type) && t.click && le(t, "input") && V.get(t, "click") || le(t, "a");
          }
        },
        beforeunload: {
          postDispatch: function(e) {
            e.result !== void 0 && e.originalEvent && (e.originalEvent.returnValue = e.result);
          }
        }
      }
    };
    function Kt(e, t, n) {
      if (!n) {
        V.get(e, t) === void 0 && s.event.add(e, t, Tt);
        return;
      }
      V.set(e, t, !1), s.event.add(e, t, {
        namespace: !1,
        handler: function(i) {
          var a, o, l = V.get(this, t);
          if (i.isTrigger & 1 && this[t]) {
            if (l.length)
              (s.event.special[t] || {}).delegateType && i.stopPropagation();
            else if (l = N.call(arguments), V.set(this, t, l), a = n(this, t), this[t](), o = V.get(this, t), l !== o || a ? V.set(this, t, !1) : o = {}, l !== o)
              return i.stopImmediatePropagation(), i.preventDefault(), o && o.value;
          } else
            l.length && (V.set(this, t, {
              value: s.event.trigger(
                s.extend(l[0], s.Event.prototype),
                l.slice(1),
                this
              )
            }), i.stopImmediatePropagation());
        }
      });
    }
    s.removeEvent = function(e, t, n) {
      e.removeEventListener && e.removeEventListener(t, n);
    }, s.Event = function(e, t) {
      if (!(this instanceof s.Event))
        return new s.Event(e, t);
      e && e.type ? (this.originalEvent = e, this.type = e.type, this.isDefaultPrevented = e.defaultPrevented || e.defaultPrevented === void 0 && e.returnValue === !1 ? Tt : Ct, this.target = e.target && e.target.nodeType === 3 ? e.target.parentNode : e.target, this.currentTarget = e.currentTarget, this.relatedTarget = e.relatedTarget) : this.type = e, t && s.extend(this, t), this.timeStamp = e && e.timeStamp || Date.now(), this[s.expando] = !0;
    }, s.Event.prototype = {
      constructor: s.Event,
      isDefaultPrevented: Ct,
      isPropagationStopped: Ct,
      isImmediatePropagationStopped: Ct,
      isSimulated: !1,
      preventDefault: function() {
        var e = this.originalEvent;
        this.isDefaultPrevented = Tt, e && !this.isSimulated && e.preventDefault();
      },
      stopPropagation: function() {
        var e = this.originalEvent;
        this.isPropagationStopped = Tt, e && !this.isSimulated && e.stopPropagation();
      },
      stopImmediatePropagation: function() {
        var e = this.originalEvent;
        this.isImmediatePropagationStopped = Tt, e && !this.isSimulated && e.stopImmediatePropagation(), this.stopPropagation();
      }
    }, s.each({
      altKey: !0,
      bubbles: !0,
      cancelable: !0,
      changedTouches: !0,
      ctrlKey: !0,
      detail: !0,
      eventPhase: !0,
      metaKey: !0,
      pageX: !0,
      pageY: !0,
      shiftKey: !0,
      view: !0,
      char: !0,
      code: !0,
      charCode: !0,
      key: !0,
      keyCode: !0,
      button: !0,
      buttons: !0,
      clientX: !0,
      clientY: !0,
      offsetX: !0,
      offsetY: !0,
      pointerId: !0,
      pointerType: !0,
      screenX: !0,
      screenY: !0,
      targetTouches: !0,
      toElement: !0,
      touches: !0,
      which: !0
    }, s.event.addProp), s.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      s.event.special[e] = {
        setup: function() {
          return Kt(this, e, fr), !1;
        },
        trigger: function() {
          return Kt(this, e), !0;
        },
        _default: function(n) {
          return V.get(n.target, e);
        },
        delegateType: t
      };
    }), s.each({
      mouseenter: "mouseover",
      mouseleave: "mouseout",
      pointerenter: "pointerover",
      pointerleave: "pointerout"
    }, function(e, t) {
      s.event.special[e] = {
        delegateType: t,
        bindType: t,
        handle: function(n) {
          var i, a = this, o = n.relatedTarget, l = n.handleObj;
          return (!o || o !== a && !s.contains(a, o)) && (n.type = l.origType, i = l.handler.apply(this, arguments), n.type = t), i;
        }
      };
    }), s.fn.extend({
      on: function(e, t, n, i) {
        return yn(this, e, t, n, i);
      },
      one: function(e, t, n, i) {
        return yn(this, e, t, n, i, 1);
      },
      off: function(e, t, n) {
        var i, a;
        if (e && e.preventDefault && e.handleObj)
          return i = e.handleObj, s(e.delegateTarget).off(
            i.namespace ? i.origType + "." + i.namespace : i.origType,
            i.selector,
            i.handler
          ), this;
        if (typeof e == "object") {
          for (a in e)
            this.off(a, t, e[a]);
          return this;
        }
        return (t === !1 || typeof t == "function") && (n = t, t = void 0), n === !1 && (n = Ct), this.each(function() {
          s.event.remove(this, e, n, t);
        });
      }
    });
    var hr = /<script|<style|<link/i, pr = /checked\s*(?:[^=]|=\s*.checked.)/i, gr = /^\s*<!\[CDATA\[|\]\]>\s*$/g;
    function Zn(e, t) {
      return le(e, "table") && le(t.nodeType !== 11 ? t : t.firstChild, "tr") && s(e).children("tbody")[0] || e;
    }
    function yr(e) {
      return e.type = (e.getAttribute("type") !== null) + "/" + e.type, e;
    }
    function br(e) {
      return (e.type || "").slice(0, 5) === "true/" ? e.type = e.type.slice(5) : e.removeAttribute("type"), e;
    }
    function ei(e, t) {
      var n, i, a, o, l, p, d;
      if (t.nodeType === 1) {
        if (V.hasData(e) && (o = V.get(e), d = o.events, d)) {
          V.remove(t, "handle events");
          for (a in d)
            for (n = 0, i = d[a].length; n < i; n++)
              s.event.add(t, a, d[a][n]);
        }
        De.hasData(e) && (l = De.access(e), p = s.extend({}, l), De.set(t, p));
      }
    }
    function vr(e, t) {
      var n = t.nodeName.toLowerCase();
      n === "input" && At.test(e.type) ? t.checked = e.checked : (n === "input" || n === "textarea") && (t.defaultValue = e.defaultValue);
    }
    function St(e, t, n, i) {
      t = w(t);
      var a, o, l, p, d, b, m = 0, L = e.length, v = L - 1, D = t[0], j = G(D);
      if (j || L > 1 && typeof D == "string" && !te.checkClone && pr.test(D))
        return e.each(function(Y) {
          var F = e.eq(Y);
          j && (t[0] = D.call(this, Y, F.html())), St(F, t, n, i);
        });
      if (L && (a = Jn(t, e[0].ownerDocument, !1, e, i), o = a.firstChild, a.childNodes.length === 1 && (a = o), o || i)) {
        for (l = s.map(Ee(a, "script"), yr), p = l.length; m < L; m++)
          d = a, m !== v && (d = s.clone(d, !0, !0), p && s.merge(l, Ee(d, "script"))), n.call(e[m], d, m);
        if (p)
          for (b = l[l.length - 1].ownerDocument, s.map(l, br), m = 0; m < p; m++)
            d = l[m], Yn.test(d.type || "") && !V.access(d, "globalEval") && s.contains(b, d) && (d.src && (d.type || "").toLowerCase() !== "module" ? s._evalUrl && !d.noModule && s._evalUrl(d.src, {
              nonce: d.nonce || d.getAttribute("nonce")
            }, b) : We(d.textContent.replace(gr, ""), d, b));
      }
      return e;
    }
    function ti(e, t, n) {
      for (var i, a = t ? s.filter(t, e) : e, o = 0; (i = a[o]) != null; o++)
        !n && i.nodeType === 1 && s.cleanData(Ee(i)), i.parentNode && (n && kt(i) && gn(Ee(i, "script")), i.parentNode.removeChild(i));
      return e;
    }
    s.extend({
      htmlPrefilter: function(e) {
        return e;
      },
      clone: function(e, t, n) {
        var i, a, o, l, p = e.cloneNode(!0), d = kt(e);
        if (!te.noCloneChecked && (e.nodeType === 1 || e.nodeType === 11) && !s.isXMLDoc(e))
          for (l = Ee(p), o = Ee(e), i = 0, a = o.length; i < a; i++)
            vr(o[i], l[i]);
        if (t)
          if (n)
            for (o = o || Ee(e), l = l || Ee(p), i = 0, a = o.length; i < a; i++)
              ei(o[i], l[i]);
          else
            ei(e, p);
        return l = Ee(p, "script"), l.length > 0 && gn(l, !d && Ee(e, "script")), p;
      },
      cleanData: function(e) {
        for (var t, n, i, a = s.event.special, o = 0; (n = e[o]) !== void 0; o++)
          if (xt(n)) {
            if (t = n[V.expando]) {
              if (t.events)
                for (i in t.events)
                  a[i] ? s.event.remove(n, i) : s.removeEvent(n, i, t.handle);
              n[V.expando] = void 0;
            }
            n[De.expando] && (n[De.expando] = void 0);
          }
      }
    }), s.fn.extend({
      detach: function(e) {
        return ti(this, e, !0);
      },
      remove: function(e) {
        return ti(this, e);
      },
      text: function(e) {
        return Ke(this, function(t) {
          return t === void 0 ? s.text(this) : this.empty().each(function() {
            (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) && (this.textContent = t);
          });
        }, null, e, arguments.length);
      },
      append: function() {
        return St(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Zn(this, e);
            t.appendChild(e);
          }
        });
      },
      prepend: function() {
        return St(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Zn(this, e);
            t.insertBefore(e, t.firstChild);
          }
        });
      },
      before: function() {
        return St(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this);
        });
      },
      after: function() {
        return St(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this.nextSibling);
        });
      },
      empty: function() {
        for (var e, t = 0; (e = this[t]) != null; t++)
          e.nodeType === 1 && (s.cleanData(Ee(e, !1)), e.textContent = "");
        return this;
      },
      clone: function(e, t) {
        return e = e == null ? !1 : e, t = t == null ? e : t, this.map(function() {
          return s.clone(this, e, t);
        });
      },
      html: function(e) {
        return Ke(this, function(t) {
          var n = this[0] || {}, i = 0, a = this.length;
          if (t === void 0 && n.nodeType === 1)
            return n.innerHTML;
          if (typeof t == "string" && !hr.test(t) && !je[(Xn.exec(t) || ["", ""])[1].toLowerCase()]) {
            t = s.htmlPrefilter(t);
            try {
              for (; i < a; i++)
                n = this[i] || {}, n.nodeType === 1 && (s.cleanData(Ee(n, !1)), n.innerHTML = t);
              n = 0;
            } catch {
            }
          }
          n && this.empty().append(t);
        }, null, e, arguments.length);
      },
      replaceWith: function() {
        var e = [];
        return St(this, arguments, function(t) {
          var n = this.parentNode;
          s.inArray(this, e) < 0 && (s.cleanData(Ee(this)), n && n.replaceChild(t, this));
        }, e);
      }
    }), s.each({
      appendTo: "append",
      prependTo: "prepend",
      insertBefore: "before",
      insertAfter: "after",
      replaceAll: "replaceWith"
    }, function(e, t) {
      s.fn[e] = function(n) {
        for (var i, a = [], o = s(n), l = o.length - 1, p = 0; p <= l; p++)
          i = p === l ? this : this.clone(!0), s(o[p])[t](i), T.apply(a, i.get());
        return this.pushStack(a);
      };
    });
    var bn = new RegExp("^(" + Un + ")(?!px)[a-z%]+$", "i"), vn = /^--/, Zt = function(e) {
      var t = e.ownerDocument.defaultView;
      return (!t || !t.opener) && (t = f), t.getComputedStyle(e);
    }, ni = function(e, t, n) {
      var i, a, o = {};
      for (a in t)
        o[a] = e.style[a], e.style[a] = t[a];
      i = n.call(e);
      for (a in t)
        e.style[a] = o[a];
      return i;
    }, mr = new RegExp(Ze.join("|"), "i"), ii = "[\\x20\\t\\r\\n\\f]", kr = new RegExp(
      "^" + ii + "+|((?:^|[^\\\\])(?:\\\\.)*)" + ii + "+$",
      "g"
    );
    (function() {
      function e() {
        if (!!b) {
          d.style.cssText = "position:absolute;left:-11111px;width:60px;margin-top:1px;padding:0;border:0", b.style.cssText = "position:relative;display:block;box-sizing:border-box;overflow:scroll;margin:auto;border:1px;padding:1px;width:60%;top:1%", lt.appendChild(d).appendChild(b);
          var m = f.getComputedStyle(b);
          n = m.top !== "1%", p = t(m.marginLeft) === 12, b.style.right = "60%", o = t(m.right) === 36, i = t(m.width) === 36, b.style.position = "absolute", a = t(b.offsetWidth / 3) === 12, lt.removeChild(d), b = null;
        }
      }
      function t(m) {
        return Math.round(parseFloat(m));
      }
      var n, i, a, o, l, p, d = K.createElement("div"), b = K.createElement("div");
      !b.style || (b.style.backgroundClip = "content-box", b.cloneNode(!0).style.backgroundClip = "", te.clearCloneStyle = b.style.backgroundClip === "content-box", s.extend(te, {
        boxSizingReliable: function() {
          return e(), i;
        },
        pixelBoxStyles: function() {
          return e(), o;
        },
        pixelPosition: function() {
          return e(), n;
        },
        reliableMarginLeft: function() {
          return e(), p;
        },
        scrollboxSize: function() {
          return e(), a;
        },
        reliableTrDimensions: function() {
          var m, L, v, D;
          return l == null && (m = K.createElement("table"), L = K.createElement("tr"), v = K.createElement("div"), m.style.cssText = "position:absolute;left:-11111px;border-collapse:separate", L.style.cssText = "border:1px solid", L.style.height = "1px", v.style.height = "9px", v.style.display = "block", lt.appendChild(m).appendChild(L).appendChild(v), D = f.getComputedStyle(L), l = parseInt(D.height, 10) + parseInt(D.borderTopWidth, 10) + parseInt(D.borderBottomWidth, 10) === L.offsetHeight, lt.removeChild(m)), l;
        }
      }));
    })();
    function Pt(e, t, n) {
      var i, a, o, l, p = vn.test(t), d = e.style;
      return n = n || Zt(e), n && (l = n.getPropertyValue(t) || n[t], p && (l = l.replace(kr, "$1")), l === "" && !kt(e) && (l = s.style(e, t)), !te.pixelBoxStyles() && bn.test(l) && mr.test(t) && (i = d.width, a = d.minWidth, o = d.maxWidth, d.minWidth = d.maxWidth = d.width = l, l = n.width, d.width = i, d.minWidth = a, d.maxWidth = o)), l !== void 0 ? l + "" : l;
    }
    function ri(e, t) {
      return {
        get: function() {
          if (e()) {
            delete this.get;
            return;
          }
          return (this.get = t).apply(this, arguments);
        }
      };
    }
    var si = ["Webkit", "Moz", "ms"], ai = K.createElement("div").style, oi = {};
    function wr(e) {
      for (var t = e[0].toUpperCase() + e.slice(1), n = si.length; n--; )
        if (e = si[n] + t, e in ai)
          return e;
    }
    function mn(e) {
      var t = s.cssProps[e] || oi[e];
      return t || (e in ai ? e : oi[e] = wr(e) || e);
    }
    var Tr = /^(none|table(?!-c[ea]).+)/, Cr = { position: "absolute", visibility: "hidden", display: "block" }, li = {
      letterSpacing: "0",
      fontWeight: "400"
    };
    function ui(e, t, n) {
      var i = Ot.exec(t);
      return i ? Math.max(0, i[2] - (n || 0)) + (i[3] || "px") : t;
    }
    function kn(e, t, n, i, a, o) {
      var l = t === "width" ? 1 : 0, p = 0, d = 0;
      if (n === (i ? "border" : "content"))
        return 0;
      for (; l < 4; l += 2)
        n === "margin" && (d += s.css(e, n + Ze[l], !0, a)), i ? (n === "content" && (d -= s.css(e, "padding" + Ze[l], !0, a)), n !== "margin" && (d -= s.css(e, "border" + Ze[l] + "Width", !0, a))) : (d += s.css(e, "padding" + Ze[l], !0, a), n !== "padding" ? d += s.css(e, "border" + Ze[l] + "Width", !0, a) : p += s.css(e, "border" + Ze[l] + "Width", !0, a));
      return !i && o >= 0 && (d += Math.max(0, Math.ceil(
        e["offset" + t[0].toUpperCase() + t.slice(1)] - o - d - p - 0.5
      )) || 0), d;
    }
    function ci(e, t, n) {
      var i = Zt(e), a = !te.boxSizingReliable() || n, o = a && s.css(e, "boxSizing", !1, i) === "border-box", l = o, p = Pt(e, t, i), d = "offset" + t[0].toUpperCase() + t.slice(1);
      if (bn.test(p)) {
        if (!n)
          return p;
        p = "auto";
      }
      return (!te.boxSizingReliable() && o || !te.reliableTrDimensions() && le(e, "tr") || p === "auto" || !parseFloat(p) && s.css(e, "display", !1, i) === "inline") && e.getClientRects().length && (o = s.css(e, "boxSizing", !1, i) === "border-box", l = d in e, l && (p = e[d])), p = parseFloat(p) || 0, p + kn(
        e,
        t,
        n || (o ? "border" : "content"),
        l,
        i,
        p
      ) + "px";
    }
    s.extend({
      cssHooks: {
        opacity: {
          get: function(e, t) {
            if (t) {
              var n = Pt(e, "opacity");
              return n === "" ? "1" : n;
            }
          }
        }
      },
      cssNumber: {
        animationIterationCount: !0,
        columnCount: !0,
        fillOpacity: !0,
        flexGrow: !0,
        flexShrink: !0,
        fontWeight: !0,
        gridArea: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnStart: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowStart: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0
      },
      cssProps: {},
      style: function(e, t, n, i) {
        if (!(!e || e.nodeType === 3 || e.nodeType === 8 || !e.style)) {
          var a, o, l, p = Ge(t), d = vn.test(t), b = e.style;
          if (d || (t = mn(p)), l = s.cssHooks[t] || s.cssHooks[p], n !== void 0) {
            if (o = typeof n, o === "string" && (a = Ot.exec(n)) && a[1] && (n = Gn(e, t, a), o = "number"), n == null || n !== n)
              return;
            o === "number" && !d && (n += a && a[3] || (s.cssNumber[p] ? "" : "px")), !te.clearCloneStyle && n === "" && t.indexOf("background") === 0 && (b[t] = "inherit"), (!l || !("set" in l) || (n = l.set(e, n, i)) !== void 0) && (d ? b.setProperty(t, n) : b[t] = n);
          } else
            return l && "get" in l && (a = l.get(e, !1, i)) !== void 0 ? a : b[t];
        }
      },
      css: function(e, t, n, i) {
        var a, o, l, p = Ge(t), d = vn.test(t);
        return d || (t = mn(p)), l = s.cssHooks[t] || s.cssHooks[p], l && "get" in l && (a = l.get(e, !0, n)), a === void 0 && (a = Pt(e, t, i)), a === "normal" && t in li && (a = li[t]), n === "" || n ? (o = parseFloat(a), n === !0 || isFinite(o) ? o || 0 : a) : a;
      }
    }), s.each(["height", "width"], function(e, t) {
      s.cssHooks[t] = {
        get: function(n, i, a) {
          if (i)
            return Tr.test(s.css(n, "display")) && (!n.getClientRects().length || !n.getBoundingClientRect().width) ? ni(n, Cr, function() {
              return ci(n, t, a);
            }) : ci(n, t, a);
        },
        set: function(n, i, a) {
          var o, l = Zt(n), p = !te.scrollboxSize() && l.position === "absolute", d = p || a, b = d && s.css(n, "boxSizing", !1, l) === "border-box", m = a ? kn(
            n,
            t,
            a,
            b,
            l
          ) : 0;
          return b && p && (m -= Math.ceil(
            n["offset" + t[0].toUpperCase() + t.slice(1)] - parseFloat(l[t]) - kn(n, t, "border", !1, l) - 0.5
          )), m && (o = Ot.exec(i)) && (o[3] || "px") !== "px" && (n.style[t] = i, i = s.css(n, t)), ui(n, i, m);
        }
      };
    }), s.cssHooks.marginLeft = ri(
      te.reliableMarginLeft,
      function(e, t) {
        if (t)
          return (parseFloat(Pt(e, "marginLeft")) || e.getBoundingClientRect().left - ni(e, { marginLeft: 0 }, function() {
            return e.getBoundingClientRect().left;
          })) + "px";
      }
    ), s.each({
      margin: "",
      padding: "",
      border: "Width"
    }, function(e, t) {
      s.cssHooks[e + t] = {
        expand: function(n) {
          for (var i = 0, a = {}, o = typeof n == "string" ? n.split(" ") : [n]; i < 4; i++)
            a[e + Ze[i] + t] = o[i] || o[i - 2] || o[0];
          return a;
        }
      }, e !== "margin" && (s.cssHooks[e + t].set = ui);
    }), s.fn.extend({
      css: function(e, t) {
        return Ke(this, function(n, i, a) {
          var o, l, p = {}, d = 0;
          if (Array.isArray(i)) {
            for (o = Zt(n), l = i.length; d < l; d++)
              p[i[d]] = s.css(n, i[d], !1, o);
            return p;
          }
          return a !== void 0 ? s.style(n, i, a) : s.css(n, i);
        }, e, t, arguments.length > 1);
      }
    });
    function Ne(e, t, n, i, a) {
      return new Ne.prototype.init(e, t, n, i, a);
    }
    s.Tween = Ne, Ne.prototype = {
      constructor: Ne,
      init: function(e, t, n, i, a, o) {
        this.elem = e, this.prop = n, this.easing = a || s.easing._default, this.options = t, this.start = this.now = this.cur(), this.end = i, this.unit = o || (s.cssNumber[n] ? "" : "px");
      },
      cur: function() {
        var e = Ne.propHooks[this.prop];
        return e && e.get ? e.get(this) : Ne.propHooks._default.get(this);
      },
      run: function(e) {
        var t, n = Ne.propHooks[this.prop];
        return this.options.duration ? this.pos = t = s.easing[this.easing](
          e,
          this.options.duration * e,
          0,
          1,
          this.options.duration
        ) : this.pos = t = e, this.now = (this.end - this.start) * t + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), n && n.set ? n.set(this) : Ne.propHooks._default.set(this), this;
      }
    }, Ne.prototype.init.prototype = Ne.prototype, Ne.propHooks = {
      _default: {
        get: function(e) {
          var t;
          return e.elem.nodeType !== 1 || e.elem[e.prop] != null && e.elem.style[e.prop] == null ? e.elem[e.prop] : (t = s.css(e.elem, e.prop, ""), !t || t === "auto" ? 0 : t);
        },
        set: function(e) {
          s.fx.step[e.prop] ? s.fx.step[e.prop](e) : e.elem.nodeType === 1 && (s.cssHooks[e.prop] || e.elem.style[mn(e.prop)] != null) ? s.style(e.elem, e.prop, e.now + e.unit) : e.elem[e.prop] = e.now;
        }
      }
    }, Ne.propHooks.scrollTop = Ne.propHooks.scrollLeft = {
      set: function(e) {
        e.elem.nodeType && e.elem.parentNode && (e.elem[e.prop] = e.now);
      }
    }, s.easing = {
      linear: function(e) {
        return e;
      },
      swing: function(e) {
        return 0.5 - Math.cos(e * Math.PI) / 2;
      },
      _default: "swing"
    }, s.fx = Ne.prototype.init, s.fx.step = {};
    var _t, en, Sr = /^(?:toggle|show|hide)$/, _r = /queueHooks$/;
    function wn() {
      en && (K.hidden === !1 && f.requestAnimationFrame ? f.requestAnimationFrame(wn) : f.setTimeout(wn, s.fx.interval), s.fx.tick());
    }
    function fi() {
      return f.setTimeout(function() {
        _t = void 0;
      }), _t = Date.now();
    }
    function tn(e, t) {
      var n, i = 0, a = { height: e };
      for (t = t ? 1 : 0; i < 4; i += 2 - t)
        n = Ze[i], a["margin" + n] = a["padding" + n] = e;
      return t && (a.opacity = a.width = e), a;
    }
    function di(e, t, n) {
      for (var i, a = (Me.tweeners[t] || []).concat(Me.tweeners["*"]), o = 0, l = a.length; o < l; o++)
        if (i = a[o].call(n, t, e))
          return i;
    }
    function Dr(e, t, n) {
      var i, a, o, l, p, d, b, m, L = "width" in t || "height" in t, v = this, D = {}, j = e.style, Y = e.nodeType && Jt(e), F = V.get(e, "fxshow");
      n.queue || (l = s._queueHooks(e, "fx"), l.unqueued == null && (l.unqueued = 0, p = l.empty.fire, l.empty.fire = function() {
        l.unqueued || p();
      }), l.unqueued++, v.always(function() {
        v.always(function() {
          l.unqueued--, s.queue(e, "fx").length || l.empty.fire();
        });
      }));
      for (i in t)
        if (a = t[i], Sr.test(a)) {
          if (delete t[i], o = o || a === "toggle", a === (Y ? "hide" : "show"))
            if (a === "show" && F && F[i] !== void 0)
              Y = !0;
            else
              continue;
          D[i] = F && F[i] || s.style(e, i);
        }
      if (d = !s.isEmptyObject(t), !(!d && s.isEmptyObject(D))) {
        L && e.nodeType === 1 && (n.overflow = [j.overflow, j.overflowX, j.overflowY], b = F && F.display, b == null && (b = V.get(e, "display")), m = s.css(e, "display"), m === "none" && (b ? m = b : (wt([e], !0), b = e.style.display || b, m = s.css(e, "display"), wt([e]))), (m === "inline" || m === "inline-block" && b != null) && s.css(e, "float") === "none" && (d || (v.done(function() {
          j.display = b;
        }), b == null && (m = j.display, b = m === "none" ? "" : m)), j.display = "inline-block")), n.overflow && (j.overflow = "hidden", v.always(function() {
          j.overflow = n.overflow[0], j.overflowX = n.overflow[1], j.overflowY = n.overflow[2];
        })), d = !1;
        for (i in D)
          d || (F ? "hidden" in F && (Y = F.hidden) : F = V.access(e, "fxshow", { display: b }), o && (F.hidden = !Y), Y && wt([e], !0), v.done(function() {
            Y || wt([e]), V.remove(e, "fxshow");
            for (i in D)
              s.style(e, i, D[i]);
          })), d = di(Y ? F[i] : 0, i, v), i in F || (F[i] = d.start, Y && (d.end = d.start, d.start = 0));
      }
    }
    function Er(e, t) {
      var n, i, a, o, l;
      for (n in e)
        if (i = Ge(n), a = t[i], o = e[n], Array.isArray(o) && (a = o[1], o = e[n] = o[0]), n !== i && (e[i] = o, delete e[n]), l = s.cssHooks[i], l && "expand" in l) {
          o = l.expand(o), delete e[i];
          for (n in o)
            n in e || (e[n] = o[n], t[n] = a);
        } else
          t[i] = a;
    }
    function Me(e, t, n) {
      var i, a, o = 0, l = Me.prefilters.length, p = s.Deferred().always(function() {
        delete d.elem;
      }), d = function() {
        if (a)
          return !1;
        for (var L = _t || fi(), v = Math.max(0, b.startTime + b.duration - L), D = v / b.duration || 0, j = 1 - D, Y = 0, F = b.tweens.length; Y < F; Y++)
          b.tweens[Y].run(j);
        return p.notifyWith(e, [b, j, v]), j < 1 && F ? v : (F || p.notifyWith(e, [b, 1, 0]), p.resolveWith(e, [b]), !1);
      }, b = p.promise({
        elem: e,
        props: s.extend({}, t),
        opts: s.extend(!0, {
          specialEasing: {},
          easing: s.easing._default
        }, n),
        originalProperties: t,
        originalOptions: n,
        startTime: _t || fi(),
        duration: n.duration,
        tweens: [],
        createTween: function(L, v) {
          var D = s.Tween(
            e,
            b.opts,
            L,
            v,
            b.opts.specialEasing[L] || b.opts.easing
          );
          return b.tweens.push(D), D;
        },
        stop: function(L) {
          var v = 0, D = L ? b.tweens.length : 0;
          if (a)
            return this;
          for (a = !0; v < D; v++)
            b.tweens[v].run(1);
          return L ? (p.notifyWith(e, [b, 1, 0]), p.resolveWith(e, [b, L])) : p.rejectWith(e, [b, L]), this;
        }
      }), m = b.props;
      for (Er(m, b.opts.specialEasing); o < l; o++)
        if (i = Me.prefilters[o].call(b, e, m, b.opts), i)
          return G(i.stop) && (s._queueHooks(b.elem, b.opts.queue).stop = i.stop.bind(i)), i;
      return s.map(m, di, b), G(b.opts.start) && b.opts.start.call(e, b), b.progress(b.opts.progress).done(b.opts.done, b.opts.complete).fail(b.opts.fail).always(b.opts.always), s.fx.timer(
        s.extend(d, {
          elem: e,
          anim: b,
          queue: b.opts.queue
        })
      ), b;
    }
    s.Animation = s.extend(Me, {
      tweeners: {
        "*": [function(e, t) {
          var n = this.createTween(e, t);
          return Gn(n.elem, e, Ot.exec(t), n), n;
        }]
      },
      tweener: function(e, t) {
        G(e) ? (t = e, e = ["*"]) : e = e.match(Ue);
        for (var n, i = 0, a = e.length; i < a; i++)
          n = e[i], Me.tweeners[n] = Me.tweeners[n] || [], Me.tweeners[n].unshift(t);
      },
      prefilters: [Dr],
      prefilter: function(e, t) {
        t ? Me.prefilters.unshift(e) : Me.prefilters.push(e);
      }
    }), s.speed = function(e, t, n) {
      var i = e && typeof e == "object" ? s.extend({}, e) : {
        complete: n || !n && t || G(e) && e,
        duration: e,
        easing: n && t || t && !G(t) && t
      };
      return s.fx.off ? i.duration = 0 : typeof i.duration != "number" && (i.duration in s.fx.speeds ? i.duration = s.fx.speeds[i.duration] : i.duration = s.fx.speeds._default), (i.queue == null || i.queue === !0) && (i.queue = "fx"), i.old = i.complete, i.complete = function() {
        G(i.old) && i.old.call(this), i.queue && s.dequeue(this, i.queue);
      }, i;
    }, s.fn.extend({
      fadeTo: function(e, t, n, i) {
        return this.filter(Jt).css("opacity", 0).show().end().animate({ opacity: t }, e, n, i);
      },
      animate: function(e, t, n, i) {
        var a = s.isEmptyObject(e), o = s.speed(t, n, i), l = function() {
          var p = Me(this, s.extend({}, e), o);
          (a || V.get(this, "finish")) && p.stop(!0);
        };
        return l.finish = l, a || o.queue === !1 ? this.each(l) : this.queue(o.queue, l);
      },
      stop: function(e, t, n) {
        var i = function(a) {
          var o = a.stop;
          delete a.stop, o(n);
        };
        return typeof e != "string" && (n = t, t = e, e = void 0), t && this.queue(e || "fx", []), this.each(function() {
          var a = !0, o = e != null && e + "queueHooks", l = s.timers, p = V.get(this);
          if (o)
            p[o] && p[o].stop && i(p[o]);
          else
            for (o in p)
              p[o] && p[o].stop && _r.test(o) && i(p[o]);
          for (o = l.length; o--; )
            l[o].elem === this && (e == null || l[o].queue === e) && (l[o].anim.stop(n), a = !1, l.splice(o, 1));
          (a || !n) && s.dequeue(this, e);
        });
      },
      finish: function(e) {
        return e !== !1 && (e = e || "fx"), this.each(function() {
          var t, n = V.get(this), i = n[e + "queue"], a = n[e + "queueHooks"], o = s.timers, l = i ? i.length : 0;
          for (n.finish = !0, s.queue(this, e, []), a && a.stop && a.stop.call(this, !0), t = o.length; t--; )
            o[t].elem === this && o[t].queue === e && (o[t].anim.stop(!0), o.splice(t, 1));
          for (t = 0; t < l; t++)
            i[t] && i[t].finish && i[t].finish.call(this);
          delete n.finish;
        });
      }
    }), s.each(["toggle", "show", "hide"], function(e, t) {
      var n = s.fn[t];
      s.fn[t] = function(i, a, o) {
        return i == null || typeof i == "boolean" ? n.apply(this, arguments) : this.animate(tn(t, !0), i, a, o);
      };
    }), s.each({
      slideDown: tn("show"),
      slideUp: tn("hide"),
      slideToggle: tn("toggle"),
      fadeIn: { opacity: "show" },
      fadeOut: { opacity: "hide" },
      fadeToggle: { opacity: "toggle" }
    }, function(e, t) {
      s.fn[e] = function(n, i, a) {
        return this.animate(t, n, i, a);
      };
    }), s.timers = [], s.fx.tick = function() {
      var e, t = 0, n = s.timers;
      for (_t = Date.now(); t < n.length; t++)
        e = n[t], !e() && n[t] === e && n.splice(t--, 1);
      n.length || s.fx.stop(), _t = void 0;
    }, s.fx.timer = function(e) {
      s.timers.push(e), s.fx.start();
    }, s.fx.interval = 13, s.fx.start = function() {
      en || (en = !0, wn());
    }, s.fx.stop = function() {
      en = null;
    }, s.fx.speeds = {
      slow: 600,
      fast: 200,
      _default: 400
    }, s.fn.delay = function(e, t) {
      return e = s.fx && s.fx.speeds[e] || e, t = t || "fx", this.queue(t, function(n, i) {
        var a = f.setTimeout(n, e);
        i.stop = function() {
          f.clearTimeout(a);
        };
      });
    }, function() {
      var e = K.createElement("input"), t = K.createElement("select"), n = t.appendChild(K.createElement("option"));
      e.type = "checkbox", te.checkOn = e.value !== "", te.optSelected = n.selected, e = K.createElement("input"), e.value = "t", e.type = "radio", te.radioValue = e.value === "t";
    }();
    var hi, qt = s.expr.attrHandle;
    s.fn.extend({
      attr: function(e, t) {
        return Ke(this, s.attr, e, t, arguments.length > 1);
      },
      removeAttr: function(e) {
        return this.each(function() {
          s.removeAttr(this, e);
        });
      }
    }), s.extend({
      attr: function(e, t, n) {
        var i, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2)) {
          if (typeof e.getAttribute > "u")
            return s.prop(e, t, n);
          if ((o !== 1 || !s.isXMLDoc(e)) && (a = s.attrHooks[t.toLowerCase()] || (s.expr.match.bool.test(t) ? hi : void 0)), n !== void 0) {
            if (n === null) {
              s.removeAttr(e, t);
              return;
            }
            return a && "set" in a && (i = a.set(e, n, t)) !== void 0 ? i : (e.setAttribute(t, n + ""), n);
          }
          return a && "get" in a && (i = a.get(e, t)) !== null ? i : (i = s.find.attr(e, t), i == null ? void 0 : i);
        }
      },
      attrHooks: {
        type: {
          set: function(e, t) {
            if (!te.radioValue && t === "radio" && le(e, "input")) {
              var n = e.value;
              return e.setAttribute("type", t), n && (e.value = n), t;
            }
          }
        }
      },
      removeAttr: function(e, t) {
        var n, i = 0, a = t && t.match(Ue);
        if (a && e.nodeType === 1)
          for (; n = a[i++]; )
            e.removeAttribute(n);
      }
    }), hi = {
      set: function(e, t, n) {
        return t === !1 ? s.removeAttr(e, n) : e.setAttribute(n, n), n;
      }
    }, s.each(s.expr.match.bool.source.match(/\w+/g), function(e, t) {
      var n = qt[t] || s.find.attr;
      qt[t] = function(i, a, o) {
        var l, p, d = a.toLowerCase();
        return o || (p = qt[d], qt[d] = l, l = n(i, a, o) != null ? d : null, qt[d] = p), l;
      };
    });
    var Nr = /^(?:input|select|textarea|button)$/i, xr = /^(?:a|area)$/i;
    s.fn.extend({
      prop: function(e, t) {
        return Ke(this, s.prop, e, t, arguments.length > 1);
      },
      removeProp: function(e) {
        return this.each(function() {
          delete this[s.propFix[e] || e];
        });
      }
    }), s.extend({
      prop: function(e, t, n) {
        var i, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2))
          return (o !== 1 || !s.isXMLDoc(e)) && (t = s.propFix[t] || t, a = s.propHooks[t]), n !== void 0 ? a && "set" in a && (i = a.set(e, n, t)) !== void 0 ? i : e[t] = n : a && "get" in a && (i = a.get(e, t)) !== null ? i : e[t];
      },
      propHooks: {
        tabIndex: {
          get: function(e) {
            var t = s.find.attr(e, "tabindex");
            return t ? parseInt(t, 10) : Nr.test(e.nodeName) || xr.test(e.nodeName) && e.href ? 0 : -1;
          }
        }
      },
      propFix: {
        for: "htmlFor",
        class: "className"
      }
    }), te.optSelected || (s.propHooks.selected = {
      get: function(e) {
        var t = e.parentNode;
        return t && t.parentNode && t.parentNode.selectedIndex, null;
      },
      set: function(e) {
        var t = e.parentNode;
        t && (t.selectedIndex, t.parentNode && t.parentNode.selectedIndex);
      }
    }), s.each([
      "tabIndex",
      "readOnly",
      "maxLength",
      "cellSpacing",
      "cellPadding",
      "rowSpan",
      "colSpan",
      "useMap",
      "frameBorder",
      "contentEditable"
    ], function() {
      s.propFix[this.toLowerCase()] = this;
    });
    function ut(e) {
      var t = e.match(Ue) || [];
      return t.join(" ");
    }
    function ct(e) {
      return e.getAttribute && e.getAttribute("class") || "";
    }
    function Tn(e) {
      return Array.isArray(e) ? e : typeof e == "string" ? e.match(Ue) || [] : [];
    }
    s.fn.extend({
      addClass: function(e) {
        var t, n, i, a, o, l;
        return G(e) ? this.each(function(p) {
          s(this).addClass(e.call(this, p, ct(this)));
        }) : (t = Tn(e), t.length ? this.each(function() {
          if (i = ct(this), n = this.nodeType === 1 && " " + ut(i) + " ", n) {
            for (o = 0; o < t.length; o++)
              a = t[o], n.indexOf(" " + a + " ") < 0 && (n += a + " ");
            l = ut(n), i !== l && this.setAttribute("class", l);
          }
        }) : this);
      },
      removeClass: function(e) {
        var t, n, i, a, o, l;
        return G(e) ? this.each(function(p) {
          s(this).removeClass(e.call(this, p, ct(this)));
        }) : arguments.length ? (t = Tn(e), t.length ? this.each(function() {
          if (i = ct(this), n = this.nodeType === 1 && " " + ut(i) + " ", n) {
            for (o = 0; o < t.length; o++)
              for (a = t[o]; n.indexOf(" " + a + " ") > -1; )
                n = n.replace(" " + a + " ", " ");
            l = ut(n), i !== l && this.setAttribute("class", l);
          }
        }) : this) : this.attr("class", "");
      },
      toggleClass: function(e, t) {
        var n, i, a, o, l = typeof e, p = l === "string" || Array.isArray(e);
        return G(e) ? this.each(function(d) {
          s(this).toggleClass(
            e.call(this, d, ct(this), t),
            t
          );
        }) : typeof t == "boolean" && p ? t ? this.addClass(e) : this.removeClass(e) : (n = Tn(e), this.each(function() {
          if (p)
            for (o = s(this), a = 0; a < n.length; a++)
              i = n[a], o.hasClass(i) ? o.removeClass(i) : o.addClass(i);
          else
            (e === void 0 || l === "boolean") && (i = ct(this), i && V.set(this, "__className__", i), this.setAttribute && this.setAttribute(
              "class",
              i || e === !1 ? "" : V.get(this, "__className__") || ""
            ));
        }));
      },
      hasClass: function(e) {
        var t, n, i = 0;
        for (t = " " + e + " "; n = this[i++]; )
          if (n.nodeType === 1 && (" " + ut(ct(n)) + " ").indexOf(t) > -1)
            return !0;
        return !1;
      }
    });
    var Lr = /\r/g;
    s.fn.extend({
      val: function(e) {
        var t, n, i, a = this[0];
        return arguments.length ? (i = G(e), this.each(function(o) {
          var l;
          this.nodeType === 1 && (i ? l = e.call(this, o, s(this).val()) : l = e, l == null ? l = "" : typeof l == "number" ? l += "" : Array.isArray(l) && (l = s.map(l, function(p) {
            return p == null ? "" : p + "";
          })), t = s.valHooks[this.type] || s.valHooks[this.nodeName.toLowerCase()], (!t || !("set" in t) || t.set(this, l, "value") === void 0) && (this.value = l));
        })) : a ? (t = s.valHooks[a.type] || s.valHooks[a.nodeName.toLowerCase()], t && "get" in t && (n = t.get(a, "value")) !== void 0 ? n : (n = a.value, typeof n == "string" ? n.replace(Lr, "") : n == null ? "" : n)) : void 0;
      }
    }), s.extend({
      valHooks: {
        option: {
          get: function(e) {
            var t = s.find.attr(e, "value");
            return t != null ? t : ut(s.text(e));
          }
        },
        select: {
          get: function(e) {
            var t, n, i, a = e.options, o = e.selectedIndex, l = e.type === "select-one", p = l ? null : [], d = l ? o + 1 : a.length;
            for (o < 0 ? i = d : i = l ? o : 0; i < d; i++)
              if (n = a[i], (n.selected || i === o) && !n.disabled && (!n.parentNode.disabled || !le(n.parentNode, "optgroup"))) {
                if (t = s(n).val(), l)
                  return t;
                p.push(t);
              }
            return p;
          },
          set: function(e, t) {
            for (var n, i, a = e.options, o = s.makeArray(t), l = a.length; l--; )
              i = a[l], (i.selected = s.inArray(s.valHooks.option.get(i), o) > -1) && (n = !0);
            return n || (e.selectedIndex = -1), o;
          }
        }
      }
    }), s.each(["radio", "checkbox"], function() {
      s.valHooks[this] = {
        set: function(e, t) {
          if (Array.isArray(t))
            return e.checked = s.inArray(s(e).val(), t) > -1;
        }
      }, te.checkOn || (s.valHooks[this].get = function(e) {
        return e.getAttribute("value") === null ? "on" : e.value;
      });
    }), te.focusin = "onfocusin" in f;
    var pi = /^(?:focusinfocus|focusoutblur)$/, gi = function(e) {
      e.stopPropagation();
    };
    s.extend(s.event, {
      trigger: function(e, t, n, i) {
        var a, o, l, p, d, b, m, L, v = [n || K], D = se.call(e, "type") ? e.type : e, j = se.call(e, "namespace") ? e.namespace.split(".") : [];
        if (o = L = l = n = n || K, !(n.nodeType === 3 || n.nodeType === 8) && !pi.test(D + s.event.triggered) && (D.indexOf(".") > -1 && (j = D.split("."), D = j.shift(), j.sort()), d = D.indexOf(":") < 0 && "on" + D, e = e[s.expando] ? e : new s.Event(D, typeof e == "object" && e), e.isTrigger = i ? 2 : 3, e.namespace = j.join("."), e.rnamespace = e.namespace ? new RegExp("(^|\\.)" + j.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, e.result = void 0, e.target || (e.target = n), t = t == null ? [e] : s.makeArray(t, [e]), m = s.event.special[D] || {}, !(!i && m.trigger && m.trigger.apply(n, t) === !1))) {
          if (!i && !m.noBubble && !Oe(n)) {
            for (p = m.delegateType || D, pi.test(p + D) || (o = o.parentNode); o; o = o.parentNode)
              v.push(o), l = o;
            l === (n.ownerDocument || K) && v.push(l.defaultView || l.parentWindow || f);
          }
          for (a = 0; (o = v[a++]) && !e.isPropagationStopped(); )
            L = o, e.type = a > 1 ? p : m.bindType || D, b = (V.get(o, "events") || /* @__PURE__ */ Object.create(null))[e.type] && V.get(o, "handle"), b && b.apply(o, t), b = d && o[d], b && b.apply && xt(o) && (e.result = b.apply(o, t), e.result === !1 && e.preventDefault());
          return e.type = D, !i && !e.isDefaultPrevented() && (!m._default || m._default.apply(v.pop(), t) === !1) && xt(n) && d && G(n[D]) && !Oe(n) && (l = n[d], l && (n[d] = null), s.event.triggered = D, e.isPropagationStopped() && L.addEventListener(D, gi), n[D](), e.isPropagationStopped() && L.removeEventListener(D, gi), s.event.triggered = void 0, l && (n[d] = l)), e.result;
        }
      },
      simulate: function(e, t, n) {
        var i = s.extend(
          new s.Event(),
          n,
          {
            type: e,
            isSimulated: !0
          }
        );
        s.event.trigger(i, null, t);
      }
    }), s.fn.extend({
      trigger: function(e, t) {
        return this.each(function() {
          s.event.trigger(e, t, this);
        });
      },
      triggerHandler: function(e, t) {
        var n = this[0];
        if (n)
          return s.event.trigger(e, t, n, !0);
      }
    }), te.focusin || s.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      var n = function(i) {
        s.event.simulate(t, i.target, s.event.fix(i));
      };
      s.event.special[t] = {
        setup: function() {
          var i = this.ownerDocument || this.document || this, a = V.access(i, t);
          a || i.addEventListener(e, n, !0), V.access(i, t, (a || 0) + 1);
        },
        teardown: function() {
          var i = this.ownerDocument || this.document || this, a = V.access(i, t) - 1;
          a ? V.access(i, t, a) : (i.removeEventListener(e, n, !0), V.remove(i, t));
        }
      };
    });
    var $t = f.location, yi = { guid: Date.now() }, Cn = /\?/;
    s.parseXML = function(e) {
      var t, n;
      if (!e || typeof e != "string")
        return null;
      try {
        t = new f.DOMParser().parseFromString(e, "text/xml");
      } catch {
      }
      return n = t && t.getElementsByTagName("parsererror")[0], (!t || n) && s.error("Invalid XML: " + (n ? s.map(n.childNodes, function(i) {
        return i.textContent;
      }).join(`
`) : e)), t;
    };
    var Or = /\[\]$/, bi = /\r?\n/g, Ar = /^(?:submit|button|image|reset|file)$/i, Pr = /^(?:input|select|textarea|keygen)/i;
    function Sn(e, t, n, i) {
      var a;
      if (Array.isArray(t))
        s.each(t, function(o, l) {
          n || Or.test(e) ? i(e, l) : Sn(
            e + "[" + (typeof l == "object" && l != null ? o : "") + "]",
            l,
            n,
            i
          );
        });
      else if (!n && Je(t) === "object")
        for (a in t)
          Sn(e + "[" + a + "]", t[a], n, i);
      else
        i(e, t);
    }
    s.param = function(e, t) {
      var n, i = [], a = function(o, l) {
        var p = G(l) ? l() : l;
        i[i.length] = encodeURIComponent(o) + "=" + encodeURIComponent(p == null ? "" : p);
      };
      if (e == null)
        return "";
      if (Array.isArray(e) || e.jquery && !s.isPlainObject(e))
        s.each(e, function() {
          a(this.name, this.value);
        });
      else
        for (n in e)
          Sn(n, e[n], t, a);
      return i.join("&");
    }, s.fn.extend({
      serialize: function() {
        return s.param(this.serializeArray());
      },
      serializeArray: function() {
        return this.map(function() {
          var e = s.prop(this, "elements");
          return e ? s.makeArray(e) : this;
        }).filter(function() {
          var e = this.type;
          return this.name && !s(this).is(":disabled") && Pr.test(this.nodeName) && !Ar.test(e) && (this.checked || !At.test(e));
        }).map(function(e, t) {
          var n = s(this).val();
          return n == null ? null : Array.isArray(n) ? s.map(n, function(i) {
            return { name: t.name, value: i.replace(bi, `\r
`) };
          }) : { name: t.name, value: n.replace(bi, `\r
`) };
        }).get();
      }
    });
    var qr = /%20/g, $r = /#.*$/, Hr = /([?&])_=[^&]*/, jr = /^(.*?):[ \t]*([^\r\n]*)$/mg, Fr = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/, Mr = /^(?:GET|HEAD)$/, Br = /^\/\//, vi = {}, _n = {}, mi = "*/".concat("*"), Dn = K.createElement("a");
    Dn.href = $t.href;
    function ki(e) {
      return function(t, n) {
        typeof t != "string" && (n = t, t = "*");
        var i, a = 0, o = t.toLowerCase().match(Ue) || [];
        if (G(n))
          for (; i = o[a++]; )
            i[0] === "+" ? (i = i.slice(1) || "*", (e[i] = e[i] || []).unshift(n)) : (e[i] = e[i] || []).push(n);
      };
    }
    function wi(e, t, n, i) {
      var a = {}, o = e === _n;
      function l(p) {
        var d;
        return a[p] = !0, s.each(e[p] || [], function(b, m) {
          var L = m(t, n, i);
          if (typeof L == "string" && !o && !a[L])
            return t.dataTypes.unshift(L), l(L), !1;
          if (o)
            return !(d = L);
        }), d;
      }
      return l(t.dataTypes[0]) || !a["*"] && l("*");
    }
    function En(e, t) {
      var n, i, a = s.ajaxSettings.flatOptions || {};
      for (n in t)
        t[n] !== void 0 && ((a[n] ? e : i || (i = {}))[n] = t[n]);
      return i && s.extend(!0, e, i), e;
    }
    function Ir(e, t, n) {
      for (var i, a, o, l, p = e.contents, d = e.dataTypes; d[0] === "*"; )
        d.shift(), i === void 0 && (i = e.mimeType || t.getResponseHeader("Content-Type"));
      if (i) {
        for (a in p)
          if (p[a] && p[a].test(i)) {
            d.unshift(a);
            break;
          }
      }
      if (d[0] in n)
        o = d[0];
      else {
        for (a in n) {
          if (!d[0] || e.converters[a + " " + d[0]]) {
            o = a;
            break;
          }
          l || (l = a);
        }
        o = o || l;
      }
      if (o)
        return o !== d[0] && d.unshift(o), n[o];
    }
    function Rr(e, t, n, i) {
      var a, o, l, p, d, b = {}, m = e.dataTypes.slice();
      if (m[1])
        for (l in e.converters)
          b[l.toLowerCase()] = e.converters[l];
      for (o = m.shift(); o; )
        if (e.responseFields[o] && (n[e.responseFields[o]] = t), !d && i && e.dataFilter && (t = e.dataFilter(t, e.dataType)), d = o, o = m.shift(), o) {
          if (o === "*")
            o = d;
          else if (d !== "*" && d !== o) {
            if (l = b[d + " " + o] || b["* " + o], !l) {
              for (a in b)
                if (p = a.split(" "), p[1] === o && (l = b[d + " " + p[0]] || b["* " + p[0]], l)) {
                  l === !0 ? l = b[a] : b[a] !== !0 && (o = p[0], m.unshift(p[1]));
                  break;
                }
            }
            if (l !== !0)
              if (l && e.throws)
                t = l(t);
              else
                try {
                  t = l(t);
                } catch (L) {
                  return {
                    state: "parsererror",
                    error: l ? L : "No conversion from " + d + " to " + o
                  };
                }
          }
        }
      return { state: "success", data: t };
    }
    s.extend({
      active: 0,
      lastModified: {},
      etag: {},
      ajaxSettings: {
        url: $t.href,
        type: "GET",
        isLocal: Fr.test($t.protocol),
        global: !0,
        processData: !0,
        async: !0,
        contentType: "application/x-www-form-urlencoded; charset=UTF-8",
        accepts: {
          "*": mi,
          text: "text/plain",
          html: "text/html",
          xml: "application/xml, text/xml",
          json: "application/json, text/javascript"
        },
        contents: {
          xml: /\bxml\b/,
          html: /\bhtml/,
          json: /\bjson\b/
        },
        responseFields: {
          xml: "responseXML",
          text: "responseText",
          json: "responseJSON"
        },
        converters: {
          "* text": String,
          "text html": !0,
          "text json": JSON.parse,
          "text xml": s.parseXML
        },
        flatOptions: {
          url: !0,
          context: !0
        }
      },
      ajaxSetup: function(e, t) {
        return t ? En(En(e, s.ajaxSettings), t) : En(s.ajaxSettings, e);
      },
      ajaxPrefilter: ki(vi),
      ajaxTransport: ki(_n),
      ajax: function(e, t) {
        typeof e == "object" && (t = e, e = void 0), t = t || {};
        var n, i, a, o, l, p, d, b, m, L, v = s.ajaxSetup({}, t), D = v.context || v, j = v.context && (D.nodeType || D.jquery) ? s(D) : s.event, Y = s.Deferred(), F = s.Callbacks("once memory"), be = v.statusCode || {}, ye = {}, Ae = {}, oe = "canceled", X = {
          readyState: 0,
          getResponseHeader: function(re) {
            var ge;
            if (d) {
              if (!o)
                for (o = {}; ge = jr.exec(a); )
                  o[ge[1].toLowerCase() + " "] = (o[ge[1].toLowerCase() + " "] || []).concat(ge[2]);
              ge = o[re.toLowerCase() + " "];
            }
            return ge == null ? null : ge.join(", ");
          },
          getAllResponseHeaders: function() {
            return d ? a : null;
          },
          setRequestHeader: function(re, ge) {
            return d == null && (re = Ae[re.toLowerCase()] = Ae[re.toLowerCase()] || re, ye[re] = ge), this;
          },
          overrideMimeType: function(re) {
            return d == null && (v.mimeType = re), this;
          },
          statusCode: function(re) {
            var ge;
            if (re)
              if (d)
                X.always(re[X.status]);
              else
                for (ge in re)
                  be[ge] = [be[ge], re[ge]];
            return this;
          },
          abort: function(re) {
            var ge = re || oe;
            return n && n.abort(ge), xe(0, ge), this;
          }
        };
        if (Y.promise(X), v.url = ((e || v.url || $t.href) + "").replace(Br, $t.protocol + "//"), v.type = t.method || t.type || v.method || v.type, v.dataTypes = (v.dataType || "*").toLowerCase().match(Ue) || [""], v.crossDomain == null) {
          p = K.createElement("a");
          try {
            p.href = v.url, p.href = p.href, v.crossDomain = Dn.protocol + "//" + Dn.host != p.protocol + "//" + p.host;
          } catch {
            v.crossDomain = !0;
          }
        }
        if (v.data && v.processData && typeof v.data != "string" && (v.data = s.param(v.data, v.traditional)), wi(vi, v, t, X), d)
          return X;
        b = s.event && v.global, b && s.active++ === 0 && s.event.trigger("ajaxStart"), v.type = v.type.toUpperCase(), v.hasContent = !Mr.test(v.type), i = v.url.replace($r, ""), v.hasContent ? v.data && v.processData && (v.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && (v.data = v.data.replace(qr, "+")) : (L = v.url.slice(i.length), v.data && (v.processData || typeof v.data == "string") && (i += (Cn.test(i) ? "&" : "?") + v.data, delete v.data), v.cache === !1 && (i = i.replace(Hr, "$1"), L = (Cn.test(i) ? "&" : "?") + "_=" + yi.guid++ + L), v.url = i + L), v.ifModified && (s.lastModified[i] && X.setRequestHeader("If-Modified-Since", s.lastModified[i]), s.etag[i] && X.setRequestHeader("If-None-Match", s.etag[i])), (v.data && v.hasContent && v.contentType !== !1 || t.contentType) && X.setRequestHeader("Content-Type", v.contentType), X.setRequestHeader(
          "Accept",
          v.dataTypes[0] && v.accepts[v.dataTypes[0]] ? v.accepts[v.dataTypes[0]] + (v.dataTypes[0] !== "*" ? ", " + mi + "; q=0.01" : "") : v.accepts["*"]
        );
        for (m in v.headers)
          X.setRequestHeader(m, v.headers[m]);
        if (v.beforeSend && (v.beforeSend.call(D, X, v) === !1 || d))
          return X.abort();
        if (oe = "abort", F.add(v.complete), X.done(v.success), X.fail(v.error), n = wi(_n, v, t, X), !n)
          xe(-1, "No Transport");
        else {
          if (X.readyState = 1, b && j.trigger("ajaxSend", [X, v]), d)
            return X;
          v.async && v.timeout > 0 && (l = f.setTimeout(function() {
            X.abort("timeout");
          }, v.timeout));
          try {
            d = !1, n.send(ye, xe);
          } catch (re) {
            if (d)
              throw re;
            xe(-1, re);
          }
        }
        function xe(re, ge, jt, nn) {
          var Pe, ft, dt, Le, it, Fe = ge;
          d || (d = !0, l && f.clearTimeout(l), n = void 0, a = nn || "", X.readyState = re > 0 ? 4 : 0, Pe = re >= 200 && re < 300 || re === 304, jt && (Le = Ir(v, X, jt)), !Pe && s.inArray("script", v.dataTypes) > -1 && s.inArray("json", v.dataTypes) < 0 && (v.converters["text script"] = function() {
          }), Le = Rr(v, Le, X, Pe), Pe ? (v.ifModified && (it = X.getResponseHeader("Last-Modified"), it && (s.lastModified[i] = it), it = X.getResponseHeader("etag"), it && (s.etag[i] = it)), re === 204 || v.type === "HEAD" ? Fe = "nocontent" : re === 304 ? Fe = "notmodified" : (Fe = Le.state, ft = Le.data, dt = Le.error, Pe = !dt)) : (dt = Fe, (re || !Fe) && (Fe = "error", re < 0 && (re = 0))), X.status = re, X.statusText = (ge || Fe) + "", Pe ? Y.resolveWith(D, [ft, Fe, X]) : Y.rejectWith(D, [X, Fe, dt]), X.statusCode(be), be = void 0, b && j.trigger(
            Pe ? "ajaxSuccess" : "ajaxError",
            [X, v, Pe ? ft : dt]
          ), F.fireWith(D, [X, Fe]), b && (j.trigger("ajaxComplete", [X, v]), --s.active || s.event.trigger("ajaxStop")));
        }
        return X;
      },
      getJSON: function(e, t, n) {
        return s.get(e, t, n, "json");
      },
      getScript: function(e, t) {
        return s.get(e, void 0, t, "script");
      }
    }), s.each(["get", "post"], function(e, t) {
      s[t] = function(n, i, a, o) {
        return G(i) && (o = o || a, a = i, i = void 0), s.ajax(s.extend({
          url: n,
          type: t,
          dataType: o,
          data: i,
          success: a
        }, s.isPlainObject(n) && n));
      };
    }), s.ajaxPrefilter(function(e) {
      var t;
      for (t in e.headers)
        t.toLowerCase() === "content-type" && (e.contentType = e.headers[t] || "");
    }), s._evalUrl = function(e, t, n) {
      return s.ajax({
        url: e,
        type: "GET",
        dataType: "script",
        cache: !0,
        async: !1,
        global: !1,
        converters: {
          "text script": function() {
          }
        },
        dataFilter: function(i) {
          s.globalEval(i, t, n);
        }
      });
    }, s.fn.extend({
      wrapAll: function(e) {
        var t;
        return this[0] && (G(e) && (e = e.call(this[0])), t = s(e, this[0].ownerDocument).eq(0).clone(!0), this[0].parentNode && t.insertBefore(this[0]), t.map(function() {
          for (var n = this; n.firstElementChild; )
            n = n.firstElementChild;
          return n;
        }).append(this)), this;
      },
      wrapInner: function(e) {
        return G(e) ? this.each(function(t) {
          s(this).wrapInner(e.call(this, t));
        }) : this.each(function() {
          var t = s(this), n = t.contents();
          n.length ? n.wrapAll(e) : t.append(e);
        });
      },
      wrap: function(e) {
        var t = G(e);
        return this.each(function(n) {
          s(this).wrapAll(t ? e.call(this, n) : e);
        });
      },
      unwrap: function(e) {
        return this.parent(e).not("body").each(function() {
          s(this).replaceWith(this.childNodes);
        }), this;
      }
    }), s.expr.pseudos.hidden = function(e) {
      return !s.expr.pseudos.visible(e);
    }, s.expr.pseudos.visible = function(e) {
      return !!(e.offsetWidth || e.offsetHeight || e.getClientRects().length);
    }, s.ajaxSettings.xhr = function() {
      try {
        return new f.XMLHttpRequest();
      } catch {
      }
    };
    var Vr = {
      0: 200,
      1223: 204
    }, Ht = s.ajaxSettings.xhr();
    te.cors = !!Ht && "withCredentials" in Ht, te.ajax = Ht = !!Ht, s.ajaxTransport(function(e) {
      var t, n;
      if (te.cors || Ht && !e.crossDomain)
        return {
          send: function(i, a) {
            var o, l = e.xhr();
            if (l.open(
              e.type,
              e.url,
              e.async,
              e.username,
              e.password
            ), e.xhrFields)
              for (o in e.xhrFields)
                l[o] = e.xhrFields[o];
            e.mimeType && l.overrideMimeType && l.overrideMimeType(e.mimeType), !e.crossDomain && !i["X-Requested-With"] && (i["X-Requested-With"] = "XMLHttpRequest");
            for (o in i)
              l.setRequestHeader(o, i[o]);
            t = function(p) {
              return function() {
                t && (t = n = l.onload = l.onerror = l.onabort = l.ontimeout = l.onreadystatechange = null, p === "abort" ? l.abort() : p === "error" ? typeof l.status != "number" ? a(0, "error") : a(
                  l.status,
                  l.statusText
                ) : a(
                  Vr[l.status] || l.status,
                  l.statusText,
                  (l.responseType || "text") !== "text" || typeof l.responseText != "string" ? { binary: l.response } : { text: l.responseText },
                  l.getAllResponseHeaders()
                ));
              };
            }, l.onload = t(), n = l.onerror = l.ontimeout = t("error"), l.onabort !== void 0 ? l.onabort = n : l.onreadystatechange = function() {
              l.readyState === 4 && f.setTimeout(function() {
                t && n();
              });
            }, t = t("abort");
            try {
              l.send(e.hasContent && e.data || null);
            } catch (p) {
              if (t)
                throw p;
            }
          },
          abort: function() {
            t && t();
          }
        };
    }), s.ajaxPrefilter(function(e) {
      e.crossDomain && (e.contents.script = !1);
    }), s.ajaxSetup({
      accepts: {
        script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
      },
      contents: {
        script: /\b(?:java|ecma)script\b/
      },
      converters: {
        "text script": function(e) {
          return s.globalEval(e), e;
        }
      }
    }), s.ajaxPrefilter("script", function(e) {
      e.cache === void 0 && (e.cache = !1), e.crossDomain && (e.type = "GET");
    }), s.ajaxTransport("script", function(e) {
      if (e.crossDomain || e.scriptAttrs) {
        var t, n;
        return {
          send: function(i, a) {
            t = s("<script>").attr(e.scriptAttrs || {}).prop({ charset: e.scriptCharset, src: e.url }).on("load error", n = function(o) {
              t.remove(), n = null, o && a(o.type === "error" ? 404 : 200, o.type);
            }), K.head.appendChild(t[0]);
          },
          abort: function() {
            n && n();
          }
        };
      }
    });
    var Ti = [], Nn = /(=)\?(?=&|$)|\?\?/;
    s.ajaxSetup({
      jsonp: "callback",
      jsonpCallback: function() {
        var e = Ti.pop() || s.expando + "_" + yi.guid++;
        return this[e] = !0, e;
      }
    }), s.ajaxPrefilter("json jsonp", function(e, t, n) {
      var i, a, o, l = e.jsonp !== !1 && (Nn.test(e.url) ? "url" : typeof e.data == "string" && (e.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && Nn.test(e.data) && "data");
      if (l || e.dataTypes[0] === "jsonp")
        return i = e.jsonpCallback = G(e.jsonpCallback) ? e.jsonpCallback() : e.jsonpCallback, l ? e[l] = e[l].replace(Nn, "$1" + i) : e.jsonp !== !1 && (e.url += (Cn.test(e.url) ? "&" : "?") + e.jsonp + "=" + i), e.converters["script json"] = function() {
          return o || s.error(i + " was not called"), o[0];
        }, e.dataTypes[0] = "json", a = f[i], f[i] = function() {
          o = arguments;
        }, n.always(function() {
          a === void 0 ? s(f).removeProp(i) : f[i] = a, e[i] && (e.jsonpCallback = t.jsonpCallback, Ti.push(i)), o && G(a) && a(o[0]), o = a = void 0;
        }), "script";
    }), te.createHTMLDocument = function() {
      var e = K.implementation.createHTMLDocument("").body;
      return e.innerHTML = "<form></form><form></form>", e.childNodes.length === 2;
    }(), s.parseHTML = function(e, t, n) {
      if (typeof e != "string")
        return [];
      typeof t == "boolean" && (n = t, t = !1);
      var i, a, o;
      return t || (te.createHTMLDocument ? (t = K.implementation.createHTMLDocument(""), i = t.createElement("base"), i.href = K.location.href, t.head.appendChild(i)) : t = K), a = Se.exec(e), o = !n && [], a ? [t.createElement(a[1])] : (a = Jn([e], t, o), o && o.length && s(o).remove(), s.merge([], a.childNodes));
    }, s.fn.load = function(e, t, n) {
      var i, a, o, l = this, p = e.indexOf(" ");
      return p > -1 && (i = ut(e.slice(p)), e = e.slice(0, p)), G(t) ? (n = t, t = void 0) : t && typeof t == "object" && (a = "POST"), l.length > 0 && s.ajax({
        url: e,
        type: a || "GET",
        dataType: "html",
        data: t
      }).done(function(d) {
        o = arguments, l.html(i ? s("<div>").append(s.parseHTML(d)).find(i) : d);
      }).always(n && function(d, b) {
        l.each(function() {
          n.apply(this, o || [d.responseText, b, d]);
        });
      }), this;
    }, s.expr.pseudos.animated = function(e) {
      return s.grep(s.timers, function(t) {
        return e === t.elem;
      }).length;
    }, s.offset = {
      setOffset: function(e, t, n) {
        var i, a, o, l, p, d, b, m = s.css(e, "position"), L = s(e), v = {};
        m === "static" && (e.style.position = "relative"), p = L.offset(), o = s.css(e, "top"), d = s.css(e, "left"), b = (m === "absolute" || m === "fixed") && (o + d).indexOf("auto") > -1, b ? (i = L.position(), l = i.top, a = i.left) : (l = parseFloat(o) || 0, a = parseFloat(d) || 0), G(t) && (t = t.call(e, n, s.extend({}, p))), t.top != null && (v.top = t.top - p.top + l), t.left != null && (v.left = t.left - p.left + a), "using" in t ? t.using.call(e, v) : L.css(v);
      }
    }, s.fn.extend({
      offset: function(e) {
        if (arguments.length)
          return e === void 0 ? this : this.each(function(a) {
            s.offset.setOffset(this, e, a);
          });
        var t, n, i = this[0];
        if (!!i)
          return i.getClientRects().length ? (t = i.getBoundingClientRect(), n = i.ownerDocument.defaultView, {
            top: t.top + n.pageYOffset,
            left: t.left + n.pageXOffset
          }) : { top: 0, left: 0 };
      },
      position: function() {
        if (!!this[0]) {
          var e, t, n, i = this[0], a = { top: 0, left: 0 };
          if (s.css(i, "position") === "fixed")
            t = i.getBoundingClientRect();
          else {
            for (t = this.offset(), n = i.ownerDocument, e = i.offsetParent || n.documentElement; e && (e === n.body || e === n.documentElement) && s.css(e, "position") === "static"; )
              e = e.parentNode;
            e && e !== i && e.nodeType === 1 && (a = s(e).offset(), a.top += s.css(e, "borderTopWidth", !0), a.left += s.css(e, "borderLeftWidth", !0));
          }
          return {
            top: t.top - a.top - s.css(i, "marginTop", !0),
            left: t.left - a.left - s.css(i, "marginLeft", !0)
          };
        }
      },
      offsetParent: function() {
        return this.map(function() {
          for (var e = this.offsetParent; e && s.css(e, "position") === "static"; )
            e = e.offsetParent;
          return e || lt;
        });
      }
    }), s.each({ scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function(e, t) {
      var n = t === "pageYOffset";
      s.fn[e] = function(i) {
        return Ke(this, function(a, o, l) {
          var p;
          if (Oe(a) ? p = a : a.nodeType === 9 && (p = a.defaultView), l === void 0)
            return p ? p[t] : a[o];
          p ? p.scrollTo(
            n ? p.pageXOffset : l,
            n ? l : p.pageYOffset
          ) : a[o] = l;
        }, e, i, arguments.length);
      };
    }), s.each(["top", "left"], function(e, t) {
      s.cssHooks[t] = ri(
        te.pixelPosition,
        function(n, i) {
          if (i)
            return i = Pt(n, t), bn.test(i) ? s(n).position()[t] + "px" : i;
        }
      );
    }), s.each({ Height: "height", Width: "width" }, function(e, t) {
      s.each({
        padding: "inner" + e,
        content: t,
        "": "outer" + e
      }, function(n, i) {
        s.fn[i] = function(a, o) {
          var l = arguments.length && (n || typeof a != "boolean"), p = n || (a === !0 || o === !0 ? "margin" : "border");
          return Ke(this, function(d, b, m) {
            var L;
            return Oe(d) ? i.indexOf("outer") === 0 ? d["inner" + e] : d.document.documentElement["client" + e] : d.nodeType === 9 ? (L = d.documentElement, Math.max(
              d.body["scroll" + e],
              L["scroll" + e],
              d.body["offset" + e],
              L["offset" + e],
              L["client" + e]
            )) : m === void 0 ? s.css(d, b, p) : s.style(d, b, m, p);
          }, t, l ? a : void 0, l);
        };
      });
    }), s.each([
      "ajaxStart",
      "ajaxStop",
      "ajaxComplete",
      "ajaxError",
      "ajaxSuccess",
      "ajaxSend"
    ], function(e, t) {
      s.fn[t] = function(n) {
        return this.on(t, n);
      };
    }), s.fn.extend({
      bind: function(e, t, n) {
        return this.on(e, null, t, n);
      },
      unbind: function(e, t) {
        return this.off(e, null, t);
      },
      delegate: function(e, t, n, i) {
        return this.on(t, e, n, i);
      },
      undelegate: function(e, t, n) {
        return arguments.length === 1 ? this.off(e, "**") : this.off(t, e || "**", n);
      },
      hover: function(e, t) {
        return this.mouseenter(e).mouseleave(t || e);
      }
    }), s.each(
      "blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),
      function(e, t) {
        s.fn[t] = function(n, i) {
          return arguments.length > 0 ? this.on(t, null, n, i) : this.trigger(t);
        };
      }
    );
    var zr = /^[\s\uFEFF\xA0]+|([^\s\uFEFF\xA0])[\s\uFEFF\xA0]+$/g;
    s.proxy = function(e, t) {
      var n, i, a;
      if (typeof t == "string" && (n = e[t], t = e, e = n), !!G(e))
        return i = N.call(arguments, 2), a = function() {
          return e.apply(t || this, i.concat(N.call(arguments)));
        }, a.guid = e.guid = e.guid || s.guid++, a;
    }, s.holdReady = function(e) {
      e ? s.readyWait++ : s.ready(!0);
    }, s.isArray = Array.isArray, s.parseJSON = JSON.parse, s.nodeName = le, s.isFunction = G, s.isWindow = Oe, s.camelCase = Ge, s.type = Je, s.now = Date.now, s.isNumeric = function(e) {
      var t = s.type(e);
      return (t === "number" || t === "string") && !isNaN(e - parseFloat(e));
    }, s.trim = function(e) {
      return e == null ? "" : (e + "").replace(zr, "$1");
    };
    var Wr = f.jQuery, Ur = f.$;
    return s.noConflict = function(e) {
      return f.$ === s && (f.$ = Ur), e && f.jQuery === s && (f.jQuery = Wr), s;
    }, typeof c > "u" && (f.jQuery = f.$ = s), s;
  });
})(Xi);
const Rn = Xi.exports;
const Qo = {
  name: "harness-ui-input",
  mixins: [Ye, nt],
  components: { InputPartial: Uo },
  props: {
    type: {
      required: !1,
      type: String,
      default: "text",
      validator: function(r) {
        return [
          "date",
          "datetime-local",
          "email",
          "month",
          "number",
          "password",
          "search",
          "tel",
          "text",
          "time",
          "url",
          "week"
        ].includes(r);
      }
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    },
    strict: {
      type: Boolean,
      required: !1,
      default: !0
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    }
  },
  data() {
    return {
      bloodhound: null,
      subscription: null,
      strictError: !1
    };
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(r) {
        !this.strict || this.evaluateStrict ? (this.strictError = !1, this.setFilterLoadData(this.filter.key, r)) : this.strict && !this.evaluateStrict && (this.strictError = !0);
      }
    }
  },
  methods: {
    evaluateStrict(r) {
      return this.getOptionsForFilter(this.filter.key).map((f) => f.key).includes(r);
    },
    initTypeahead() {
      window && (window.$ = window.jQuery = Rn);
      const r = require("corejs-typeahead");
      this.bloodhound = new r({
        datumTokenizer: r.tokenizers.ngram,
        queryTokenizer: r.tokenizers.ngram,
        local: this.getOptionsForFilter(this.filter.key).map((c) => c.key)
      });
      const f = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((c, _) => (c[_] = `harness-ui-typeahead-${_}`, c), {});
      window.$(`#${this.filter.key}-${this.type}-input`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: f
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (c, _) => {
        this.setFilter(this.filter.key, _);
      }).bind("typeahead:autocomplete", (c, _) => {
        this.setFilter(this.filter.key, _);
      });
    }
  },
  mounted() {
    this.typeahead && (this.initTypeahead(), this.subscription = this.$store.subscribeAction({
      before: (r, f) => {
      },
      after: (r, f) => {
        r.type.includes(`SET_${this.filter.key.toUpperCase()}_OPTIONS`) && (this.bloodhound.clear(), this.bloodhound.add(
          this.getOptionsForFilter(this.filter.key).map((c) => c.key)
        ));
      }
    }));
  },
  beforeUnmount() {
    this.typeahead && (this.subscription(), this.bloodhound.clear());
  }
}, Xo = { class: "row form-row" }, Yo = ["for", "id", "innerHTML"], Jo = ["innerHTML"], Ko = ["for", "id", "innerHTML"], Zo = ["innerHTML"], el = ["innerHTML"];
function tl(r, f, c, _, A, N) {
  const w = Xe("InputPartial");
  return C(), S("div", null, [
    r.labelPosition == "horizontal" ? (C(), S("div", {
      key: 0,
      class: $(r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("div", Xo, [
        k("div", {
          class: $(
            "col-" + r.labelColumnSize + " " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-label-wrapper" : "")
          )
        }, [
          k("label", {
            for: r.filter.key,
            class: $(
              "col-form-label harness-ui-select-label harness-ui-select-label-horizontal " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-label" : "")
            ),
            id: r.filter.key + "-label",
            innerHTML: r.filter.label
          }, null, 10, Yo)
        ], 2),
        k("div", {
          class: $(
            "col-" + (12 - r.labelColumnSize) + " " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-input-wrapper" : "")
          )
        }, [
          we(w, He(ze({ ...r.$props, ...r.$attrs, strictError: A.strictError })), null, 16),
          r.helperText ? (C(), S("small", {
            key: 0,
            innerHTML: r.helperText,
            class: $(
              "form-text harness-ui-helper-text harness-ui-input-helper-text " + r.helperTextClass
            )
          }, null, 10, Jo)) : M("", !0)
        ], 2)
      ])
    ], 2)) : M("", !0),
    r.labelPosition == "vertical" ? (C(), S("div", {
      key: 1,
      class: $(r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("label", {
        for: r.filter.key,
        class: $(
          "col-form-label harness-ui-select-label harness-ui-select-label-vertical " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-label" : "")
        ),
        id: r.filter.key + "-label",
        innerHTML: r.filter.label
      }, null, 10, Ko),
      we(w, He(ze({ ...r.$props, ...r.$attrs, strictError: A.strictError })), null, 16),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-helper-text harness-ui-input-helper-text " + r.helperTextClass
        )
      }, null, 10, Zo)) : M("", !0)
    ], 2)) : M("", !0),
    r.labelPosition == "none" ? (C(), S("div", {
      key: 2,
      class: $(
        "form-inline " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      we(w, He(ze({ ...r.$props, ...r.$attrs, strictError: A.strictError })), null, 16),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-helper-text harness-ui-input-helper-text " + r.helperTextClass
        )
      }, null, 10, el)) : M("", !0)
    ], 2)) : M("", !0)
  ]);
}
const nl = /* @__PURE__ */ ke(Qo, [["render", tl]]), il = {
  name: "SelectPartial",
  mixins: [Ye, nt],
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, rl = ["multiple", "id", "aria-labelledby"], sl = ["value", "disabled", "hidden", "title", "innerHTML"];
function al(r, f, c, _, A, N) {
  return Ve((C(), S("select", {
    multiple: c.multiple,
    class: $(
      "form-control harness-ui-select " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-select" : "")
    ),
    "onUpdate:modelValue": f[0] || (f[0] = (w) => r.boundValue = w),
    id: r.filter.key + "-select",
    "aria-labelledby": r.filter.key + "-label"
  }, [
    (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (w) => (C(), S("option", {
      key: w.key,
      value: w.key,
      disabled: w.disabled,
      hidden: w.hidden,
      title: w.label,
      innerHTML: w.label
    }, null, 8, sl))), 128))
  ], 10, rl)), [
    [fn, r.boundValue]
  ]);
}
const ol = /* @__PURE__ */ ke(il, [["render", al]]), ll = {
  name: "harness-ui-select",
  mixins: [Ye, nt],
  components: { SelectPartial: ol },
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, ul = { class: "row form-row" }, cl = ["for", "id", "innerHTML"], fl = ["innerHTML"], dl = ["for", "id", "innerHTML"], hl = ["innerHTML"], pl = ["innerHTML"];
function gl(r, f, c, _, A, N) {
  const w = Xe("SelectPartial");
  return C(), S("div", null, [
    r.labelPosition == "horizontal" ? (C(), S("div", {
      key: 0,
      class: $(r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("div", ul, [
        k("div", {
          class: $("col-" + r.labelColumnSize)
        }, [
          k("label", {
            for: r.filter.key,
            class: $(
              "col-form-label harness-ui-select-label harness-ui-select-label-horizontal " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-label" : "")
            ),
            id: r.filter.key + "-label",
            innerHTML: r.filter.label
          }, null, 10, cl)
        ], 2),
        k("div", {
          class: $("col-" + (12 - r.labelColumnSize))
        }, [
          we(w, He(ze({ ...r.$props, ...r.$attrs })), null, 16),
          r.helperText ? (C(), S("small", {
            key: 0,
            innerHTML: r.helperText,
            class: $(
              "form-text harness-ui-select-helper-text harness-ui-helper-text " + r.helperTextClass
            )
          }, null, 10, fl)) : M("", !0)
        ], 2)
      ])
    ], 2)) : M("", !0),
    r.labelPosition == "vertical" ? (C(), S("div", {
      key: 1,
      class: $(r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("label", {
        for: r.filter.key,
        class: $(
          "col-form-label harness-ui-select-label harness-ui-select-label-vertical " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-label" : "")
        ),
        id: r.filter.key + "-label",
        innerHTML: r.filter.label
      }, null, 10, dl),
      we(w, He(ze({ ...r.$props, ...r.$attrs })), null, 16),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-select-helper-text harness-ui-helper-text " + r.helperTextClass
        )
      }, null, 10, hl)) : M("", !0)
    ], 2)) : M("", !0),
    r.labelPosition == "none" ? (C(), S("div", {
      key: 2,
      class: $(
        "form-inline " + (r.isFilterDirty(r.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      we(w, He(ze({ ...r.$props, ...r.$attrs })), null, 16),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-select-helper-text harness-ui-helper-text " + r.helperTextClass
        )
      }, null, 10, pl)) : M("", !0)
    ], 2)) : M("", !0)
  ]);
}
const yl = /* @__PURE__ */ ke(ll, [["render", gl]]), bl = {
  name: "CheckboxPartial",
  mixins: [Ye, nt],
  props: {
    option: {
      type: Object,
      required: !0
    }
  }
}, vl = ["name", "id", "value", "disabled", "aria-labelledby"];
function ml(r, f, c, _, A, N) {
  return Ve((C(), S("input", {
    class: "form-check-input harness-ui-radiogroup-input",
    type: "radio",
    name: r.filter.key,
    id: r.filter.key + c.option.key,
    value: c.option.key,
    disabled: c.option.disabled,
    "onUpdate:modelValue": f[0] || (f[0] = (w) => r.boundValue = w),
    "aria-labelledby": r.filter.key + c.option.key + "-label"
  }, null, 8, vl)), [
    [ls, r.boundValue]
  ]);
}
const kl = /* @__PURE__ */ ke(bl, [["render", ml]]), wl = {
  name: "harness-ui-radiogroup",
  components: { RadioGroupPartial: kl },
  mixins: [Ye, nt],
  props: {
    inline: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Tl = { key: 0 }, Cl = ["for", "innerHTML"], Sl = ["id", "for", "disabled", "innerHTML"], _l = ["innerHTML"], Dl = { key: 1 }, El = { class: "row form-row" }, Nl = ["for", "innerHTML"], xl = ["id", "for", "disabled", "innerHTML"], Ll = ["innerHTML"];
function Ol(r, f, c, _, A, N) {
  const w = Xe("RadioGroupPartial");
  return C(), S("div", null, [
    r.labelPosition === "vertical" ? (C(), S("fieldset", Tl, [
      k("legend", {
        class: "col-form-label harness-ui-radiogroup-legend",
        for: r.filter.key,
        innerHTML: r.filter.label
      }, null, 8, Cl),
      (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (T, B) => (C(), S("div", {
        class: $("form-check" + (c.inline ? " form-check-inline" : "")),
        key: B
      }, [
        we(w, He(ze({ ...r.$props, ...r.$attrs, option: T })), null, 16),
        k("label", {
          class: "form-check-label harness-ui-radiogroup-label",
          id: r.filter.key + T.key + "-label",
          for: r.filter.key + T.key,
          disabled: T.disabled,
          innerHTML: T.label
        }, null, 8, Sl)
      ], 2))), 128)),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-helper-text harness-ui-radiogroup-helper-text " + r.helperTextClass
        )
      }, null, 10, _l)) : M("", !0)
    ])) : M("", !0),
    r.labelPosition === "horizontal" ? (C(), S("fieldset", Dl, [
      k("div", El, [
        k("div", {
          class: $("col-" + r.labelColumnSize)
        }, [
          k("legend", {
            class: "col-form-label harness-ui-radiogroup-legend",
            for: r.filter.key,
            innerHTML: r.filter.label
          }, null, 8, Nl)
        ], 2),
        k("div", {
          class: $("col-" + (12 - r.labelColumnSize))
        }, [
          (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (T, B) => (C(), S("div", {
            class: $("form-check" + (c.inline ? " form-check-inline" : "")),
            key: B
          }, [
            we(w, He(ze({ ...r.$props, ...r.$attrs, option: T })), null, 16),
            k("label", {
              class: "form-check-label harness-ui-radiogroup-label",
              id: r.filter.key + T.key + "-label",
              for: r.filter.key + T.key,
              disabled: T.disabled,
              innerHTML: T.label
            }, null, 8, xl)
          ], 2))), 128)),
          r.helperText ? (C(), S("small", {
            key: 0,
            innerHTML: r.helperText,
            class: $(
              "form-text harness-ui-helper-text harness-ui-radiogroup-helper-text " + r.helperTextClass
            )
          }, null, 10, Ll)) : M("", !0)
        ], 2)
      ])
    ])) : M("", !0)
  ]);
}
const Al = /* @__PURE__ */ ke(wl, [["render", Ol]]), Pl = {
  name: "CheckboxPartial",
  mixins: [Ye, nt],
  props: {
    inline: {
      type: Boolean,
      required: !0
    },
    collapse: {
      type: Boolean,
      required: !0
    },
    collapsed: {
      type: Boolean,
      required: !0
    },
    option: {
      type: Object,
      required: !0
    }
  }
}, ql = ["name", "id", "value", "aria-labelledby"];
function $l(r, f, c, _, A, N) {
  return Ve((C(), S("input", {
    class: "form-check-input harness-ui-checkboxgroup-input",
    type: "checkbox",
    name: r.filter.key + c.option.key,
    id: r.filter.key + c.option.key,
    value: c.option.key,
    "onUpdate:modelValue": f[0] || (f[0] = (w) => r.boundValue = w),
    "aria-labelledby": r.filter.key + c.option.key + "-label"
  }, null, 8, ql)), [
    [us, r.boundValue]
  ]);
}
const Hl = /* @__PURE__ */ ke(Pl, [["render", $l]]);
const jl = {
  name: "harness-ui-checkboxgroup",
  mixins: [Ye, nt],
  components: { CheckboxPartial: Hl },
  data: () => ({ collapsed: !0 }),
  props: {
    inline: {
      type: Boolean,
      docstring: "asdasdasd",
      required: !1,
      default: !1
    },
    collapse: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Fl = { key: 0 }, Ml = ["for", "data-toggle", "href", "role"], Bl = ["innerHTML"], Il = ["data-toggle", "href", "role"], Rl = {
  key: 0,
  class: "bi-chevron-down"
}, Vl = {
  key: 1,
  class: "bi-chevron-up"
}, zl = ["href"], Wl = { key: 0 }, Ul = { key: 1 }, Gl = ["id"], Ql = ["id", "for", "innerHTML"], Xl = ["innerHTML"], Yl = { key: 1 }, Jl = { class: "row form-row" }, Kl = ["data-toggle", "href", "role", "for"], Zl = ["innerHTML"], eu = ["data-toggle", "href", "role"], tu = {
  key: 0,
  class: "bi-chevron-down"
}, nu = {
  key: 1,
  class: "bi-chevron-up"
}, iu = ["href"], ru = { key: 0 }, su = { key: 1 }, au = ["id"], ou = ["id", "for", "innerHTML"], lu = ["innerHTML"], uu = { key: 2 }, cu = ["id", "for", "innerHTML"], fu = ["innerHTML"];
function du(r, f, c, _, A, N) {
  const w = Xe("CheckboxPartial");
  return C(), S("div", null, [
    r.labelPosition === "vertical" ? (C(), S("fieldset", Fl, [
      k("legend", {
        class: "col-form-label harness-ui-checkboxgroup-legend",
        for: r.filter.key,
        "data-toggle": c.collapse ? "collapse" : "",
        href: c.collapse ? "#harness-ui-checkbox-collapse-" + r.filter.key : "",
        role: c.collapse ? "button" : "",
        onClick: f[1] || (f[1] = (T) => r.collapsed = !r.collapsed)
      }, [
        k("span", {
          innerHTML: r.filter.label
        }, null, 8, Bl),
        c.collapse ? (C(), S("button", {
          key: 0,
          class: "harness-ui-collapse-toggle-button",
          "data-toggle": c.collapse ? "collapse" : "",
          href: c.collapse ? "#harness-ui-checkbox-collapse-" + r.filter.key : "",
          role: c.collapse ? "button" : "",
          onClick: f[0] || (f[0] = (T) => r.collapsed = !r.collapsed),
          "aria-expanded": "false",
          "aria-label": "Collapse Toggle"
        }, [
          c.collapse && r.collapsed ? (C(), S("i", Rl)) : M("", !0),
          c.collapse && !r.collapsed ? (C(), S("i", Vl)) : M("", !0)
        ], 8, Il)) : M("", !0)
      ], 8, Ml),
      c.collapse ? (C(), S("div", {
        key: 0,
        "data-toggle": "collapse",
        href: c.collapse ? "#harness-ui-checkbox-collapse-" + r.filter.key : "",
        role: "button",
        class: "harness-ui-checkboxgroup-collapse-label",
        onClick: f[2] || (f[2] = (T) => r.collapsed = !r.collapsed)
      }, [
        c.collapse && r.getFilter(r.filter.key).length === r.getOptionsForFilter(r.filter.key).length ? (C(), S("span", Wl, " (All Selected) ")) : c.collapse ? (C(), S("span", Ul, " (" + me(r.getFilter(r.filter.key).length) + " of " + me(r.getOptionsForFilter(r.filter.key).length) + " selected) ", 1)) : M("", !0)
      ], 8, zl)) : M("", !0),
      k("div", {
        class: $(c.collapse ? "collapse" : ""),
        id: c.collapse ? "harness-ui-checkbox-collapse-" + r.filter.key : ""
      }, [
        (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (T, B) => (C(), S("div", {
          class: $("form-check" + (c.inline ? " form-check-inline" : "")),
          key: B
        }, [
          we(w, He(ze({ ...r.$props, ...r.$attrs, collapsed: r.collapsed, option: T })), null, 16),
          k("label", {
            class: "form-check-label harness-ui-checkboxgroup-label",
            id: r.filter.key + T.key + "-label",
            for: r.filter.key + T.key,
            innerHTML: T.label
          }, null, 8, Ql)
        ], 2))), 128)),
        r.helperText ? (C(), S("small", {
          key: 0,
          innerHTML: r.helperText,
          class: $(
            "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + r.helperTextClass
          )
        }, null, 10, Xl)) : M("", !0)
      ], 10, Gl)
    ])) : M("", !0),
    r.labelPosition === "horizontal" ? (C(), S("fieldset", Yl, [
      k("div", Jl, [
        k("div", {
          class: $("col-" + r.labelColumnSize)
        }, [
          k("legend", {
            class: "col-form-label harness-ui-checkboxgroup-legend",
            "data-toggle": c.collapse ? "collapse" : "",
            href: c.collapse ? "#harness-ui-checkbox-collapse-" + r.filter.key : "",
            role: c.collapse ? "button" : "",
            for: r.filter.key,
            onClick: f[4] || (f[4] = (T) => r.collapsed = !r.collapsed)
          }, [
            k("span", {
              innerHTML: r.filter.label
            }, null, 8, Zl),
            c.collapse ? (C(), S("button", {
              key: 0,
              class: "harness-ui-collapse-toggle-button",
              "data-toggle": c.collapse ? "collapse" : "",
              href: c.collapse ? "#harness-ui-checkbox-collapse-" + r.filter.key : "",
              role: c.collapse ? "button" : "",
              onClick: f[3] || (f[3] = (T) => r.collapsed = !r.collapsed),
              "aria-expanded": "false",
              "aria-label": "Collapse Toggle"
            }, [
              c.collapse && r.collapsed ? (C(), S("i", tu)) : M("", !0),
              c.collapse && !r.collapsed ? (C(), S("i", nu)) : M("", !0)
            ], 8, eu)) : M("", !0)
          ], 8, Kl)
        ], 2),
        k("div", {
          class: $("col-" + (12 - r.labelColumnSize))
        }, [
          c.collapse ? (C(), S("div", {
            key: 0,
            class: "col-form-label harness-ui-checkboxgroup-collapse-label",
            "data-toggle": "collapse",
            href: "#harness-ui-checkbox-collapse-" + r.filter.key,
            role: "button",
            onClick: f[5] || (f[5] = (T) => r.collapsed = !r.collapsed)
          }, [
            c.collapse && r.getFilter(r.filter.key).length === r.getOptionsForFilter(r.filter.key).length ? (C(), S("span", ru, " (All Selected) ")) : c.collapse ? (C(), S("span", su, " (" + me(r.getFilter(r.filter.key).length) + " of " + me(r.getOptionsForFilter(r.filter.key).length) + " selected) ", 1)) : M("", !0)
          ], 8, iu)) : M("", !0),
          k("div", {
            class: $(c.collapse ? "collapse" : ""),
            id: c.collapse ? "harness-ui-checkbox-collapse-" + r.filter.key : ""
          }, [
            (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (T, B) => (C(), S("div", {
              class: $("form-check" + (c.inline ? " form-check-inline" : "")),
              key: B
            }, [
              we(w, He(ze({ ...r.$props, ...r.$attrs, collapsed: r.collapsed, option: T })), null, 16),
              k("label", {
                class: "form-check-label harness-ui-checkboxgroup-label",
                id: r.filter.key + T.key + "-label",
                for: r.filter.key + T.key,
                innerHTML: T.label
              }, null, 8, ou)
            ], 2))), 128)),
            r.helperText ? (C(), S("small", {
              key: 0,
              innerHTML: r.helperText,
              class: $(
                "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + r.helperTextClass
              )
            }, null, 10, lu)) : M("", !0)
          ], 10, au)
        ], 2)
      ])
    ])) : M("", !0),
    r.labelPosition === "none" ? (C(), S("fieldset", uu, [
      (C(!0), S(de, null, pe(r.getOptionsForFilter(r.filter.key), (T, B) => (C(), S("div", {
        class: $("form-check" + (c.inline ? " form-check-inline" : "")),
        key: B
      }, [
        we(w, He(ze({ ...r.$props, ...r.$attrs, collapsed: r.collapsed, option: T })), null, 16),
        k("label", {
          class: "form-check-label harness-ui-checkboxgroup-label",
          id: r.filter.key + T.key + "-label",
          for: r.filter.key + T.key,
          innerHTML: T.label
        }, null, 8, cu)
      ], 2))), 128)),
      r.helperText ? (C(), S("small", {
        key: 0,
        innerHTML: r.helperText,
        class: $(
          "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + r.helperTextClass
        )
      }, null, 10, fu)) : M("", !0)
    ])) : M("", !0)
  ]);
}
const hu = /* @__PURE__ */ ke(jl, [["render", du]]);
const pu = {
  name: "HarnessVueBootstrapMultiselectListbox",
  mixins: [Ye, nt],
  props: {
    searchable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  data() {
    return {
      bloodhound: null,
      leftBox: [],
      rightBox: [],
      search: "",
      searchDisabled: !1
    };
  },
  computed: {
    leftBoxOptions() {
      return this.unselectedOptions.filter(
        (r) => this.search === "" || r.label.toLowerCase().includes(this.search.toLowerCase())
      );
    },
    rightBoxOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (r) => this.getFilter(this.filter.key).includes(r.key)
      );
    },
    unselectedOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (r) => !this.getFilter(this.filter.key).includes(r.key)
      );
    }
  },
  methods: {
    leftToRight() {
      const r = this.getFilter(this.filter.key).concat(this.leftBox);
      this.setFilterLoadData(this.filter.key, r), this.lifecycleBloodhound();
    },
    rightToLeft() {
      const r = this.getFilter(this.filter.key).filter(
        (f) => !this.rightBox.includes(f)
      );
      this.setFilterLoadData(this.filter.key, r), this.lifecycleBloodhound();
    },
    lifecycleBloodhound() {
      this.bloodhound && (this.bloodhound.clear(), this.unselectedOptions.length ? (this.searchDisabled = !1, this.bloodhound.add(this.unselectedOptions.map((r) => r.label))) : this.searchDisabled = !0);
    },
    initTypeahead() {
      window.$ = window.jQuery = Rn;
      const r = require("corejs-typeahead");
      this.bloodhound = new r({
        datumTokenizer: r.tokenizers.ngram,
        queryTokenizer: r.tokenizers.ngram,
        local: this.leftBoxOptions.map((c) => c.label)
      });
      const f = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((c, _) => (c[_] = `harness-ui-multiselect-listbox-typeahead-${_}`, c), {});
      window.$(`#harness-ui-multiselect-listbox-search-${this.filter.key}`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: f
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (c, _) => {
        this.search = _;
      }).bind("typeahead:autocomplete", (c, _) => {
        this.search = _;
      });
    }
  },
  mounted() {
    this.searchable && this.typeahead && this.initTypeahead();
  }
}, gu = { class: "harness-ui-select-label harness-ui-multiselect-listbox-top-label" }, yu = {
  key: 0,
  class: "row"
}, bu = { class: "col" }, vu = ["id", "disabled"], mu = { class: "row align-items-center" }, ku = { class: "col-5" }, wu = /* @__PURE__ */ k("label", { class: "col-form-label harness-ui-select-label harness-ui-multiselect-listbox-select-label harness-ui-select-label-vertical" }, "Options", -1), Tu = ["value", "title"], Cu = { class: "col-2" }, Su = { class: "text-center" }, _u = /* @__PURE__ */ k("i", { class: "bi bi-caret-left-fill" }, null, -1), Du = [
  _u
], Eu = /* @__PURE__ */ k("i", { class: "bi bi-caret-right-fill" }, null, -1), Nu = [
  Eu
], xu = { class: "col-5" }, Lu = /* @__PURE__ */ k("label", { class: "col-form-label harness-ui-select-label harness-ui-multiselect-listbox-select-label harness-ui-select-label-vertical" }, "Selected", -1), Ou = ["value", "title"];
function Au(r, f, c, _, A, N) {
  return C(), S("div", null, [
    k("label", gu, me(this.filter.label), 1),
    c.searchable ? (C(), S("div", yu, [
      k("div", bu, [
        Ve(k("input", {
          type: "text",
          id: `harness-ui-multiselect-listbox-search-${r.filter.key}`,
          class: "form-control harness-ui-input harness-ui-multiselect-listbox-search-input",
          disabled: A.searchDisabled,
          "onUpdate:modelValue": f[0] || (f[0] = (w) => A.search = w)
        }, null, 8, vu), [
          [Vi, A.search]
        ])
      ])
    ])) : M("", !0),
    k("div", mu, [
      k("div", ku, [
        wu,
        Ve(k("select", {
          class: "form-control harness-ui-select harness-ui-multiselect-listbox-select harness-ui-multiselect-listbox-select-left",
          multiple: "true",
          "onUpdate:modelValue": f[1] || (f[1] = (w) => A.leftBox = w)
        }, [
          (C(!0), S(de, null, pe(N.leftBoxOptions, (w) => (C(), S("option", {
            key: w.key,
            value: w.key,
            title: w.label
          }, me(w.label), 9, Tu))), 128))
        ], 512), [
          [fn, A.leftBox]
        ])
      ]),
      k("div", Cu, [
        k("div", Su, [
          k("button", {
            class: "btn btn-xs",
            onClick: f[2] || (f[2] = (...w) => N.rightToLeft && N.rightToLeft(...w))
          }, Du),
          k("button", {
            class: "btn btn-xs",
            onClick: f[3] || (f[3] = (...w) => N.leftToRight && N.leftToRight(...w))
          }, Nu)
        ])
      ]),
      k("div", xu, [
        Lu,
        Ve(k("select", {
          class: "form-control harness-ui-select harness-ui-multiselect-listbox-select harness-ui-multiselect-listbox-select-right",
          multiple: "true",
          "onUpdate:modelValue": f[4] || (f[4] = (w) => A.rightBox = w)
        }, [
          (C(!0), S(de, null, pe(N.rightBoxOptions, (w) => (C(), S("option", {
            key: w.key,
            value: w.key,
            title: w.label
          }, me(w.label), 9, Ou))), 128))
        ], 512), [
          [fn, A.rightBox]
        ])
      ])
    ])
  ]);
}
const Pu = /* @__PURE__ */ ke(pu, [["render", Au]]);
/*!
  * pinia v2.0.22
  * (c) 2022 Eduardo San Martin Morote
  * @license MIT
  */
process.env.NODE_ENV !== "production" ? Symbol("pinia") : Symbol();
var Hi;
(function(r) {
  r.direct = "direct", r.patchObject = "patch object", r.patchFunction = "patch function";
})(Hi || (Hi = {}));
const qu = typeof window < "u";
process.env.NODE_ENV !== "production" && process.env.NODE_ENV;
process.env.NODE_ENV !== "production" ? Symbol("pinia:skipHydration") : Symbol();
let $u = "Store";
function Hu(...r) {
  return process.env.NODE_ENV !== "production" && Array.isArray(r[0]) && (console.warn(`[\u{1F34D}]: Directly pass all stores to "mapStores()" without putting them in an array:
Replace
	mapStores([useAuthStore, useCartStore])
with
	mapStores(useAuthStore, useCartStore)
This will fail in production if not fixed.`), r = r[0]), r.reduce((f, c) => (f[c.$id + $u] = function() {
    return c(this.$pinia);
  }, f), {});
}
var ju = !1;
function cn(r, f, c) {
  return Array.isArray(r) ? (r.length = Math.max(r.length, f), r.splice(f, 1, c), c) : (r[f] = c, c);
}
function Fn(r, f) {
  if (Array.isArray(r)) {
    r.splice(f, 1);
    return;
  }
  delete r[f];
}
/*!
  * pinia v2.0.21
  * (c) 2022 Eduardo San Martin Morote
  * @license MIT
  */
let Rt;
const dn = (r) => Rt = r, Fu = process.env.NODE_ENV !== "production" ? Symbol("pinia") : Symbol();
function vt(r) {
  return r && typeof r == "object" && Object.prototype.toString.call(r) === "[object Object]" && typeof r.toJSON != "function";
}
var zt;
(function(r) {
  r.direct = "direct", r.patchObject = "patch object", r.patchFunction = "patch function";
})(zt || (zt = {}));
const Vt = typeof window < "u";
process.env.NODE_ENV !== "production" && process.env.NODE_ENV;
function Yi(r, f) {
  for (const c in f) {
    const _ = f[c];
    if (!(c in r))
      continue;
    const A = r[c];
    vt(A) && vt(_) && !Gt(_) && !In(_) ? r[c] = Yi(A, _) : r[c] = _;
  }
  return r;
}
const Ji = () => {
};
function ji(r, f, c, _ = Ji) {
  r.push(f);
  const A = () => {
    const N = r.indexOf(f);
    N > -1 && (r.splice(N, 1), _());
  };
  return !c && zi() && gs(A), A;
}
function Dt(r, ...f) {
  r.slice().forEach((c) => {
    c(...f);
  });
}
function Mn(r, f) {
  for (const c in f) {
    if (!f.hasOwnProperty(c))
      continue;
    const _ = f[c], A = r[c];
    vt(A) && vt(_) && r.hasOwnProperty(c) && !Gt(_) && !In(_) ? r[c] = Mn(A, _) : r[c] = _;
  }
  return r;
}
const Mu = process.env.NODE_ENV !== "production" ? Symbol("pinia:skipHydration") : Symbol();
function Bu(r) {
  return !vt(r) || !r.hasOwnProperty(Mu);
}
const { assign: Re } = Object;
function Fi(r) {
  return !!(Gt(r) && r.effect);
}
function Mi(r, f, c, _) {
  const { state: A, actions: N, getters: w } = f, T = c.state.value[r];
  let B;
  function H() {
    !T && (process.env.NODE_ENV === "production" || !_) && (c.state.value[r] = A ? A() : {});
    const Q = process.env.NODE_ENV !== "production" && _ ? qi(Wi(A ? A() : {}).value) : qi(c.state.value[r]);
    return Re(Q, N, Object.keys(w || {}).reduce((se, Z) => (process.env.NODE_ENV !== "production" && Z in Q && console.warn(`[\u{1F34D}]: A getter cannot have the same name as another state property. Rename one of them. Found with "${Z}" in store "${r}".`), se[Z] = yt(Ui(() => {
      dn(c);
      const fe = c._s.get(r);
      return w[Z].call(fe, fe);
    })), se), {}));
  }
  return B = Bn(r, H, f, c, _, !0), B.$reset = function() {
    const Q = A ? A() : {};
    this.$patch((se) => {
      Re(se, Q);
    });
  }, B;
}
function Bn(r, f, c = {}, _, A, N) {
  let w;
  const T = Re({ actions: {} }, c);
  if (process.env.NODE_ENV !== "production" && !_._e.active)
    throw new Error("Pinia destroyed");
  const B = {
    deep: !0
  };
  process.env.NODE_ENV !== "production" && !ju && (B.onTrigger = (ee) => {
    H ? fe = ee : H == !1 && !J._hotUpdating && (Array.isArray(fe) ? fe.push(ee) : console.error("\u{1F34D} debuggerEvents should be an array. This is most likely an internal Pinia bug."));
  });
  let H, Q, se = yt([]), Z = yt([]), fe;
  const te = _.state.value[r];
  !N && !te && (process.env.NODE_ENV === "production" || !A) && (_.state.value[r] = {});
  const G = Wi({});
  let Oe;
  function K(ee) {
    let R;
    H = Q = !1, process.env.NODE_ENV !== "production" && (fe = []), typeof ee == "function" ? (ee(_.state.value[r]), R = {
      type: zt.patchFunction,
      storeId: r,
      events: fe
    }) : (Mn(_.state.value[r], ee), R = {
      type: zt.patchObject,
      payload: ee,
      storeId: r,
      events: fe
    });
    const ie = Oe = Symbol();
    Pi().then(() => {
      Oe === ie && (H = !0);
    }), Q = !0, Dt(se, R, _.state.value[r]);
  }
  const st = process.env.NODE_ENV !== "production" ? () => {
    throw new Error(`\u{1F34D}: Store "${r}" is built using the setup syntax and does not implement $reset().`);
  } : Ji;
  function We() {
    w.stop(), se = [], Z = [], _._s.delete(r);
  }
  function Je(ee, R) {
    return function() {
      dn(_);
      const ie = Array.from(arguments), le = [], Se = [];
      function Nt(_e) {
        le.push(_e);
      }
      function Qt(_e) {
        Se.push(_e);
      }
      Dt(Z, {
        args: ie,
        name: ee,
        store: J,
        after: Nt,
        onError: Qt
      });
      let ot;
      try {
        ot = R.apply(this && this.$id === r ? this : J, ie);
      } catch (_e) {
        throw Dt(Se, _e), _e;
      }
      return ot instanceof Promise ? ot.then((_e) => (Dt(le, _e), _e)).catch((_e) => (Dt(Se, _e), Promise.reject(_e))) : (Dt(le, ot), ot);
    };
  }
  const at = /* @__PURE__ */ yt({
    actions: {},
    getters: {},
    state: [],
    hotState: G
  }), s = {
    _p: _,
    $id: r,
    $onAction: ji.bind(null, Z),
    $patch: K,
    $reset: st,
    $subscribe(ee, R = {}) {
      const ie = ji(se, ee, R.detached, () => le()), le = w.run(() => fs(() => _.state.value[r], (Se) => {
        (R.flush === "sync" ? Q : H) && ee({
          storeId: r,
          type: zt.direct,
          events: fe
        }, Se);
      }, Re({}, B, R)));
      return ie;
    },
    $dispose: We
  }, J = ds(Re(
    process.env.NODE_ENV !== "production" && Vt ? {
      _customProperties: yt(/* @__PURE__ */ new Set()),
      _hmrPayload: at
    } : {},
    s
  ));
  _._s.set(r, J);
  const Te = _._e.run(() => (w = hs(), w.run(() => f())));
  for (const ee in Te) {
    const R = Te[ee];
    if (Gt(R) && !Fi(R) || In(R))
      process.env.NODE_ENV !== "production" && A ? cn(G.value, ee, jn(Te, ee)) : N || (te && Bu(R) && (Gt(R) ? R.value = te[ee] : Mn(R, te[ee])), _.state.value[r][ee] = R), process.env.NODE_ENV !== "production" && at.state.push(ee);
    else if (typeof R == "function") {
      const ie = process.env.NODE_ENV !== "production" && A ? R : Je(ee, R);
      Te[ee] = ie, process.env.NODE_ENV !== "production" && (at.actions[ee] = R), T.actions[ee] = R;
    } else
      process.env.NODE_ENV !== "production" && Fi(R) && (at.getters[ee] = N ? c.getters[ee] : R, Vt && (Te._getters || (Te._getters = yt([]))).push(ee));
  }
  if (Re(J, Te), Re(ps(J), Te), Object.defineProperty(J, "$state", {
    get: () => process.env.NODE_ENV !== "production" && A ? G.value : _.state.value[r],
    set: (ee) => {
      if (process.env.NODE_ENV !== "production" && A)
        throw new Error("cannot set hotState");
      K((R) => {
        Re(R, ee);
      });
    }
  }), process.env.NODE_ENV !== "production") {
    J._hotUpdate = yt((R) => {
      J._hotUpdating = !0, R._hmrPayload.state.forEach((ie) => {
        if (ie in J.$state) {
          const le = R.$state[ie], Se = J.$state[ie];
          typeof le == "object" && vt(le) && vt(Se) ? Yi(le, Se) : R.$state[ie] = Se;
        }
        cn(J, ie, jn(R.$state, ie));
      }), Object.keys(J.$state).forEach((ie) => {
        ie in R.$state || Fn(J, ie);
      }), H = !1, Q = !1, _.state.value[r] = jn(R._hmrPayload, "hotState"), Q = !0, Pi().then(() => {
        H = !0;
      });
      for (const ie in R._hmrPayload.actions) {
        const le = R[ie];
        cn(J, ie, Je(ie, le));
      }
      for (const ie in R._hmrPayload.getters) {
        const le = R._hmrPayload.getters[ie], Se = N ? Ui(() => (dn(_), le.call(J, J))) : le;
        cn(J, ie, Se);
      }
      Object.keys(J._hmrPayload.getters).forEach((ie) => {
        ie in R._hmrPayload.getters || Fn(J, ie);
      }), Object.keys(J._hmrPayload.actions).forEach((ie) => {
        ie in R._hmrPayload.actions || Fn(J, ie);
      }), J._hmrPayload = R._hmrPayload, J._getters = R._getters, J._hotUpdating = !1;
    });
    const ee = {
      writable: !0,
      configurable: !0,
      enumerable: !1
    };
    Vt && ["_p", "_hmrPayload", "_getters", "_customProperties"].forEach((R) => {
      Object.defineProperty(J, R, {
        value: J[R],
        ...ee
      });
    });
  }
  return _._p.forEach((ee) => {
    if (process.env.NODE_ENV !== "production" && Vt) {
      const R = w.run(() => ee({
        store: J,
        app: _._a,
        pinia: _,
        options: T
      }));
      Object.keys(R || {}).forEach((ie) => J._customProperties.add(ie)), Re(J, R);
    } else
      Re(J, w.run(() => ee({
        store: J,
        app: _._a,
        pinia: _,
        options: T
      })));
  }), process.env.NODE_ENV !== "production" && J.$state && typeof J.$state == "object" && typeof J.$state.constructor == "function" && !J.$state.constructor.toString().includes("[native code]") && console.warn(`[\u{1F34D}]: The "state" must be a plain object. It cannot be
	state: () => new MyClass()
Found in store "${J.$id}".`), te && N && c.hydrate && c.hydrate(J.$state, te), H = !0, Q = !0, J;
}
function Iu(r, f, c) {
  let _, A;
  const N = typeof f == "function";
  typeof r == "string" ? (_ = r, A = N ? c : f) : (A = r, _ = r.id);
  function w(T, B) {
    const H = zi();
    if (T = (process.env.NODE_ENV === "test" && Rt && Rt._testing ? null : T) || H && cs(Fu), T && dn(T), process.env.NODE_ENV !== "production" && !Rt)
      throw new Error(`[\u{1F34D}]: getActivePinia was called with no active Pinia. Did you forget to install pinia?
	const pinia = createPinia()
	app.use(pinia)
This will fail in production.`);
    T = Rt, T._s.has(_) || (N ? Bn(_, f, A, T) : Mi(_, A, T), process.env.NODE_ENV !== "production" && (w._pinia = T));
    const Q = T._s.get(_);
    if (process.env.NODE_ENV !== "production" && B) {
      const se = "__hot:" + _, Z = N ? Bn(se, f, A, T, !0) : Mi(se, Re({}, A), T, !0);
      B._hotUpdate(Z), delete T.state.value[se], T._s.delete(se);
    }
    if (process.env.NODE_ENV !== "production" && Vt && H && H.proxy && !B) {
      const se = H.proxy, Z = "_pStores" in se ? se._pStores : se._pStores = {};
      Z[_] = Q;
    }
    return Q;
  }
  return w.$id = _, w;
}
const Ru = Iu("harnessStore", {
  state: () => ({ pages: [], pageObjects: {}, pageStores: {} }),
  getters: {
    getPages() {
      return this.pages;
    },
    getPageObjects() {
      return this.pageObjects;
    },
    getPageStores() {
      return this.pageStores;
    }
  },
  actions: {
    addStore(r, f, c) {
      this.pages.push(r), this.pageObjects[r] = f, this.pageStores[r] = c;
    }
  }
});
var It = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Vu = { exports: {} };
(function(r, f) {
  (function(c, _) {
    _();
  })(It, function() {
    function c(H, Q) {
      return typeof Q > "u" ? Q = { autoBom: !1 } : typeof Q != "object" && (console.warn("Deprecated: Expected third argument to be a object"), Q = { autoBom: !Q }), Q.autoBom && /^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(H.type) ? new Blob(["\uFEFF", H], { type: H.type }) : H;
    }
    function _(H, Q, se) {
      var Z = new XMLHttpRequest();
      Z.open("GET", H), Z.responseType = "blob", Z.onload = function() {
        B(Z.response, Q, se);
      }, Z.onerror = function() {
        console.error("could not download file");
      }, Z.send();
    }
    function A(H) {
      var Q = new XMLHttpRequest();
      Q.open("HEAD", H, !1);
      try {
        Q.send();
      } catch {
      }
      return 200 <= Q.status && 299 >= Q.status;
    }
    function N(H) {
      try {
        H.dispatchEvent(new MouseEvent("click"));
      } catch {
        var Q = document.createEvent("MouseEvents");
        Q.initMouseEvent("click", !0, !0, window, 0, 0, 0, 80, 20, !1, !1, !1, !1, 0, null), H.dispatchEvent(Q);
      }
    }
    var w = typeof window == "object" && window.window === window ? window : typeof self == "object" && self.self === self ? self : typeof It == "object" && It.global === It ? It : void 0, T = w.navigator && /Macintosh/.test(navigator.userAgent) && /AppleWebKit/.test(navigator.userAgent) && !/Safari/.test(navigator.userAgent), B = w.saveAs || (typeof window != "object" || window !== w ? function() {
    } : "download" in HTMLAnchorElement.prototype && !T ? function(H, Q, se) {
      var Z = w.URL || w.webkitURL, fe = document.createElement("a");
      Q = Q || H.name || "download", fe.download = Q, fe.rel = "noopener", typeof H == "string" ? (fe.href = H, fe.origin === location.origin ? N(fe) : A(fe.href) ? _(H, Q, se) : N(fe, fe.target = "_blank")) : (fe.href = Z.createObjectURL(H), setTimeout(function() {
        Z.revokeObjectURL(fe.href);
      }, 4e4), setTimeout(function() {
        N(fe);
      }, 0));
    } : "msSaveOrOpenBlob" in navigator ? function(H, Q, se) {
      if (Q = Q || H.name || "download", typeof H != "string")
        navigator.msSaveOrOpenBlob(c(H, se), Q);
      else if (A(H))
        _(H, Q, se);
      else {
        var Z = document.createElement("a");
        Z.href = H, Z.target = "_blank", setTimeout(function() {
          N(Z);
        });
      }
    } : function(H, Q, se, Z) {
      if (Z = Z || open("", "_blank"), Z && (Z.document.title = Z.document.body.innerText = "downloading..."), typeof H == "string")
        return _(H, Q, se);
      var fe = H.type === "application/octet-stream", te = /constructor/i.test(w.HTMLElement) || w.safari, G = /CriOS\/[\d]+/.test(navigator.userAgent);
      if ((G || fe && te || T) && typeof FileReader < "u") {
        var Oe = new FileReader();
        Oe.onloadend = function() {
          var We = Oe.result;
          We = G ? We : We.replace(/^data:[^;]*;/, "data:attachment/file;"), Z ? Z.location.href = We : location = We, Z = null;
        }, Oe.readAsDataURL(H);
      } else {
        var K = w.URL || w.webkitURL, st = K.createObjectURL(H);
        Z ? Z.location = st : location.href = st, Z = null, setTimeout(function() {
          K.revokeObjectURL(st);
        }, 4e4);
      }
    });
    w.saveAs = B.saveAs = B, r.exports = B;
  });
})(Vu);
const zu = {
  name: "navbar",
  props: {
    title: {
      type: String,
      required: !1,
      default: "dataVue"
    },
    classes: {
      type: String,
      required: !1,
      default: "navbar-light bg-light"
    }
  },
  computed: {
    ...Hu(Ru)
  }
}, Wu = /* @__PURE__ */ k("button", {
  class: "navbar-toggler",
  type: "button",
  "data-toggle": "collapse",
  "data-target": "#navbarSupportedContent",
  "aria-controls": "navbarSupportedContent",
  "aria-expanded": "false",
  "aria-label": "Toggle navigation"
}, [
  /* @__PURE__ */ k("span", { class: "navbar-toggler-icon" })
], -1), Uu = {
  class: "collapse navbar-collapse",
  id: "navbarSupportedContent"
}, Gu = { class: "navbar-nav mr-auto" };
function Qu(r, f, c, _, A, N) {
  const w = Xe("router-link");
  return C(), S("nav", {
    class: $("navbar navbar-expand-lg " + c.classes)
  }, [
    we(w, {
      to: "/",
      class: "navbar-brand"
    }, {
      default: $i(() => [
        Ut(me(c.title), 1)
      ]),
      _: 1
    }),
    Wu,
    k("div", Uu, [
      k("ul", Gu, [
        Qe(r.$slots, "beforepages"),
        (C(!0), S(de, null, pe(r.harnessStore.pages, (T) => (C(), S("li", {
          class: "nav-item",
          key: T
        }, [
          we(w, {
            to: T,
            class: "nav-link"
          }, {
            default: $i(() => [
              Ut(me(T), 1)
            ]),
            _: 2
          }, 1032, ["to"])
        ]))), 128)),
        Qe(r.$slots, "afterpages")
      ])
    ])
  ], 2);
}
const Xu = /* @__PURE__ */ ke(zu, [["render", Qu]]), Bi = {
  navbar: Xu,
  FilterGrid: Ts,
  ChartGrid: _s,
  GridWithFilters: qs,
  DataTable508: Is,
  ChartWithTable: va,
  InteractiveTable: Ja,
  FilterPicker: po,
  FilterAccordion: $o,
  HarnessVueBootstrapInput: nl,
  HarnessVueBootstrapSelect: yl,
  HarnessVueBootstrapRadioGroup: Al,
  HarnessVueBootstrapCheckboxGroup: hu,
  HarnessVueBootstrapMultiselectListbox: Pu
};
typeof window < "u" && (window.$ = window.jQuery = Rn);
const Ju = {
  install(r, f) {
    Object.keys(Bi).forEach((c) => {
      r.component(c, Bi[c]);
    });
  }
};
export {
  Bi as components,
  Ju as harnessVueBootstrap
};
